import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _omit from "ramda/src/omit";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["message", "type", "closable", "onClose"];
import React, { forwardRef } from 'react';
import styled from 'styled-components';
import { MdClose } from 'react-icons/md';
import { space } from 'styled-system';
import { rgba } from 'polished';
import { Box, Flex } from '../Layout';
import { Icon } from '../Icon';
var StyledAlert = styled.div.withConfig({
  componentId: "sc-1sk3rcv-0"
})(["display:flex;align-items:center;margin-bottom:", ";padding:", " ", ";border:", ";border-radius:", ";border-color:", ";background-color:", ";font-size:", ";transform-origin:top;", ";"], function (p) {
  return p.theme.space[3];
}, function (p) {
  return p.theme.space[2];
}, function (p) {
  return p.theme.space[3];
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors[p.type];
}, function (p) {
  return rgba(p.theme.colors[p.type], 0.1);
}, function (p) {
  return p.theme.fontSizes.sm;
}, space);
var BaseAlert = /*#__PURE__*/forwardRef(function BaseAlert(_ref, ref) {
  var message = _ref.message,
      type = _ref.type,
      closable = _ref.closable,
      onClose = _ref.onClose,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(StyledAlert, _objectSpread({
    ref: ref,
    type: type
  }, _omit(['onClosed'], props)), /*#__PURE__*/React.createElement(Flex, {
    flex: "none"
  }, /*#__PURE__*/React.createElement(Icon, {
    size: "20",
    type: type,
    mr: "2",
    fill: type
  })), /*#__PURE__*/React.createElement(Box, {
    flex: "auto"
  }, message), closable && /*#__PURE__*/React.createElement(Flex, {
    flex: "none"
  }, /*#__PURE__*/React.createElement(Icon, {
    size: "16",
    cursor: "pointer",
    type: MdClose,
    onClick: onClose
  })));
});
export default BaseAlert;