import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["onClosed"];
import React, { useEffect, useState } from 'react';
import { animated, config, to, useSpring } from '@react-spring/web';
import { useMeasure } from '../hooks';
import BaseAlert from './BaseAlert';

var ClosableAlert = function ClosableAlert(_ref) {
  var onClosed = _ref.onClosed,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useMeasure = useMeasure(),
      _useMeasure2 = _slicedToArray(_useMeasure, 2),
      bind = _useMeasure2[0],
      boundHeight = _useMeasure2[1].height;

  var _useState = useState(true),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  var _useState3 = useState(false),
      _useState4 = _slicedToArray(_useState3, 2),
      closeDone = _useState4[0],
      setCloseDone = _useState4[1];

  var _useSpring = useSpring({
    x: visible ? 1 : 0,
    height: visible ? boundHeight : 0,
    onRest: {
      x: function x(restX) {
        if (restX.value === 0) {
          setCloseDone(true);
        }
      }
    },
    config: _objectSpread(_objectSpread({}, config.default), {}, {
      precision: 0.1
    })
  }),
      x = _useSpring.x,
      height = _useSpring.height;

  useEffect(function () {
    if (onClosed && closeDone) {
      onClosed();
    }
  }, [closeDone, onClosed]);

  if (closeDone) {
    return null;
  }

  return /*#__PURE__*/React.createElement(animated.div, {
    style: {
      transform: to(x, function (_x) {
        return "scaleY(".concat(_x, ")");
      }),
      opacity: x,
      height: height
    }
  }, /*#__PURE__*/React.createElement("div", _objectSpread({}, bind), /*#__PURE__*/React.createElement(BaseAlert, _objectSpread({
    onClose: function onClose() {
      return setVisible(false);
    }
  }, props))));
};

ClosableAlert.propTypes = {
  onClosed: _pt.func
};
export default ClosableAlert;