import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["fontSize"];
import React, { forwardRef, useEffect, useRef, useState } from 'react';
import styled from 'styled-components';
import { mergeEventProps } from '../utils';
var MirrorSpan = styled.span.withConfig({
  componentId: "sc-128a4xv-0"
})(["visibility:hidden;position:absolute;pointer-events:none;"]);
var MIN_INPUT_WIDTH = 18;
var AutoSizeInput = /*#__PURE__*/forwardRef(function AutoSizeInput(_ref, ref) {
  var _ref$fontSize = _ref.fontSize,
      fontSize = _ref$fontSize === void 0 ? 14 : _ref$fontSize,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(props.value || props.defaultValue || ''),
      _useState2 = _slicedToArray(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = useState(MIN_INPUT_WIDTH),
      _useState4 = _slicedToArray(_useState3, 2),
      width = _useState4[0],
      setWidth = _useState4[1];

  var mirrorInputRef = useRef(null);
  useEffect(function () {
    if (mirrorInputRef.current) {
      setWidth(mirrorInputRef.current.scrollWidth + MIN_INPUT_WIDTH);
    }
  }, [value]);
  useEffect(function () {
    if (props.value !== undefined && props.value !== value) {
      setValue(props.value);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [props.value]);
  var inputProps = mergeEventProps(props, {
    onChange: function onChange(e) {
      return setValue(e.target.value);
    }
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("input", _objectSpread({
    ref: ref,
    style: {
      width: width,
      boxSizing: 'content-box'
    }
  }, inputProps)), /*#__PURE__*/React.createElement(MirrorSpan, {
    ref: mirrorInputRef,
    style: {
      fontSize: fontSize
    }
  }, value === '' && props.placeholder !== undefined ? props.placeholder : value));
});
export { AutoSizeInput };