import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["visible", "zIndex"];
import React from 'react';
import styled from 'styled-components';
import { animated, config, useTransition } from '@react-spring/web';
import { Portal } from '../Portal';
import { StackingOrder } from '../constants';
var StyledBackdrop = styled.div.withConfig({
  componentId: "sc-1mnai8-0"
})(["position:fixed;z-index:-1;top:0;right:0;bottom:0;left:0;background-color:rgba(0,0,0,0.65);"]);
var AnimatedStyledBackdrop = animated(StyledBackdrop);

var Backdrop = function Backdrop(_ref) {
  var visible = _ref.visible,
      _ref$zIndex = _ref.zIndex,
      zIndex = _ref$zIndex === void 0 ? StackingOrder.OVERLAY : _ref$zIndex,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var transition = useTransition(visible, {
    from: {
      opacity: 0
    },
    enter: {
      opacity: 1
    },
    leave: {
      opacity: 0,
      pointerEvents: 'none'
    },
    config: config.stiff
  });
  return transition(function (style, item) {
    return item && /*#__PURE__*/React.createElement(Portal, {
      defaultOrder: zIndex
    }, /*#__PURE__*/React.createElement(AnimatedStyledBackdrop, _objectSpread({
      style: style
    }, otherProps)));
  });
};

Backdrop.propTypes = {
  visible: _pt.bool.isRequired,
  zIndex: _pt.number
};
export { Backdrop };