import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["count", "overflowCount", "showZero", "wrapperProps", "children", "color", "bg", "borderColor"];
import React from 'react';
import { to, useTransition } from '@react-spring/web';
import { AnimatedStyledBadge, StyledBadgeWrapper } from './styles';

var Badge = function Badge(_ref) {
  var count = _ref.count,
      _ref$overflowCount = _ref.overflowCount,
      overflowCount = _ref$overflowCount === void 0 ? 99 : _ref$overflowCount,
      _ref$showZero = _ref.showZero,
      showZero = _ref$showZero === void 0 ? false : _ref$showZero,
      wrapperProps = _ref.wrapperProps,
      children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'light' : _ref$color,
      _ref$bg = _ref.bg,
      bg = _ref$bg === void 0 ? 'danger' : _ref$bg,
      _ref$borderColor = _ref.borderColor,
      borderColor = _ref$borderColor === void 0 ? 'light' : _ref$borderColor,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var displayCount = count && count > overflowCount ? "".concat(overflowCount, "+") : count;
  var transition = useTransition(showZero || count !== 0, {
    from: {
      opacity: 0,
      transform: 'scale(0.6)'
    },
    enter: {
      opacity: 1,
      transform: 'scale(1)'
    },
    leave: {
      opacity: 0,
      transform: 'scale(0.6)'
    }
  });
  var badge = transition(function (style, item) {
    return item && /*#__PURE__*/React.createElement(AnimatedStyledBadge, _objectSpread(_objectSpread({
      color: color,
      bg: bg,
      borderColor: borderColor
    }, otherProps), {}, {
      style: {
        opacity: style.opacity,
        transformOrigin: children ? 'right' : 'center',
        transform: to(style.transform, function (x) {
          return children ? "".concat(x, " translateX(50%)") : x;
        })
      }
    }), displayCount);
  });

  if (!children) {
    return badge;
  }

  return /*#__PURE__*/React.createElement(StyledBadgeWrapper, _objectSpread({}, wrapperProps), children, badge);
};

Badge.propTypes = {
  count: _pt.number,
  showZero: _pt.bool,
  overflowCount: _pt.number
};
export { Badge };