import React, { ComponentPropsWithoutRef } from 'react';
import { SpaceProps, WidthProps } from 'styled-system';
import { IconType } from '../Icon';
import { ButtonSize, ButtonVariant } from './styles';
export declare type ButtonProps = ComponentPropsWithoutRef<'button'> & SpaceProps & WidthProps & {
    loading?: boolean;
    size?: ButtonSize;
    variant?: ButtonVariant;
    rounded?: boolean;
    disabled?: boolean;
    icon?: IconType;
};
declare const Button: React.ForwardRefExoticComponent<Pick<React.DetailedHTMLProps<React.ButtonHTMLAttributes<HTMLButtonElement>, HTMLButtonElement>, "key" | keyof React.ButtonHTMLAttributes<HTMLButtonElement>> & SpaceProps<Required<import("styled-system").Theme<import("styled-system").TLengthStyledSystem>>, string | number | symbol> & WidthProps<Required<import("styled-system").Theme<import("styled-system").TLengthStyledSystem>>, import("csstype").Property.Width<import("styled-system").TLengthStyledSystem>> & {
    loading?: boolean | undefined;
    size?: ButtonSize | undefined;
    variant?: ButtonVariant | undefined;
    rounded?: boolean | undefined;
    disabled?: boolean | undefined;
    icon?: IconType | undefined;
} & React.RefAttributes<HTMLButtonElement>>;
export { Button };
