import React from 'react';
import { Icon } from '../Icon';
var iconSizes = {
  sm: 16,
  md: 24,
  lg: 24
};
var iconMargins = {
  sm: '2px',
  md: '4px',
  lg: '8px'
};

var ButtonIcon = function ButtonIcon(_ref) {
  var loading = _ref.loading,
      icon = _ref.icon,
      size = _ref.size,
      buttonContent = _ref.buttonContent;

  if (loading || !icon) {
    return null;
  }

  return /*#__PURE__*/React.createElement(Icon, {
    type: icon,
    size: iconSizes[size],
    mr: buttonContent ? iconMargins[size] : 0,
    style: {
      pointerEvents: 'none'
    }
  });
};

export default ButtonIcon;