import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "disabled", "checked", "defaultChecked", "onChange", "value", "id", "onMouseEnter", "onMouseLeave"];
import React, { forwardRef, useContext } from 'react';
import { Box } from '../Layout';
import { useFormField } from '../FormField';
import { CheckboxContext } from './CheckboxContext';
import { CheckboxInner, CheckboxLabel, CheckboxWrapper, StyledCheckbox } from './styles';
var Checkbox = /*#__PURE__*/forwardRef(function Checkbox(_ref, ref) {
  var children = _ref.children,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      checked = _ref.checked,
      defaultChecked = _ref.defaultChecked,
      _onChange = _ref.onChange,
      value = _ref.value,
      id = _ref.id,
      onMouseEnter = _ref.onMouseEnter,
      onMouseLeave = _ref.onMouseLeave,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useContext = useContext(CheckboxContext),
      handleChange = _useContext.handleChange,
      isChecked = _useContext.isChecked,
      direction = _useContext.direction;

  var _useFormField = useFormField({
    id: id,
    value: checked,
    defaultValue: defaultChecked
  }),
      _useFormField2 = _slicedToArray(_useFormField, 3),
      labelId = _useFormField2[1],
      setValue = _useFormField2[2];

  var inGroup = Boolean(handleChange);
  var boxChecked = isChecked && value ? isChecked(value) : checked;
  return /*#__PURE__*/React.createElement(CheckboxLabel, {
    ref: ref,
    disabled: disabled,
    direction: direction,
    onMouseEnter: onMouseEnter,
    onMouseLeave: onMouseLeave
  }, /*#__PURE__*/React.createElement(CheckboxWrapper, null, /*#__PURE__*/React.createElement(StyledCheckbox, _objectSpread({
    id: inGroup ? undefined : labelId,
    disabled: disabled,
    checked: boxChecked,
    defaultChecked: defaultChecked,
    onChange: function onChange(event) {
      if (_onChange) {
        _onChange(event);
      }

      if (handleChange && value) {
        handleChange(event, value);
      }

      if (!inGroup) {
        setValue(event.target.checked);
      }
    }
  }, props)), /*#__PURE__*/React.createElement(CheckboxInner, null)), /*#__PURE__*/React.createElement(Box, {
    px: "2"
  }, children));
});
export { Checkbox };