import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["value", "defaultValue", "onChange", "options", "direction", "children"];
import React, { forwardRef, useCallback, useMemo } from 'react';
import { useFormField } from '../FormField';
import { useOwnValue } from '../hooks';
import { Checkbox } from './Checkbox';
import { CheckboxContext } from './CheckboxContext';
import { CheckboxGroupFlex } from './styles';
var CheckboxGroup = /*#__PURE__*/forwardRef(function CheckboxGroup(_ref, ref) {
  var value = _ref.value,
      defaultValue = _ref.defaultValue,
      onChange = _ref.onChange,
      _ref$options = _ref.options,
      options = _ref$options === void 0 ? null : _ref$options,
      _ref$direction = _ref.direction,
      direction = _ref$direction === void 0 ? 'horizontal' : _ref$direction,
      children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useOwnValue = useOwnValue({
    value: value,
    defaultValue: defaultValue,
    onChange: onChange
  }, {
    fallbackValue: []
  }),
      _useOwnValue2 = _slicedToArray(_useOwnValue, 2),
      ownValue = _useOwnValue2[0],
      setOwnValue = _useOwnValue2[1];

  var _useFormField = useFormField({
    value: ownValue
  }),
      _useFormField2 = _slicedToArray(_useFormField, 3),
      setValue = _useFormField2[2];

  var handleChange = useCallback(function (event, newValue) {
    var checked = event.target.checked;
    var nextValue = ownValue;

    if (ownValue.includes(newValue) && !checked) {
      nextValue = ownValue.filter(function (val) {
        return val !== newValue;
      });
    }

    if (!ownValue.includes(newValue) && checked) {
      nextValue = [].concat(_toConsumableArray(ownValue), [newValue]);
    }

    setOwnValue(nextValue);
    setValue(nextValue);
  }, [ownValue, setOwnValue, setValue]);
  var isChecked = useCallback(function (_value) {
    return ownValue.includes(_value);
  }, [ownValue]);
  var child = useMemo(function () {
    return options ? options.map(function (_ref2) {
      var label = _ref2.label,
          optionValue = _ref2.value,
          _ref2$disabled = _ref2.disabled,
          disabled = _ref2$disabled === void 0 ? false : _ref2$disabled;
      return /*#__PURE__*/React.createElement(Checkbox, {
        key: optionValue,
        value: optionValue,
        disabled: disabled
      }, label);
    }) : children;
  }, [children, options]);
  return /*#__PURE__*/React.createElement(CheckboxContext.Provider, {
    value: {
      direction: direction,
      handleChange: handleChange,
      isChecked: isChecked
    }
  }, /*#__PURE__*/React.createElement(CheckboxGroupFlex, _objectSpread({
    ref: ref,
    direction: direction
  }, otherProps), child));
});
export { CheckboxGroup };