import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["title", "children"],
    _excluded2 = ["title", "subTitle", "children"];
import React, { forwardRef, isValidElement } from 'react';
import { Box } from '../Layout/Box';
import { Divider } from '../Divider';
import { Heading, Text } from '../Typography';
import { StyledContainer, StyledSection } from './styles';
var Section = /*#__PURE__*/forwardRef(function Section(_ref, ref) {
  var title = _ref.title,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(StyledSection, _objectSpread({
    ref: ref
  }, props), title && /*#__PURE__*/React.createElement(Heading.H5, {
    mb: "8px"
  }, title), children);
});

var isElementTable = function isElementTable(element) {
  return /*#__PURE__*/isValidElement(element) && element.type.displayName === 'Table';
};

var ContainerTitle = function ContainerTitle(_ref2) {
  var title = _ref2.title,
      subTitle = _ref2.subTitle;
  return /*#__PURE__*/React.createElement(Box, {
    pt: "24px",
    px: "32px"
  }, title && /*#__PURE__*/React.createElement(Heading.H4, {
    mb: "8px"
  }, title), subTitle && /*#__PURE__*/React.createElement(Box, {
    mb: "8px"
  }, /*#__PURE__*/React.createElement(Text, {
    color: "gray500",
    fontSize: "sm"
  }, subTitle)), /*#__PURE__*/React.createElement(Divider, {
    mb: "24px"
  }));
};

ContainerTitle.propTypes = {
  title: _pt.node,
  subTitle: _pt.node
};

var ContainerChildren = function ContainerChildren(_ref3) {
  var hasTitle = _ref3.hasTitle,
      children = _ref3.children;
  var hasChildrenTable = Array.isArray(children) ? children.some(isElementTable) : isElementTable(children);

  if (!hasChildrenTable) {
    return /*#__PURE__*/React.createElement(Box, {
      px: "32px",
      pb: "32px",
      pt: hasTitle ? '0' : '24px',
      overflow: "auto"
    }, children);
  }

  if (!Array.isArray(children)) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, children);
  }

  var childrenIndex = Array.isArray(children) && children.findIndex(function (child) {
    return isElementTable(child);
  }) || -1;
  return /*#__PURE__*/React.createElement(React.Fragment, null, children.slice(0, childrenIndex).length > 0 && /*#__PURE__*/React.createElement(Box, {
    py: "24px",
    px: "32px",
    overflow: "auto"
  }, children.slice(0, childrenIndex)), children[childrenIndex], children.slice(childrenIndex + 1).length > 0 && /*#__PURE__*/React.createElement(Box, {
    py: "24px",
    px: "32px",
    overflow: "auto"
  }, children.slice(childrenIndex + 1)));
};

ContainerChildren.propTypes = {
  hasTitle: _pt.bool.isRequired
};
var Container = /*#__PURE__*/forwardRef(function Container(_ref4, ref) {
  var title = _ref4.title,
      subTitle = _ref4.subTitle,
      children = _ref4.children,
      props = _objectWithoutProperties(_ref4, _excluded2);

  var hasTitle = Boolean(title || subTitle);
  return /*#__PURE__*/React.createElement(StyledContainer, _objectSpread({
    ref: ref
  }, props), hasTitle && /*#__PURE__*/React.createElement(ContainerTitle, {
    title: title,
    subTitle: subTitle
  }), /*#__PURE__*/React.createElement(ContainerChildren, {
    hasTitle: hasTitle
  }, children));
});
Container.Section = Section;
export { Container };