import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import React, { useContext, useMemo } from 'react';
import _format from 'date-fns/format';
import { AiOutlineCalendar, AiOutlineClose, AiOutlineDoubleLeft, AiOutlineDoubleRight, AiOutlineLeft, AiOutlineRight } from 'react-icons/ai';
import { ClickOutsideContext } from '../../Popover';
import { Icon } from '../../Icon';
import { useLocale } from '../../locale';
import dateFnsGenerateConfig from './dateFnsGenerateConfig';

var useSharedProps = function useSharedProps(props) {
  var _useContext = useContext(ClickOutsideContext),
      setHasChild = _useContext.setHasChild;

  var _useLocale = useLocale(),
      locale = _useLocale.locale;

  var prevIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(Icon, {
      size: "20",
      type: AiOutlineLeft,
      cursor: "pointer",
      fill: "gray300"
    });
  }, []);
  var nextIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(Icon, {
      size: "20",
      type: AiOutlineRight,
      cursor: "pointer",
      fill: "gray300"
    });
  }, []);
  var superPrevIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(Icon, {
      size: "20",
      type: AiOutlineDoubleLeft,
      cursor: "pointer",
      fill: "gray300"
    });
  }, []);
  var superNextIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(Icon, {
      size: "20",
      type: AiOutlineDoubleRight,
      cursor: "pointer",
      fill: "gray300"
    });
  }, []);
  var clearIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(Icon, {
      size: "16",
      type: AiOutlineClose,
      cursor: "pointer",
      fill: "gray300"
    });
  }, []);
  var suffixIcon = useMemo(function () {
    return /*#__PURE__*/React.createElement(Icon, {
      size: "20",
      type: AiOutlineCalendar,
      fill: "gray300"
    });
  }, []);
  return _objectSpread({
    prefixCls: 'tailor-ui-picker',
    inputReadOnly: true,
    prevIcon: prevIcon,
    nextIcon: nextIcon,
    superPrevIcon: superPrevIcon,
    superNextIcon: superNextIcon,
    clearIcon: clearIcon,
    suffixIcon: suffixIcon,
    generateConfig: dateFnsGenerateConfig,
    locale: locale.DatePicker,
    onOpenChange: function onOpenChange(open) {
      return setHasChild(open);
    },
    format: function format(date) {
      return _format(date, props.showTime ? 'yyyy−MM−dd HH:mm:ss' : 'yyyy−MM−dd');
    }
  }, props);
};

export default useSharedProps;