import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["type", "orientation", "dashed", "children", "color", "fontSize", "fontWeight"];
import React from 'react';
import styled, { css } from 'styled-components';
import { space, color as styledColor, typography } from 'styled-system';
var StyledInnerText = styled.span.withConfig({
  componentId: "sc-1gptxix-0"
})(["display:inline-block;padding:0 ", ";"], function (p) {
  return p.theme.space[3];
});
var StyledDivider = styled.div.withConfig({
  componentId: "sc-1gptxix-1"
})(["background-color:", ";", " ", " ", ";", ";", ";"], function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  if (p.type === 'vertical') {
    return css(["display:inline-block;position:relative;top:-0.06em;width:1px;height:0.9em;vertical-align:middle;", ""], p.withText && css(["border-top:0;&::before,&::after{border-style:dashed none none;}"]));
  }

  return css(["display:block;width:100%;min-width:100%;height:1px;margin:", " 0;clear:both;", ""], p.theme.space[3], p.withText && css(["display:table;background-color:transparent;text-align:center;white-space:nowrap;&::before,&::after{content:'';display:table-cell;position:relative;top:50%;width:50%;border-top:", ";border-color:", ";transform:translateY(50%);}", ""], p.theme.borders.base, p.theme.colors.gray300, p.orientation && css(["&::before{top:50%;width:", ";}&::after{top:50%;width:", ";}", "{display:inline-block;padding:0 10px;}"], p.orientation === 'left' ? '5%' : '95%', p.orientation === 'left' ? '95%' : '5%', StyledInnerText)));
}, function (p) {
  return p.dashed && css(["border-top:", ";border-color:", ";background-color:transparent;"], p.theme.borders.dashed, p.theme.colors.gray300);
}, space, styledColor, typography);

var Divider = function Divider(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'horizontal' : _ref$type,
      orientation = _ref.orientation,
      dashed = _ref.dashed,
      children = _ref.children,
      _ref$color = _ref.color,
      color = _ref$color === void 0 ? 'gray400' : _ref$color,
      _ref$fontSize = _ref.fontSize,
      fontSize = _ref$fontSize === void 0 ? 'sm' : _ref$fontSize,
      _ref$fontWeight = _ref.fontWeight,
      fontWeight = _ref$fontWeight === void 0 ? 500 : _ref$fontWeight,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(StyledDivider, _objectSpread({
    type: type,
    orientation: orientation,
    dashed: dashed,
    withText: !!children,
    my: type === 'horizontal' ? 2 : 0,
    mx: type === 'vertical' ? 2 : 0,
    color: color,
    fontSize: fontSize,
    fontWeight: fontWeight
  }, props), children && /*#__PURE__*/React.createElement(StyledInnerText, null, children));
};

Divider.propTypes = {
  type: _pt.oneOf(['horizontal', 'vertical']),
  orientation: _pt.oneOf(['left', 'right']),
  dashed: _pt.bool
};
export { Divider };