import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "position", "overlay"];
import React from 'react';
import { Popover } from '../Popover';
import { Position } from '../constants';
import DropdownContext from './DropdownContext';
import DropdownItem from './DropdownItem';
import DropdownSubList from './DropdownSubList';
import { Divider, List } from './styles';

var Dropdown = function Dropdown(_ref) {
  var children = _ref.children,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? Position.BOTTOM_LEFT : _ref$position,
      overlay = _ref.overlay,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(Popover, _objectSpread({
    p: "0",
    position: position,
    content: function content(close) {
      return /*#__PURE__*/React.createElement(DropdownContext.Provider, {
        value: {
          close: close
        }
      }, overlay);
    }
  }, props), children);
};

Dropdown.List = List;
Dropdown.SubList = DropdownSubList;
Dropdown.Item = DropdownItem;
Dropdown.Divider = Divider;
export { Dropdown };