import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["keep", "disabled", "icon", "onClick", "children"];
import React, { useCallback, useContext } from 'react';
import { Icon } from '../Icon';
import DropdownContext from './DropdownContext';
import { Item } from './styles';

var DropdownItem = function DropdownItem(_ref) {
  var _ref$keep = _ref.keep,
      keep = _ref$keep === void 0 ? false : _ref$keep,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      icon = _ref.icon,
      onClick = _ref.onClick,
      children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useContext = useContext(DropdownContext),
      close = _useContext.close;

  var handleClick = useCallback(function (event) {
    if (disabled) {
      return;
    }

    if (onClick) {
      onClick(event);
    }

    if (!keep) {
      close();
    }
  }, [close, disabled, keep, onClick]);
  return /*#__PURE__*/React.createElement(Item, _objectSpread({
    onClick: handleClick,
    disabled: disabled
  }, otherProps), children, icon && /*#__PURE__*/React.createElement(Icon, {
    ml: "auto",
    pl: "8px",
    fill: "gray300",
    type: icon
  }));
};

DropdownItem.propTypes = {
  disabled: _pt.bool,
  onClick: _pt.func,
  keep: _pt.bool
};
export default DropdownItem;