import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _pt from "prop-types";
var _excluded = ["disabled", "title", "children"];
import React, { useState } from 'react';
import { MdKeyboardArrowRight } from 'react-icons/md';
import { Box } from '../Layout';
import { Icon } from '../Icon';
import { Position } from '../constants';
import { StyledPopover } from '../Popover/styles';
import { Tooltip } from '../Tooltip';
import { Item, List } from './styles';

var DropdownSubListWrapper = function DropdownSubListWrapper(props) {
  return /*#__PURE__*/React.createElement(StyledPopover, _objectSpread({
    p: "0"
  }, props));
};

var DropdownSubList = function DropdownSubList(_ref) {
  var _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      title = _ref.title,
      children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      visible = _useState2[0],
      setVisible = _useState2[1];

  return /*#__PURE__*/React.createElement(Tooltip, {
    position: Position.RIGHT,
    visible: visible,
    mouseEnterDelay: 200,
    mouseLeaveDelay: 300,
    Wrapper: DropdownSubListWrapper,
    content: /*#__PURE__*/React.createElement(List, {
      onClick: function onClick() {
        return setVisible(false);
      }
    }, children),
    onVisibleChange: function onVisibleChange(newVisible) {
      if (!disabled) {
        setVisible(newVisible);
      }
    }
  }, /*#__PURE__*/React.createElement(Item, _objectSpread({
    disabled: disabled
  }, otherProps), title, /*#__PURE__*/React.createElement(Box, {
    display: "inline-flex",
    ml: "auto",
    pl: "2"
  }, /*#__PURE__*/React.createElement(Icon, {
    cursor: "pointer",
    type: MdKeyboardArrowRight
  }))));
};

DropdownSubList.propTypes = {
  title: _pt.string.isRequired,
  disabled: _pt.bool
};
export default DropdownSubList;