import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["children", "tooltipProps"];
import React, { useRef } from 'react';
import styled from 'styled-components';
import { Box } from '../Layout';
import { Position } from '../constants';
import { Tooltip } from '../Tooltip';
var EllipsisText = styled.div.withConfig({
  componentId: "sc-15l93jq-0"
})(["width:100%;overflow-x:hidden;text-overflow:ellipsis;white-space:nowrap;"]);

var Ellipsis = function Ellipsis(_ref) {
  var children = _ref.children,
      _ref$tooltipProps = _ref.tooltipProps,
      tooltipProps = _ref$tooltipProps === void 0 ? {} : _ref$tooltipProps,
      props = _objectWithoutProperties(_ref, _excluded);

  var ref = useRef(null);
  var isTextOverflow = ref.current ? ref.current.scrollWidth > ref.current.offsetWidth : false;
  var Content = /*#__PURE__*/React.createElement(EllipsisText, _objectSpread({
    ref: ref
  }, props), children);
  return isTextOverflow ? /*#__PURE__*/React.createElement(Tooltip, _objectSpread({
    content: /*#__PURE__*/React.createElement(Box, {
      minWidth: "200px",
      maxWidth: "280px",
      style: {
        whiteSpace: 'pre-line',
        wordBreak: 'break-word'
      }
    }, children),
    position: Position.BOTTOM,
    mouseLeaveDelay: 0
  }, tooltipProps), Content) : Content;
};

export { Ellipsis };