import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["label", "required", "validator", "validationMessage", "children"];
import React, { useCallback, useEffect, useState } from 'react';
import { animated, useTransition } from '@react-spring/web';
import { Box } from '../Layout';
import { useUID } from '../UIProvider/UIDContext';
import FormFieldContext from './FormFieldContext';
import { Label, ValidationMessage } from './styles';
import { validate } from './validate';

var FormField = function FormField(_ref) {
  var label = _ref.label,
      _ref$required = _ref.required,
      required = _ref$required === void 0 ? false : _ref$required,
      validator = _ref.validator,
      validationMessage = _ref.validationMessage,
      children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var getUID = useUID();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      mounted = _useState2[0],
      setMounted = _useState2[1];

  var _useState3 = useState(function () {
    return getUID();
  }),
      _useState4 = _slicedToArray(_useState3, 2),
      labelId = _useState4[0],
      setLabelId = _useState4[1];

  var _useState5 = useState(),
      _useState6 = _slicedToArray(_useState5, 2),
      value = _useState6[0],
      setValue = _useState6[1];

  var _useState7 = useState(function () {
    return validate({
      value: value,
      validator: validator,
      validationMessage: validationMessage
    });
  }),
      _useState8 = _slicedToArray(_useState7, 2),
      _useState8$ = _useState8[0],
      invalid = _useState8$.invalid,
      message = _useState8$.message,
      setValidationResult = _useState8[1];

  useEffect(function () {
    setMounted(true);
  }, []);
  useEffect(function () {
    setValidationResult(validate({
      validationMessage: validationMessage
    }));
  }, [validationMessage]);
  var handleValidation = useCallback(function () {
    if (value !== undefined) {
      var result = validate({
        value: value,
        validator: validator,
        validationMessage: validationMessage
      });
      setValidationResult(result);
    }
  }, [validationMessage, validator, value]);
  useEffect(function () {
    handleValidation();
  }, [handleValidation]);
  var transitions = useTransition(invalid, {
    immediate: !mounted,
    from: {
      height: 0,
      opacity: 0
    },
    enter: {
      height: 22,
      opacity: 1
    },
    leave: {
      height: 0,
      opacity: 0
    },
    config: {
      tension: 320,
      friction: 32
    }
  });
  return /*#__PURE__*/React.createElement(FormFieldContext.Provider, {
    value: {
      invalid: invalid,
      setValue: setValue,
      setLabelId: setLabelId,
      labelId: labelId
    }
  }, /*#__PURE__*/React.createElement(Box, _objectSpread({
    mb: "16px"
  }, otherProps), label && /*#__PURE__*/React.createElement(Label, {
    required: required,
    htmlFor: labelId
  }, label), children, transitions(function (style, item) {
    return item && /*#__PURE__*/React.createElement(animated.div, {
      style: style
    }, /*#__PURE__*/React.createElement(ValidationMessage, null, message));
  })));
};

FormField.propTypes = {
  label: _pt.node,
  required: _pt.bool,
  validationMessage: _pt.node
};
export { FormField };