import React, { useContext, useEffect } from 'react';
import { tuplify } from '../utils';
import FormFieldContext from './FormFieldContext';

var useFormField = function useFormField(_ref) {
  var id = _ref.id,
      value = _ref.value,
      defaultValue = _ref.defaultValue;

  var _useContext = useContext(FormFieldContext),
      invalid = _useContext.invalid,
      setValue = _useContext.setValue,
      setLabelId = _useContext.setLabelId,
      labelId = _useContext.labelId;

  useEffect(function () {
    if (id) {
      setLabelId(id);
    }
  }, [id, setLabelId]);
  useEffect(function () {
    var fieldValue = value || defaultValue;

    if (fieldValue) {
      setValue(fieldValue);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, []);
  return tuplify(invalid, id || labelId, setValue);
};

export { useFormField };