import React from 'react'; // eslint-disable-next-line import/no-extraneous-dependencies

// eslint-disable-next-line no-underscore-dangle
var isSchema = function isSchema(obj) {
  return obj && obj.__isYupSchema__;
};

export var validate = function validate(_ref) {
  var value = _ref.value,
      validator = _ref.validator,
      validationMessage = _ref.validationMessage;

  if (validationMessage) {
    return {
      invalid: true,
      message: validationMessage
    };
  }

  if (!validator) {
    return {
      invalid: false,
      message: null
    };
  }

  if (isSchema(validator)) {
    try {
      validator.validateSync(value);
      return {
        invalid: false,
        message: null
      };
    } catch (err) {
      return {
        invalid: true,
        message: err.name === 'ValidationError' ? err.errors[0] : null
      };
    }
  }

  if (validator instanceof Function) {
    var message = validator(value);
    return {
      invalid: Boolean(message),
      message: message
    };
  }

  if (validator instanceof Object && !Array.isArray(validator)) {
    var invalid = validator.rule(value);
    return {
      invalid: invalid,
      message: invalid ? validator.message : null
    };
  }

  if (Array.isArray(validator)) {
    var returnMessage = null;
    var _invalid = false;
    validator.some(function (_ref2) {
      var rule = _ref2.rule,
          message = _ref2.message;

      if (rule(value)) {
        returnMessage = message;
        _invalid = true;
        return true;
      }

      return false;
    });
    return {
      invalid: _invalid,
      message: returnMessage
    };
  }

  return {
    invalid: false,
    message: null
  };
};