import React, { ComponentPropsWithoutRef } from 'react';
import { IconType as ReactIconsIconType } from 'react-icons/lib/esm';
import { SpaceProps } from 'styled-system';
import { BuiltInIconKeys } from './icons';
declare type Size = string | number;
export declare type IconWrapperProps = SpaceProps & {
    cursor?: string;
    pointerEvents?: string;
    size: Size;
    fill?: string;
};
export declare const IconWrapper: import("styled-components").StyledComponent<"i", any, SpaceProps<Required<import("styled-system").Theme<import("styled-system").TLengthStyledSystem>>, string | number | symbol> & {
    cursor?: string | undefined;
    pointerEvents?: string | undefined;
    size: Size;
    fill?: string | undefined;
}, never>;
export declare type IconType = BuiltInIconKeys | ReactIconsIconType;
export declare type IconProps = ComponentPropsWithoutRef<'div'> & SpaceProps & {
    cursor?: string;
    pointerEvents?: string;
    size?: Size;
    fill?: string;
    alt?: string;
    type: IconType;
};
declare const Icon: React.ForwardRefExoticComponent<Pick<React.DetailedHTMLProps<React.HTMLAttributes<HTMLDivElement>, HTMLDivElement>, "key" | keyof React.HTMLAttributes<HTMLDivElement>> & SpaceProps<Required<import("styled-system").Theme<import("styled-system").TLengthStyledSystem>>, string | number | symbol> & {
    cursor?: string | undefined;
    pointerEvents?: string | undefined;
    size?: Size | undefined;
    fill?: string | undefined;
    alt?: string | undefined;
    type: IconType;
} & React.RefAttributes<HTMLElement>>;
export { Icon };
