import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["type", "cursor", "size"];
import React, { forwardRef } from 'react';
import styled, { css } from 'styled-components';
import { space, style } from 'styled-system';
import { icons } from './icons';
var styledFill = style({
  prop: 'fill',
  cssProperty: 'fill',
  key: 'colors'
});
var styledSize = css(["width:", "px;height:", "px;"], function (p) {
  return p.size;
}, function (p) {
  return p.size;
});
export var IconWrapper = styled.i.withConfig({
  componentId: "sc-10g5g0q-0"
})(["display:inline-flex;line-height:1;cursor:", ";pointer-events:", ";svg{fill:", ";vertical-align:middle;pointer-events:none;", ";}&&& svg{", ";", ";}", ";"], function (p) {
  return p.cursor;
}, function (p) {
  return p.pointerEvents;
}, function (p) {
  return p.theme.colors.gray500;
}, function (p) {
  return p.theme.transition;
}
/* sc-declaration */
, styledFill, styledSize, space);
var Icon = /*#__PURE__*/forwardRef(function Icon(_ref, ref) {
  var type = _ref.type,
      _ref$cursor = _ref.cursor,
      cursor = _ref$cursor === void 0 ? 'default' : _ref$cursor,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 24 : _ref$size,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var IconComponent;

  if (typeof type === 'string') {
    var BuiltInIcon = icons[type];

    if (!BuiltInIcon) {
      console.error('Built-in icon does not exists!');
      return null;
    }

    IconComponent = BuiltInIcon;
  } else {
    IconComponent = type;
  }

  return /*#__PURE__*/React.createElement(IconWrapper, _objectSpread({
    ref: ref,
    cursor: cursor,
    size: size
  }, otherProps), /*#__PURE__*/React.createElement(IconComponent, null));
});
export { Icon };