import React, { ComponentPropsWithoutRef, KeyboardEventHandler, ReactNode } from 'react';
import { Size } from './styles';
export declare type InputProps = Omit<ComponentPropsWithoutRef<'input'>, 'size'> & {
    autoSelect?: boolean;
    size?: Size;
    onPressEnter?: KeyboardEventHandler<HTMLInputElement>;
    prefix?: ReactNode;
    suffix?: ReactNode;
    onKeyPress?: KeyboardEventHandler<HTMLInputElement>;
    required?: boolean;
};
declare const Input: React.ForwardRefExoticComponent<Omit<Pick<React.DetailedHTMLProps<React.InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>, "key" | keyof React.InputHTMLAttributes<HTMLInputElement>>, "size"> & {
    autoSelect?: boolean | undefined;
    size?: Size | undefined;
    onPressEnter?: React.KeyboardEventHandler<HTMLInputElement> | undefined;
    prefix?: ReactNode;
    suffix?: ReactNode;
    onKeyPress?: React.KeyboardEventHandler<HTMLInputElement> | undefined;
    required?: boolean | undefined;
} & React.RefAttributes<HTMLInputElement>>;
export { Input };
