import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["id", "prefix", "suffix", "size", "onPressEnter", "onKeyPress", "autoSelect", "autoFocus"];
import React, { forwardRef, isValidElement, useCallback, useLayoutEffect, useRef } from 'react';
import { useComposedRefs } from '@reach/utils/compose-refs';
import { mergeEventProps } from '../utils';
import { useFormField } from '../FormField';
import { InputLabel, InputWrapper, StyledInput } from './styles';
var Input = /*#__PURE__*/forwardRef(function Input(_ref, forwardedRef) {
  var id = _ref.id,
      prefix = _ref.prefix,
      suffix = _ref.suffix,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'md' : _ref$size,
      onPressEnter = _ref.onPressEnter,
      onKeyPress = _ref.onKeyPress,
      autoSelect = _ref.autoSelect,
      autoFocus = _ref.autoFocus,
      props = _objectWithoutProperties(_ref, _excluded);

  var ownRef = useRef(null);
  var ref = useComposedRefs(forwardedRef, ownRef);

  var _useFormField = useFormField({
    id: id,
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useFormField2 = _slicedToArray(_useFormField, 3),
      invalid = _useFormField2[0],
      labelId = _useFormField2[1],
      setValue = _useFormField2[2];

  useLayoutEffect(function () {
    if (autoSelect) {
      var _ownRef$current;

      (_ownRef$current = ownRef.current) === null || _ownRef$current === void 0 ? void 0 : _ownRef$current.select();
    }
  }, [autoSelect]);
  var handleKeyPress = useCallback(function (event) {
    if (onKeyPress) {
      onKeyPress(event);
    }

    if (onPressEnter && event.key === 'Enter') {
      onPressEnter(event);
    }
  }, [onKeyPress, onPressEnter]);
  var input = /*#__PURE__*/React.createElement(StyledInput, _objectSpread({
    ref: ref,
    id: labelId,
    invalid: invalid,
    size: size,
    onKeyPress: handleKeyPress,
    autoFocus: autoFocus || autoSelect
  }, mergeEventProps(props, {
    onChange: function onChange(event) {
      setValue(event.currentTarget.value);
    }
  })));

  if (prefix || suffix) {
    return /*#__PURE__*/React.createElement(InputWrapper, {
      prefix: prefix,
      suffix: suffix
    }, prefix && /*#__PURE__*/React.createElement(InputLabel, null, prefix), input, suffix && ( /*#__PURE__*/isValidElement(suffix) ? suffix : /*#__PURE__*/React.createElement(InputLabel, null, suffix)));
  }

  return input;
});
export { Input };