import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _omit from "ramda/src/omit";
var _excluded = ["id"];

/* eslint react/no-multi-comp: off */
import React, { forwardRef } from 'react';
import TextareaAutosize from 'react-autosize-textarea';
import styled from 'styled-components';
import { mergeEventProps } from '../utils';
import { useFormField } from '../FormField';
import { inputStyles } from './styles';
export var StyledTextarea = styled( /*#__PURE__*/forwardRef(function StyledTextarea(props, ref) {
  return /*#__PURE__*/React.createElement(TextareaAutosize, _objectSpread({
    ref: ref
  }, _omit(['invalid'], props)));
})).withConfig({
  componentId: "vlcri7-0"
})(["word-wrap:break-word;resize:", ";", ";height:auto;transition:border 0.2s ease;"], function (_ref) {
  var resize = _ref.resize;
  return resize ? 'initial' : 'none';
}, inputStyles);
var Textarea = /*#__PURE__*/forwardRef(function Textarea(_ref2, ref) {
  var id = _ref2.id,
      props = _objectWithoutProperties(_ref2, _excluded);

  var _useFormField = useFormField({
    id: id,
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useFormField2 = _slicedToArray(_useFormField, 3),
      invalid = _useFormField2[0],
      labelId = _useFormField2[1],
      setValue = _useFormField2[2];

  return /*#__PURE__*/React.createElement(StyledTextarea, _objectSpread({
    ref: ref,
    id: labelId,
    invalid: invalid || undefined
  }, mergeEventProps(props, {
    onChange: function onChange(event) {
      setValue(event.currentTarget.value);
    }
  })));
});
export { Textarea };