import styled, { css } from 'styled-components';
import React from 'react';
import { space, textAlign, width } from 'styled-system';
import { StyledButton } from '../Button';
export var inputStyles = css(["display:block;width:100%;max-width:100%;border:", ";border-radius:", ";border-color:", ";outline:none;background-color:", ";color:", ";line-height:", ";appearance:none;&:hover{border-color:", ";}&:focus{border-color:", ";box-shadow:inset 0 0 0 2px ", ";}&:disabled,[disabled]{border-color:", ";background-color:", ";color:", ";cursor:not-allowed;}&::placeholder{color:", ";}", " ", ";", ";", ";", ";", ";"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.lineHeight;
}, function (p) {
  return p.theme.colors.primary;
}, function (p) {
  return p.theme.colors.primary;
}, function (p) {
  return p.theme.colors.surface;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return p.theme.colors.gray500;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.invalid && css(["border-color:", " !important;box-shadow:none !important;"], p.theme.colors.danger);
}, function (_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? 'md' : _ref$size,
      _ref$theme = _ref.theme,
      paddings = _ref$theme.paddings,
      heights = _ref$theme.heights,
      fontSizes = _ref$theme.fontSizes;
  var inputSizeStyles = {
    sm: css(["height:", ";padding:1px ", ";font-size:", ";"], heights.sm, paddings.xs, fontSizes.sm),
    md: css(["height:", ";padding:4px ", ";font-size:", ";"], heights.base, paddings.sm, fontSizes.base),
    lg: css(["height:", ";padding:6px ", ";font-size:", ";"], heights.lg, paddings.md, fontSizes.lg)
  };
  return inputSizeStyles[size];
}, function (p) {
  return p.theme.transition;
}
/* sc-declaration */
, width, space, textAlign);
export var StyledInput = styled.input.withConfig({
  componentId: "rdis26-0"
})(["", ";"], inputStyles);
export var InputLabel = styled.span.withConfig({
  componentId: "rdis26-1"
})(["display:inline-flex;align-items:center;justify-content:center;padding:0 ", ";border:", ";border-radius:", ";border-color:", ";background-color:", ";font-size:", ";line-height:1;"], function (p) {
  return p.theme.space[2];
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return p.theme.colors.gray200;
}, function (p) {
  return p.theme.fontSizes.base;
});
export var InputWrapper = styled.div.withConfig({
  componentId: "rdis26-2"
})(["display:flex;", ";", ";", ";", ";"], function (p) {
  return p.prefix && css(["", "{border-top-left-radius:0;border-bottom-left-radius:0;}", ":first-child{border-right:none;border-top-right-radius:0;border-bottom-right-radius:0;}"], StyledInput
  /* sc-selector */
  , InputLabel
  /* sc-selector */
  );
}, function (p) {
  return p.suffix && css(["", "{border-top-right-radius:0;border-bottom-right-radius:0;}", ":last-child{border-left:none;border-top-left-radius:0;border-bottom-left-radius:0;}", "{flex:none;border-top-left-radius:0;border-bottom-left-radius:0;}"], StyledInput
  /* sc-selector */
  , InputLabel
  /* sc-selector */
  , StyledButton
  /* sc-selector */
  );
}, space, width);