export var applyHighlights = function applyHighlights(_ref) {
  var suggestions = _ref.suggestions,
      value = _ref.value,
      highlightInvalid = _ref.highlightInvalid;
  var transformedValue = value.replace(/\n$/g, '\n\n');
  var mentionRegexp = /\{{2}[^{}\n]+\}{2}/g;
  var allSuggestions = suggestions.map(function (suggestion) {
    return "{{".concat(suggestion, "}}");
  });

  var replacer = function replacer(match) {
    var valid = true;

    if (highlightInvalid) {
      valid = allSuggestions.includes(match);
    }

    var formatText = function formatText(text, index) {
      var classNames = ['mention-highlight', !valid && 'invalid', index === 0 && 'start', index === match.length - 1 && 'end'].filter(Boolean).join(' ');
      var content = text === ' ' ? '&nbsp;' : text;
      return "<span class=\"".concat(classNames, "\">").concat(content, "</span>");
    };

    return match.split('').map(formatText).join('');
  };

  return transformedValue.replace(mentionRegexp, replacer);
};