import styled from 'styled-components';
import { animated } from '@react-spring/web';
import { Textarea as BaseTextarea } from '../Input/Textarea';
import { inputStyles } from '../Input/styles';
export var Textarea = styled(BaseTextarea).withConfig({
  componentId: "sc-1e95lj4-0"
})(["position:absolute;top:0;background-color:transparent;color:transparent;caret-color:", ";"], function (p) {
  return p.theme.colors.gray700;
});
export var MentionWrapper = styled.div.withConfig({
  componentId: "sc-1e95lj4-1"
})(["position:relative;.mention-highlight{display:inline-flex;color:", ";line-height:1.3;text-decoration:none;&.invalid{color:", ";}}"], function (p) {
  return p.disabled ? p.theme.colors.gray400 : p.theme.colors.primaryLight;
}, function (p) {
  return p.disabled ? p.theme.colors.gray400 : p.theme.colors.danger;
});
export var Highlights = styled.div.withConfig({
  componentId: "sc-1e95lj4-2"
})(["", ";overflow-y:auto;border-color:transparent;color:", ";word-break:break-word;white-space:pre-wrap;transition:none;"], inputStyles, function (p) {
  return p.theme.colors.gray700;
});
export var SuggestionList = styled(animated.div).withConfig({
  componentId: "sc-1e95lj4-3"
})(["display:flex;z-index:2;box-sizing:border-box;flex-direction:column;min-width:120px;max-height:180px;overflow-y:auto;border:", ";border-radius:", ";border-color:", ";background-color:", ";box-shadow:", ";color:", ";font-size:", ";text-align:left;white-space:nowrap;cursor:pointer;"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.shadows.base;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
});
export var SuggestionItem = styled.div.withConfig({
  componentId: "sc-1e95lj4-4"
})(["display:flex;flex:none;align-items:center;height:36px;padding:0 24px;background-color:", ";color:", ";cursor:pointer;&:hover{background-color:", ";color:", ";}"], function (p) {
  return p.active ? p.theme.colors.primaryLight : p.theme.colors.light;
}, function (p) {
  return p.active ? p.theme.colors.light : p.theme.colors.gray700;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.colors.light;
});