import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "currentSubOnly", "subKeys", "onUpdateSubKeys", "defaultSubKeys"];
import React, { useState } from 'react';
import { Flex } from '../Layout';
import Item from './Item';
import MenuContext from './MenuContext';
import SubMenu from './SubMenu';

var Menu = function Menu(_ref) {
  var children = _ref.children,
      currentSubOnly = _ref.currentSubOnly,
      subKeys = _ref.subKeys,
      onUpdateSubKeys = _ref.onUpdateSubKeys,
      defaultSubKeys = _ref.defaultSubKeys,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useState = useState(defaultSubKeys || []),
      _useState2 = _slicedToArray(_useState, 2),
      ownOpenKeys = _useState2[0],
      setOwnOpenKeys = _useState2[1];

  var openKeys = subKeys || ownOpenKeys;
  var setOpenKeys = onUpdateSubKeys || setOwnOpenKeys;
  return /*#__PURE__*/React.createElement(MenuContext.Provider, {
    value: {
      openKeys: openKeys,
      handleToggleOpenKeys: function handleToggleOpenKeys(key) {
        if (openKeys.includes(key)) {
          setOpenKeys(openKeys.filter(function (openKey) {
            return openKey !== key;
          }));
        } else {
          setOpenKeys(currentSubOnly ? [key] : [].concat(_toConsumableArray(openKeys), [key]));
        }
      }
    }
  }, /*#__PURE__*/React.createElement(Flex, _objectSpread({
    flexDirection: "column",
    justifyContent: "start",
    height: "100%",
    overflowY: "auto",
    bg: "primaryDark2"
  }, props), children));
};

Menu.defaultProps = {
  width: 240,
  currentSubOnly: false,
  defaultSubKeys: []
};
Menu.SubMenu = SubMenu;
Menu.Item = Item;
export { Menu };