import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["id", "icon", "title", "children"];
import React, { useContext } from 'react';
import styled from 'styled-components';
import { MdKeyboardArrowDown } from 'react-icons/md';
import { animated, to, useSpring } from '@react-spring/web';
import { Icon } from '../Icon';
import { useMeasure } from '../hooks';
import MenuContext from './MenuContext';
import { StyledSubMenu } from './styles';
var SubMenuWrapper = styled.div.withConfig({
  componentId: "sc-6dq8by-0"
})(["flex:none;overflow:hidden;"]);
var AnimatedSubMenuWrapper = animated(SubMenuWrapper);

var SubMenu = function SubMenu(_ref) {
  var id = _ref.id,
      icon = _ref.icon,
      title = _ref.title,
      children = _ref.children,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useMeasure = useMeasure(),
      _useMeasure2 = _slicedToArray(_useMeasure, 2),
      bind = _useMeasure2[0],
      height = _useMeasure2[1].height;

  var _useContext = useContext(MenuContext),
      openKeys = _useContext.openKeys,
      handleToggleOpenKeys = _useContext.handleToggleOpenKeys;

  var menuOn = openKeys.includes(id);

  var _useSpring = useSpring({
    rotate: menuOn ? '180' : '0'
  }),
      rotate = _useSpring.rotate;

  var style = useSpring({
    height: menuOn ? height : 0,
    opacity: menuOn ? 1 : 0
  });
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(StyledSubMenu, _objectSpread({
    active: menuOn,
    onClick: function onClick() {
      return handleToggleOpenKeys(id);
    }
  }, otherProps), icon && /*#__PURE__*/React.createElement(Icon, {
    type: icon,
    mr: "12px"
  }), title, /*#__PURE__*/React.createElement(animated.div, {
    style: {
      display: 'inline-flex',
      pointerEvents: 'none',
      marginLeft: 'auto',
      transform: to(rotate, function (r) {
        return "rotate(".concat(r, "deg)");
      })
    }
  }, /*#__PURE__*/React.createElement(Icon, {
    type: MdKeyboardArrowDown,
    size: "24"
  }))), /*#__PURE__*/React.createElement(AnimatedSubMenuWrapper, {
    style: style
  }, /*#__PURE__*/React.createElement("div", _objectSpread({}, bind), children)));
};

SubMenu.propTypes = {
  id: _pt.string.isRequired,
  initial: _pt.bool,
  title: _pt.node.isRequired,
  togglable: _pt.bool
};
export default SubMenu;