import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _pt from "prop-types";
var _excluded = ["footer", "closable", "cancelText", "confirmText", "onCancel", "onConfirm", "confirmButtonProps", "cancelButtonProps"];
import React, { isValidElement } from 'react';
import { Box, Flex } from '../Layout';
import { Button } from '../Button';
import { useLocale } from '../locale';
export var FooterButtons = function FooterButtons(_ref) {
  var closable = _ref.closable,
      cancelText = _ref.cancelText,
      confirmText = _ref.confirmText,
      onCancel = _ref.onCancel,
      onConfirm = _ref.onConfirm,
      confirmButtonProps = _ref.confirmButtonProps,
      cancelButtonProps = _ref.cancelButtonProps;

  var _useLocale = useLocale(),
      locale = _useLocale.locale;

  return /*#__PURE__*/React.createElement(Flex, {
    width: "100%"
  }, /*#__PURE__*/React.createElement(Box, {
    ml: "auto"
  }, closable && /*#__PURE__*/React.createElement(Button, _objectSpread({
    variant: "normal",
    onClick: onCancel
  }, cancelButtonProps), cancelText || locale.Modal.cancelText), /*#__PURE__*/React.createElement(Button, _objectSpread({
    ml: "3",
    variant: "primary",
    onClick: onConfirm
  }, confirmButtonProps), confirmText || locale.Modal.confirmText)));
};
FooterButtons.propTypes = {
  closable: _pt.bool,
  cancelText: _pt.node,
  confirmText: _pt.node,
  onConfirm: _pt.func,
  onCancel: _pt.func
};

var ModalFooter = function ModalFooter(_ref2) {
  var footer = _ref2.footer,
      closable = _ref2.closable,
      cancelText = _ref2.cancelText,
      confirmText = _ref2.confirmText,
      onCancel = _ref2.onCancel,
      onConfirm = _ref2.onConfirm,
      confirmButtonProps = _ref2.confirmButtonProps,
      cancelButtonProps = _ref2.cancelButtonProps,
      props = _objectWithoutProperties(_ref2, _excluded);

  return footer === null ? null : /*#__PURE__*/React.createElement(Flex, _objectSpread({
    flex: "none",
    alignItems: "center",
    px: "3",
    mx: "3",
    py: "3",
    borderTop: "base",
    borderColor: "gray300"
  }, props), /*#__PURE__*/isValidElement(footer) ? footer : /*#__PURE__*/React.createElement(FooterButtons, {
    closable: closable,
    cancelText: cancelText,
    confirmText: confirmText,
    onCancel: onCancel,
    onConfirm: onConfirm,
    confirmButtonProps: confirmButtonProps,
    cancelButtonProps: cancelButtonProps
  }));
};

ModalFooter.propTypes = {
  closable: _pt.bool,
  cancelText: _pt.node,
  confirmText: _pt.node,
  onConfirm: _pt.func,
  onCancel: _pt.func,
  footer: _pt.node
};
export default ModalFooter;