import _pt from "prop-types";
import React from 'react';
import { Flex } from '../Layout';
import { Heading } from '../Typography';
import { Icon } from '../Icon';
import CloseButton from './CloseButton';

var ModalHeader = function ModalHeader(_ref) {
  var header = _ref.header,
      title = _ref.title,
      status = _ref.status,
      onCancel = _ref.onCancel,
      closable = _ref.closable;

  if (header) {
    return /*#__PURE__*/React.createElement(Flex, {
      flex: "none",
      mb: "3",
      position: "relative"
    }, header, closable && /*#__PURE__*/React.createElement(CloseButton, {
      onCancel: onCancel
    }));
  }

  return /*#__PURE__*/React.createElement(Flex, {
    flex: "none",
    mb: "3",
    pt: "24px",
    px: "4",
    position: "relative"
  }, status && /*#__PURE__*/React.createElement(Icon, {
    type: status,
    fill: status === 'info' ? 'primary' : status,
    size: "32",
    mr: "3"
  }), /*#__PURE__*/React.createElement(Heading.H3, {
    lineHeight: "32px"
  }, title), closable && /*#__PURE__*/React.createElement(CloseButton, {
    onCancel: onCancel
  }));
};

ModalHeader.propTypes = {
  header: _pt.node,
  title: _pt.node,
  closable: _pt.bool,
  onCancel: _pt.func.isRequired
};
export default ModalHeader;