import { FC, KeyboardEventHandler, MouseEventHandler, MutableRefObject, ReactNode } from 'react';
import { StatusType } from '../types';
export declare type ModalTypes = StatusType | 'confirm';
export interface ModalOptions {
    title?: ReactNode;
    content?: ReactNode;
    confirmText?: ReactNode;
    cancelText?: ReactNode;
    onConfirm?: MouseEventHandler;
    onCancel?: MouseEventHandler | KeyboardEventHandler;
    onOpenComplete?: () => void;
    onCloseComplete?: () => void;
    closable?: boolean;
    zIndex?: number;
}
export declare type UpdateFunction = (options: Omit<ModalOptions, 'onConfirm' | 'onCancel'>) => void;
export declare type TriggerResponse = [Promise<boolean>, () => void, UpdateFunction] & {
    confirmation: Promise<boolean>;
    close: () => void;
    update: UpdateFunction;
};
export declare type Trigger = (options: ModalOptions, type: ModalTypes) => TriggerResponse;
interface HooksModalProps {
    modalTriggerRef: MutableRefObject<Trigger>;
}
declare const HooksModal: FC<HooksModalProps>;
export default HooksModal;
