import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["status", "title", "header", "onCancel", "onConfirm", "closable", "children", "footer", "cancelText", "confirmText", "confirmButtonProps", "cancelButtonProps", "zIndex", "contentStyle", "footerStyle"];
import React from 'react';
import { Flex } from '../Layout';
import AnimationModal from './AnimationModal';
import ModalFooter from './Footer';
import ModalHeader from './Header';

var Modal = function Modal(_ref) {
  var status = _ref.status,
      title = _ref.title,
      header = _ref.header,
      onCancel = _ref.onCancel,
      onConfirm = _ref.onConfirm,
      closable = _ref.closable,
      children = _ref.children,
      footer = _ref.footer,
      cancelText = _ref.cancelText,
      confirmText = _ref.confirmText,
      confirmButtonProps = _ref.confirmButtonProps,
      cancelButtonProps = _ref.cancelButtonProps,
      zIndex = _ref.zIndex,
      contentStyle = _ref.contentStyle,
      footerStyle = _ref.footerStyle,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(AnimationModal, _objectSpread({
    status: status,
    onCancel: onCancel,
    zIndex: zIndex
  }, props), /*#__PURE__*/React.createElement(ModalHeader, {
    status: status,
    title: title,
    header: header,
    onCancel: onCancel,
    closable: closable
  }), /*#__PURE__*/React.createElement(Flex, {
    flex: "auto",
    flexDirection: "column",
    overflowY: "auto",
    mx: "3",
    mb: "24px",
    px: "3",
    style: contentStyle
  }, children), /*#__PURE__*/React.createElement(ModalFooter, {
    footer: footer,
    closable: closable,
    cancelText: cancelText,
    confirmText: confirmText,
    onCancel: onCancel,
    onConfirm: onConfirm,
    confirmButtonProps: confirmButtonProps,
    cancelButtonProps: cancelButtonProps,
    style: footerStyle
  }));
};

Modal.propTypes = {
  zIndex: _pt.number
};
export { Modal };