import React, { useContext } from 'react';
import { HooksModalContext } from './HooksModalProvider';

var useModal = function useModal() {
  var triggerRef = useContext(HooksModalContext);
  return {
    confirm: function confirm(options) {
      return triggerRef.current(options, 'confirm');
    },
    info: function info(options) {
      return triggerRef.current(options, 'info');
    },
    success: function success(options) {
      return triggerRef.current(options, 'success');
    },
    warning: function warning(options) {
      return triggerRef.current(options, 'warning');
    },
    error: function error(options) {
      return triggerRef.current(options, 'error');
    }
  };
};

export { useModal };