import _pt from "prop-types";
import React from 'react';
import { MdKeyboardBackspace } from 'react-icons/md';
import { Box, Flex } from '../Layout';
import { Breadcrumb } from '../Breadcrumb';
import { Button } from '../Button';
import { Ellipsis } from '../Ellipsis';
import { Heading } from '../Typography';

var PageHeader = function PageHeader(_ref) {
  var title = _ref.title,
      onBack = _ref.onBack,
      _ref$breadcrumb = _ref.breadcrumb,
      breadcrumb = _ref$breadcrumb === void 0 ? [] : _ref$breadcrumb,
      extra = _ref.extra;
  return /*#__PURE__*/React.createElement(Flex, {
    flex: "auto",
    alignItems: "center",
    height: "56px",
    px: "32px"
  }, /*#__PURE__*/React.createElement(Flex, {
    alignItems: "center",
    flex: "auto",
    overflow: "hidden"
  }, onBack && /*#__PURE__*/React.createElement(Button, {
    icon: MdKeyboardBackspace,
    size: "sm",
    mr: "12px",
    variant: "normal",
    rounded: true,
    onClick: onBack
  }), title && /*#__PURE__*/React.createElement(Box, {
    maxWidth: "240px"
  }, /*#__PURE__*/React.createElement(Heading.H5, {
    letterSpacing: "0.2px",
    color: "gray500"
  }, /*#__PURE__*/React.createElement(Ellipsis, null, title))), title && breadcrumb.length > 0 && /*#__PURE__*/React.createElement(Box, {
    mx: "12px",
    width: "1px",
    height: "16px",
    bg: "gray300"
  }), /*#__PURE__*/React.createElement(Breadcrumb, {
    items: breadcrumb
  })), extra && /*#__PURE__*/React.createElement(Flex, {
    alignItems: "center",
    flex: "none"
  }, extra));
};

PageHeader.propTypes = {
  title: _pt.node,
  extra: _pt.node,
  onBack: _pt.func,
  breadcrumb: _pt.array
};
export { PageHeader };