import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["type", "content", "confirmText", "cancelText", "onConfirm", "onCancel"];
import React, { memo } from 'react';
import { Button } from '../Button';
import { Flex } from '../Layout';
import { Icon } from '../Icon';
import { Popover } from '../Popover';
import { useLocale } from '../locale';
var PopconfirmContent = /*#__PURE__*/memo(function PopconfirmContent(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === void 0 ? 'warning' : _ref$type,
      content = _ref.content,
      confirmText = _ref.confirmText,
      cancelText = _ref.cancelText,
      onConfirm = _ref.onConfirm,
      onCancel = _ref.onCancel,
      hideTooltip = _ref.hideTooltip;

  var _useLocale = useLocale(),
      locale = _useLocale.locale;

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Flex, {
    alignItems: "center"
  }, /*#__PURE__*/React.createElement(Icon, {
    type: type,
    fill: type,
    size: "20",
    mr: "2"
  }), content), /*#__PURE__*/React.createElement(Flex, {
    mt: "3"
  }, /*#__PURE__*/React.createElement(Button, {
    ml: "auto",
    size: "sm",
    onClick: function onClick(event) {
      hideTooltip();

      if (onCancel) {
        onCancel(event);
      }
    }
  }, cancelText || locale.Popconfirm.cancelText), /*#__PURE__*/React.createElement(Button, {
    ml: "2",
    size: "sm",
    variant: "primary",
    onClick: function onClick(event) {
      hideTooltip();

      if (onConfirm) {
        onConfirm(event);
      }
    }
  }, confirmText || locale.Popconfirm.confirmText)));
});

var Popconfirm = function Popconfirm(_ref2) {
  var type = _ref2.type,
      _ref2$content = _ref2.content,
      _content = _ref2$content === void 0 ? '' : _ref2$content,
      confirmText = _ref2.confirmText,
      cancelText = _ref2.cancelText,
      _ref2$onConfirm = _ref2.onConfirm,
      onConfirm = _ref2$onConfirm === void 0 ? function () {} : _ref2$onConfirm,
      _ref2$onCancel = _ref2.onCancel,
      onCancel = _ref2$onCancel === void 0 ? function () {} : _ref2$onCancel,
      props = _objectWithoutProperties(_ref2, _excluded);

  return /*#__PURE__*/React.createElement(Popover, _objectSpread({
    content: function content(hideTooltip) {
      return /*#__PURE__*/React.createElement(PopconfirmContent, {
        type: type,
        content: _content,
        confirmText: confirmText,
        cancelText: cancelText,
        onConfirm: onConfirm,
        onCancel: onCancel,
        hideTooltip: hideTooltip
      });
    }
  }, props));
};

Popconfirm.propTypes = {
  cancelText: _pt.node,
  confirmText: _pt.node,
  content: _pt.node.isRequired,
  onCancel: _pt.func,
  onConfirm: _pt.func,
  onOpenComplete: _pt.func,
  onCloseComplete: _pt.func
};
export { Popconfirm };