import { DownshiftInterface } from 'downshift3';
import { Component, ReactNode } from 'react';
declare type Option = {
    label: string;
    value: string;
} | string | number;
declare type MultiDownshiftProps = DownshiftInterface<Option> & {
    selectedItem?: Option[];
    initialSelectedItem?: Option[];
    onSelect?: (options: Option | Option[]) => void;
    onChange?: (options: Option | Option[]) => void;
    children: (options: any) => ReactNode;
};
interface MultiDownshiftState {
    selectedItems: Option[];
}
declare class MultiDownshift extends Component<MultiDownshiftProps, MultiDownshiftState> {
    state: MultiDownshiftState;
    get selectedItems(): Option[];
    stateReducer: (state: any, changes: any) => any;
    handleChange: () => void;
    handleSelection: (selectedItem: Option) => void;
    removeItem: (item: Option) => void;
    addSelectedItem(item: Option): void;
    getRemoveButtonProps: ({ onClick, item, ...props }: {
        onClick?: ((e: any) => void) | undefined;
        item: Option;
    }) => {
        onClick: (e: any) => void;
    };
    render(): JSX.Element;
}
export default MultiDownshift;
