import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inherits from "@babel/runtime/helpers/inherits";
import _createSuper from "@babel/runtime/helpers/createSuper";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import _pt from "prop-types";
var _excluded = ["onClick", "item"],
    _excluded2 = ["children"];
import Downshift from 'downshift3';
import React, { Component } from 'react';
import { itemToString } from './utils';

var MultiDownshift = /*#__PURE__*/function (_Component) {
  _inherits(MultiDownshift, _Component);

  var _super = _createSuper(MultiDownshift);

  function MultiDownshift() {
    var _this;

    _classCallCheck(this, MultiDownshift);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));

    _defineProperty(_assertThisInitialized(_this), "state", {
      selectedItems: _this.props.initialSelectedItem || _this.props.selectedItem || []
    });

    _defineProperty(_assertThisInitialized(_this), "stateReducer", function (state, changes) {
      switch (changes.type) {
        case Downshift.stateChangeTypes.blurButton:
          return {};

        case Downshift.stateChangeTypes.keyDownEnter:
        case Downshift.stateChangeTypes.mouseUp:
        case Downshift.stateChangeTypes.clickItem:
          return _objectSpread(_objectSpread({}, changes), {}, {
            highlightedIndex: state.highlightedIndex,
            isOpen: true,
            inputValue: ''
          });

        default:
          return changes;
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleChange", function () {
      var _this$props = _this.props,
          onSelect = _this$props.onSelect,
          onChange = _this$props.onChange;
      var selectedItems = _this.state.selectedItems;

      if (onSelect) {
        onSelect(selectedItems);
      }

      if (onChange) {
        onChange(selectedItems);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "handleSelection", function (selectedItem) {
      var _this$props2 = _this.props,
          onSelect = _this$props2.onSelect,
          onChange = _this$props2.onChange;

      if (selectedItem.label === 'CREATE_OPTION') {
        if (onSelect) {
          onSelect(selectedItem);
        }

        if (onChange) {
          onChange(selectedItem);
        }

        return;
      }

      if (_this.state.selectedItems.map(itemToString).includes(itemToString(selectedItem))) {
        _this.removeItem(selectedItem);
      } else {
        _this.addSelectedItem(selectedItem);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "removeItem", function (item) {
      _this.setState({
        selectedItems: _this.selectedItems.filter(function (i) {
          return itemToString(i) !== itemToString(item);
        })
      }, _this.handleChange);
    });

    _defineProperty(_assertThisInitialized(_this), "getRemoveButtonProps", function (_ref) {
      var _onClick = _ref.onClick,
          item = _ref.item,
          props = _objectWithoutProperties(_ref, _excluded);

      return _objectSpread({
        onClick: function onClick(e) {
          // TODO: use something like downshift's composeEventHandlers utility instead
          if (_onClick) {
            _onClick(e);
          }

          e.stopPropagation();

          _this.removeItem(item);
        }
      }, props);
    });

    return _this;
  }

  _createClass(MultiDownshift, [{
    key: "selectedItems",
    get: function get() {
      var selectedItem = this.props.selectedItem;

      if (selectedItem) {
        return selectedItem;
      }

      return this.state.selectedItems;
    }
  }, {
    key: "addSelectedItem",
    value: function addSelectedItem(item) {
      this.setState({
        selectedItems: [].concat(_toConsumableArray(this.selectedItems), [item])
      }, this.handleChange);
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props3 = this.props,
          children = _this$props3.children,
          props = _objectWithoutProperties(_this$props3, _excluded2); // TODO: compose together props (rather than overwriting them) like downshift does


      return /*#__PURE__*/React.createElement(Downshift, _objectSpread(_objectSpread({}, props), {}, {
        stateReducer: this.stateReducer,
        onChange: this.handleSelection,
        selectedItem: null
      }), function (downshift) {
        return children(_objectSpread({
          getRemoveButtonProps: _this2.getRemoveButtonProps,
          removeItem: _this2.removeItem,
          selectedItems: _this2.selectedItems
        }, downshift));
      });
    }
  }]);

  return MultiDownshift;
}(Component);

_defineProperty(MultiDownshift, "propTypes", {
  selectedItem: _pt.arrayOf(_pt.oneOfType([_pt.shape({
    label: _pt.string.isRequired,
    value: _pt.string.isRequired
  }), _pt.string, _pt.number])),
  initialSelectedItem: _pt.arrayOf(_pt.oneOfType([_pt.shape({
    label: _pt.string.isRequired,
    value: _pt.string.isRequired
  }), _pt.string, _pt.number])),
  onSelect: _pt.func,
  onChange: _pt.func,
  children: _pt.func.isRequired
});

export default MultiDownshift;