import React, { FocusEventHandler, PropsWithChildren, ReactNode } from 'react';
import { Option, SelectedValue } from './SelectOptions';
export interface SelectProps<V extends SelectedValue = SelectedValue> {
    id?: string;
    name?: string;
    className?: string;
    width?: string | number;
    size?: 'sm' | 'md' | 'lg';
    creatable?: boolean;
    clearable?: boolean;
    disabled?: boolean;
    loading?: boolean;
    multiple?: boolean;
    searchable?: boolean;
    options: Option[];
    value?: V;
    defaultValue?: V;
    placeholder?: string;
    menu?: ReactNode;
    itemSize?: number;
    optionsMaxHeight?: number;
    onChange?: (option: V) => void;
    onBlur?: FocusEventHandler<HTMLInputElement>;
    noOptionsMessage?: () => ReactNode;
    formatCreateLabel?: (labelInfo: {
        value: string;
        active: boolean;
        hovered: boolean;
    }) => ReactNode;
    isValidNewOption?: (value: string) => boolean;
    onCreateOption?: (value: string) => void;
    onVisibleChange?: (visible: boolean) => void;
    'data-testid'?: string;
}
declare const Select: <V extends SelectedValue>({ id, width, size, creatable, clearable, disabled, loading, multiple, searchable, options, value, defaultValue, placeholder, menu, itemSize, optionsMaxHeight, onChange, noOptionsMessage, formatCreateLabel, isValidNewOption, onCreateOption, onVisibleChange, onBlur, ...props }: React.PropsWithChildren<SelectProps<V>>) => JSX.Element;
export { Select };
