import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _typeof from "@babel/runtime/helpers/typeof";
import _pick from "ramda/src/pick";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["visible", "searchable", "creatable", "multiple", "inputValue", "onChange", "options", "selectedItem", "selectedItems", "removeItem", "placeholder", "getInputProps", "onBlur"];
import React, { forwardRef } from 'react';
import { AutoSizeInput } from '../AutoSizeInput';
import { getDataTestId, itemToString } from './utils';
var SelectInput = /*#__PURE__*/forwardRef(function SelectInput(_ref, ref) {
  var visible = _ref.visible,
      searchable = _ref.searchable,
      creatable = _ref.creatable,
      multiple = _ref.multiple,
      inputValue = _ref.inputValue,
      onChange = _ref.onChange,
      options = _ref.options,
      selectedItem = _ref.selectedItem,
      selectedItems = _ref.selectedItems,
      removeItem = _ref.removeItem,
      placeholder = _ref.placeholder,
      getInputProps = _ref.getInputProps,
      onBlur = _ref.onBlur,
      props = _objectWithoutProperties(_ref, _excluded);

  var inputProps = getInputProps();
  return /*#__PURE__*/React.createElement(AutoSizeInput, _objectSpread(_objectSpread(_objectSpread({
    ref: ref
  }, getDataTestId(props, 'input')), {}, {
    fontSize: 16,
    onBlur: onBlur,
    autoComplete: "off"
  }, _pick(['aria-autocomplete', 'aria-activedescendant', 'aria-controls', 'aria-labelledby', 'onBlur', 'id'], inputProps)), visible && (searchable || creatable || multiple) ? {
    value: inputValue,
    onChange: onChange,
    onKeyDown: function onKeyDown(event) {
      inputProps.onKeyDown(event);

      if (multiple && event.key === 'Backspace' && !event.currentTarget.value) {
        removeItem(selectedItems[selectedItems.length - 1]);
      }
    },
    placeholder: selectedItem && !multiple ? itemToString(selectedItem) : placeholder
  } : {
    value: itemToString(_typeof(selectedItem) !== 'object' && options.every(function (option) {
      return _typeof(option) === 'object';
    }) ? options.find(function (option) {
      return option.value === selectedItem;
    }) : selectedItem),
    onKeyDown: inputProps.onKeyDown,
    placeholder: placeholder
  }));
});
export default SelectInput;