import { FC, ReactNode } from 'react';
import { GetItemPropsOptions } from 'downshift3';
export declare type Option = {
    label: ReactNode;
    value: string | number;
    disabled?: boolean;
} | string | number;
export declare type SelectedValue = Option | Option[];
export interface CreateOption {
    label: 'CREATE_OPTION';
    value: string;
}
interface SelectOptionsProps {
    visible: boolean;
    creatable: boolean;
    searchable: boolean;
    multiple: boolean;
    itemSize: number;
    optionsMaxHeight: number;
    getMenuProps: () => any;
    getItemProps: (option: GetItemPropsOptions<Option>) => any;
    options: Option[];
    inputValue: string;
    menu?: ReactNode;
    highlightedIndex: number | null;
    selectedItem?: Option;
    selectedItems?: Option[];
    noOptionsMessage?: () => ReactNode;
    formatCreateLabel?: (labelInfo: {
        value: string;
        active: boolean;
        hovered: boolean;
    }) => ReactNode;
    isValidNewOption?: (value: string) => boolean;
    'data-testid'?: string;
}
declare const SelectOptions: FC<SelectOptionsProps>;
export default SelectOptions;
