import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["children", "index", "removeButtonProps"];
import React from 'react';
import { MdClose } from 'react-icons/md';
import { Icon } from '../Icon';
import { StyledSelectedOption } from './styles';
import { getDataTestId } from './utils';

var SelectedOption = function SelectedOption(_ref) {
  var children = _ref.children,
      index = _ref.index,
      removeButtonProps = _ref.removeButtonProps,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/React.createElement(StyledSelectedOption, _objectSpread(_objectSpread({}, props), getDataTestId(props, "selected-option-".concat(index))), children, /*#__PURE__*/React.createElement(Icon, _objectSpread(_objectSpread({
    type: MdClose,
    size: "16",
    cursor: "pointer",
    ml: "1"
  }, removeButtonProps), getDataTestId(props, "selected-option-".concat(index, "-clear-icon")))));
};

SelectedOption.propTypes = {
  index: _pt.number.isRequired,
  size: _pt.oneOf(['sm', 'md', 'lg']).isRequired,
  'data-testid': _pt.string
};
export default SelectedOption;