import styled, { css, keyframes } from 'styled-components';
export var SelectWrapper = styled.div.withConfig({
  componentId: "sc-22d49l-0"
})(["display:inline-flex;cursor:pointer;"]);
export var StyledSelectOption = styled.div.withConfig({
  componentId: "sc-22d49l-1"
})(["display:flex;align-items:center;background-color:", ";color:", ";font-size:", ";cursor:", ";> div{padding:0 24px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}"], function (p) {
  return p.hovered ? p.theme.colors.primaryLight : p.theme.colors.light;
}, function (p) {
  if (p.hovered) {
    return p.theme.colors.light;
  }

  if (p.active) {
    return p.theme.colors.primaryLight;
  }

  if (p.disabled) {
    return p.theme.colors.gray300;
  }

  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  return p.disabled ? 'not-allowed' : 'pointer';
});
export var StyledSelectedOption = styled.div.withConfig({
  componentId: "sc-22d49l-2"
})(["display:inline-flex;align-items:center;max-width:100%;margin-right:8px;padding:0 8px;border:", ";border-radius:", ";border-color:", ";background-color:", ";color:", ";font-size:", ";", ";> span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}svg{fill:", ";}&:hover svg{fill:", ";}"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.colors.surface2;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (_ref) {
  var size = _ref.size,
      heights = _ref.theme.heights;
  return {
    sm: css(["min-height:calc(", " - 4px);margin-top:0.5px;margin-bottom:0.5px;"], heights.sm),
    md: css(["min-height:calc(", " - 10px);margin-top:2px;margin-bottom:2px;"], heights.base),
    lg: css(["min-height:calc(", " - 14px);margin-top:3px;margin-bottom:3px;"], heights.lg)
  }[size];
}, function (p) {
  return p.theme.colors.primaryLight2;
}, function (p) {
  return p.theme.colors.primaryLight;
});
export var StyledSelect = styled.div.withConfig({
  componentId: "sc-22d49l-3"
})(["display:inline-flex;align-items:center;width:100%;max-width:100%;border:", ";border-radius:", ";border-color:", ";outline:none;background-color:", ";color:", ";line-height:", ";cursor:pointer;appearance:none;&:hover{border-color:", ";}", " ", " ", " input{flex:1;width:100%;overflow:hidden;border:none;outline:none;background-color:transparent;text-overflow:ellipsis;pointer-events:none;&::placeholder{color:", ";}}", ";", ";"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.lineHeight;
}, function (p) {
  return p.theme.colors.primary;
}, function (p) {
  return p.focused && css(["border-color:", ";"], p.theme.colors.primary);
}, function (p) {
  return p.invalid && css(["border-color:", " !important;"], p.theme.colors.danger);
}, function (p) {
  return p.disabled && css(["border-color:", ";background-color:", ";cursor:not-allowed;&:hover{border-color:", ";}input{color:", ";}", "{border-color:", ";background-color:", ";color:", ";pointer-events:none;}"], p.theme.colors.gray400, p.theme.colors.gray300, p.theme.colors.gray400, p.theme.colors.gray500, StyledSelectedOption, p.theme.colors.gray400, p.theme.colors.gray200, p.theme.colors.gray400);
}, function (p) {
  return p.theme.colors.gray400;
}, function (_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 'md' : _ref2$size,
      multiple = _ref2.multiple,
      _ref2$theme = _ref2.theme,
      paddings = _ref2$theme.paddings,
      heights = _ref2$theme.heights,
      fontSizes = _ref2$theme.fontSizes;
  var inputSizeStyles = {
    sm: css(["min-height:", ";padding:", " ", ";input{font-size:", ";}"], heights.sm, multiple ? '0.5px' : '1px', paddings.xs, fontSizes.sm),
    md: css(["min-height:", ";padding:", " ", ";input{font-size:", ";}"], heights.base, multiple ? '2px' : '4px', paddings.sm, fontSizes.base),
    lg: css(["min-height:", ";padding:", " ", ";input{font-size:", ";}"], heights.lg, multiple ? '3px' : '6px', paddings.md, fontSizes.lg)
  };
  return inputSizeStyles[size];
}, function (p) {
  return p.theme.transition;
}
/* sc-declaration */
);
var spin = keyframes(["0%{transform:rotate(0deg);}100%{transform:rotate(360deg);}"]);
export var Loading = styled.div.withConfig({
  componentId: "sc-22d49l-4"
})(["flex:none;width:24px;height:24px;margin:4px;border:", ";border-radius:50%;border-top-color:transparent;border-right-color:transparent;animation:", " 0.7s linear infinite;"], function (p) {
  return p.theme.borders.base;
}, spin);