import _typeof from "@babel/runtime/helpers/typeof";
import fuzzaldrin from 'fuzzaldrin-plus';
import React from 'react';
export var fuzzyFilter = function fuzzyFilter(itemToString) {
  if (itemToString) {
    return function (items, input) {
      var wrappedItems = items.map(function (item) {
        return {
          key: itemToString(item),
          item: item
        };
      });
      return fuzzaldrin.filter(wrappedItems, input, {
        key: 'key'
      }).map(function (_ref) {
        var item = _ref.item;
        return item;
      });
    };
  }

  return function (items, input) {
    return fuzzaldrin.filter(items, input);
  };
};
export var itemToString = function itemToString(item) {
  if (!item) {
    return '';
  }

  return _typeof(item) === 'object' ? String(item.label) : String(item);
};
export var getDataTestId = function getDataTestId(props) {
  var suffix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (!props['data-testid']) {
    return {};
  }

  return {
    'data-testid': "".concat(props['data-testid']).concat(suffix ? "-".concat(suffix) : '')
  };
};