import _pt from "prop-types";
import React from 'react';
import { StyledDotContainer, StyledSliderDot, StyledSliderDotNumber } from './styles';

var Dot = function Dot(_ref) {
  var active = _ref.active,
      value = _ref.value,
      style = _ref.style;
  return /*#__PURE__*/React.createElement(StyledDotContainer, {
    style: style,
    active: active
  }, /*#__PURE__*/React.createElement(StyledSliderDot, null), /*#__PURE__*/React.createElement(StyledSliderDotNumber, null, value));
};

Dot.propTypes = {
  active: _pt.bool.isRequired
};

var SliderDot = function SliderDot(_ref2) {
  var range = _ref2.range,
      value = _ref2.value,
      active = _ref2.active,
      changedValue = _ref2.changedValue,
      denominator = _ref2.denominator,
      min = _ref2.min,
      valuePercentage = _ref2.valuePercentage;

  if (!range) {
    return /*#__PURE__*/React.createElement(Dot, {
      active: active,
      value: value,
      style: {
        left: valuePercentage
      }
    });
  }

  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Dot, {
    active: active && value[0] === changedValue,
    value: value[0],
    style: {
      left: "".concat((value[0] - min) / denominator * 100, "%")
    }
  }), /*#__PURE__*/React.createElement(Dot, {
    active: active && value[1] === changedValue,
    value: value[1],
    style: {
      left: "".concat((value[1] - min) / denominator * 100, "%")
    }
  }));
};

SliderDot.propTypes = {
  active: _pt.bool.isRequired,
  changedValue: _pt.number,
  denominator: _pt.number.isRequired,
  min: _pt.number.isRequired,
  valuePercentage: _pt.string.isRequired,
  range: _pt.bool.isRequired
};
export default SliderDot;