import _clamp from "ramda/src/clamp";
export var getOffsetValue = function getOffsetValue(_ref) {
  var event = _ref.event,
      startX = _ref.startX,
      stepOffset = _ref.stepOffset,
      min = _ref.min,
      max = _ref.max;

  var _ref2 = 'touches' in event ? event.touches[0] : event,
      currentX = _ref2.pageX;

  var offsetX = currentX - startX;
  var offsetValue = Math.round(offsetX / stepOffset);

  var value = _clamp(min, max, offsetValue);

  return value;
};
export var getPageX = function getPageX(_ref3) {
  var event = _ref3.event;
  return 'touches' in event ? event.touches[0].pageX : event.pageX;
};
export var getMovedValue = function getMovedValue(_ref4) {
  var offsetX = _ref4.offsetX,
      stepOffset = _ref4.stepOffset,
      min = _ref4.min,
      max = _ref4.max;
  var offsetValue = Math.round(offsetX / stepOffset);

  var value = _clamp(min, max, offsetValue);

  return value;
};
export var updateRangeValues = function updateRangeValues(_ref5) {
  var value = _ref5.value,
      replaceValue = _ref5.replaceValue,
      newValue = _ref5.newValue;

  if (value.every(function (val) {
    return val === replaceValue;
  })) {
    return [value[0], newValue];
  }

  var updatedValues = value.map(function (v) {
    return v === replaceValue ? newValue : v;
  }).sort(function (a, b) {
    return a - b;
  });
  return updatedValues;
};