import _pt from "prop-types";
import React from 'react';
import styled, { keyframes } from 'styled-components';

var spinAnimationCircle1 = function spinAnimationCircle1(primaryLight) {
  return keyframes(["0%{transform:scale(0.36,0.36) translate(0,-90%);}33%{background-color:", ";transform:scale(0.36,0.36) translate(-80%,60%);}50%{background-color:", ";transform:scale(0.18,0.18) translate(0,60%);}66%{transform:scale(0.36,0.36) translate(80%,60%);}100%{transform:scale(0.36,0.36) translate(0,-90%);}"], primaryLight, primaryLight);
};

var spinAnimationCircle2 = function spinAnimationCircle2(primaryLight) {
  return keyframes(["0%{transform:scale(0.36,0.36) translate(-80%,60%);}33%{background-color:", ";transform:scale(0.36,0.36) translate(80%,60%);}50%{background-color:", ";transform:scale(0.18,0.18) translate(45%,-20%);}66%{transform:scale(0.36,0.36) translate(0,-90%);}100%{transform:scale(0.36,0.36) translate(-80%,60%);}"], primaryLight, primaryLight);
};

var spinAnimationCircle3 = function spinAnimationCircle3(primaryLight) {
  return keyframes(["0%{transform:scale(0.36,0.36) translate(80%,60%);}33%{background-color:", ";transform:scale(0.36,0.36) translate(0,-90%);}50%{background-color:", ";transform:scale(0.18,0.18) translate(-45%,-20%);}66%{transform:scale(0.36,0.36) translate(-80%,60%);}100%{transform:scale(0.36,0.36) translate(80%,60%);}"], primaryLight, primaryLight);
};

var BaseSpinCircle = styled.div.withConfig({
  componentId: "i6fbnf-0"
})(["position:absolute;top:0;left:0;width:100%;height:100%;border-radius:50%;background-color:", ";"], function (p) {
  return p.theme.colors.primary;
});
var SpinCircle1 = styled(BaseSpinCircle).withConfig({
  componentId: "i6fbnf-1"
})(["animation:", " 1.5s infinite linear both;"], function (p) {
  return spinAnimationCircle1(p.theme.colors.primaryLight);
});
var SpinCircle2 = styled(BaseSpinCircle).withConfig({
  componentId: "i6fbnf-2"
})(["animation:", " 1.5s infinite linear both;"], function (p) {
  return spinAnimationCircle2(p.theme.colors.primaryLight);
});
var SpinCircle3 = styled(BaseSpinCircle).withConfig({
  componentId: "i6fbnf-3"
})(["animation:", " 1.5s infinite linear both;"], function (p) {
  return spinAnimationCircle3(p.theme.colors.primaryLight);
});
var SpinCircleWrapper = styled.div.withConfig({
  componentId: "i6fbnf-4"
})(["position:relative;width:", "px;height:", "px;"], function (p) {
  return p.size;
}, function (p) {
  return p.size;
});
var SpinWrapper = styled.div.withConfig({
  componentId: "i6fbnf-5"
})(["display:flex;align-items:center;justify-content:center;width:100%;height:100%;"]);

var Spin = function Spin(_ref) {
  var _ref$size = _ref.size,
      size = _ref$size === void 0 ? 40 : _ref$size;
  return /*#__PURE__*/React.createElement(SpinWrapper, null, /*#__PURE__*/React.createElement(SpinCircleWrapper, {
    size: size
  }, /*#__PURE__*/React.createElement(SpinCircle1, null), /*#__PURE__*/React.createElement(SpinCircle2, null), /*#__PURE__*/React.createElement(SpinCircle3, null)));
};

Spin.propTypes = {
  size: _pt.oneOfType([_pt.number, _pt.string]),
  fullscreen: _pt.bool,
  bg: _pt.string
};
export { Spin };