import _pt from "prop-types";
// Reference: https://github.com/segmentio/evergreen/blob/master/src/stack/src/Stack.js
import React, { useContext } from 'react';
import { StackingOrder } from '../constants';
import StackingContext from './StackingContext';

var Stack = function Stack(_ref) {
  var _ref$defaultOrder = _ref.defaultOrder,
      defaultOrder = _ref$defaultOrder === void 0 ? StackingOrder.STACKING_CONTEXT : _ref$defaultOrder,
      children = _ref.children;
  var previousOrder = useContext(StackingContext);
  var currentOrder = Math.max(defaultOrder, previousOrder);
  var nextOrder = currentOrder + 1;
  return /*#__PURE__*/React.createElement(StackingContext.Provider, {
    value: nextOrder
  }, children(currentOrder));
};

Stack.propTypes = {
  defaultOrder: _pt.number,
  children: _pt.func.isRequired
};
export { Stack };