import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "style"];
import React, { forwardRef, useMemo, useRef } from 'react';
import { useComposedRefs } from '@reach/utils/compose-refs';
import { StyledColumn } from './styles';
import { useFixedColumnContext } from './FixedColumnContext';
var Column = /*#__PURE__*/forwardRef(function Column(_ref, forwardedRef) {
  var children = _ref.children,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      props = _objectWithoutProperties(_ref, _excluded);

  var ownRef = useRef(null);
  var ref = useComposedRefs(forwardedRef, ownRef);

  var _useFixedColumnContex = useFixedColumnContext(),
      getColumnFixedInfo = _useFixedColumnContex.getColumnFixedInfo;

  var fixedInfo = useMemo(function () {
    var _ownRef$current$cellI, _ownRef$current;

    return getColumnFixedInfo({
      index: (_ownRef$current$cellI = (_ownRef$current = ownRef.current) === null || _ownRef$current === void 0 ? void 0 : _ownRef$current.cellIndex) !== null && _ownRef$current$cellI !== void 0 ? _ownRef$current$cellI : -1,
      style: style
    });
  }, [getColumnFixedInfo, style]);
  return /*#__PURE__*/React.createElement(StyledColumn, _objectSpread(_objectSpread({
    ref: ref
  }, fixedInfo), props), children);
});
export default Column;