import React, { ReactNode } from 'react';
import { CSSProperties } from 'styled-components';
interface FixedColumn {
    width: number;
    fixed?: 'left' | 'right';
    colSpan?: number;
}
interface Column extends FixedColumn {
    index: number;
}
declare const useFixedColumnContext: () => {
    setColumn: (column: Column) => void;
    getColumnFixedInfo: (payload: {
        index: number;
        style?: CSSProperties;
    }) => {
        style?: CSSProperties;
        fixed?: boolean;
        showScrollShadowStart?: boolean;
        showScrollShadowEnd?: boolean;
        isLastFixedLeft?: boolean;
        isFirstFixedRight?: boolean;
    };
};
declare const useFixedHeadColumn: ({ index, width, fixed, style, colSpan, }: {
    index: number;
    width: number;
    fixed?: "left" | "right" | undefined;
    style?: CSSProperties | undefined;
    colSpan?: number | undefined;
}) => {
    style?: CSSProperties | undefined;
    fixed?: boolean | undefined;
    showScrollShadowStart?: boolean | undefined;
    showScrollShadowEnd?: boolean | undefined;
    isLastFixedLeft?: boolean | undefined;
    isFirstFixedRight?: boolean | undefined;
};
interface FixedColumnContextProviderProps {
    scrollShadowStart: boolean;
    scrollShadowEnd: boolean;
    children: ReactNode;
}
declare const FixedColumnContextProvider: React.NamedExoticComponent<FixedColumnContextProviderProps>;
export { FixedColumnContextProvider, useFixedColumnContext, useFixedHeadColumn, };
