import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "fixed", "colSpan", "style"];
import React, { forwardRef, useRef } from 'react';
import { useComposedRefs } from '@reach/utils/compose-refs';
import { useMeasure } from '../hooks';
import { StyledHeadColumn } from './styles';
import { useFixedHeadColumn } from './FixedColumnContext';
var HeadColumn = /*#__PURE__*/forwardRef(function HeadColumn(_ref, forwardedRef) {
  var _ownRef$current$cellI, _ownRef$current;

  var children = _ref.children,
      fixed = _ref.fixed,
      colSpan = _ref.colSpan,
      _ref$style = _ref.style,
      style = _ref$style === void 0 ? {} : _ref$style,
      props = _objectWithoutProperties(_ref, _excluded);

  var ownRef = useRef(null);
  var forkedRef = useComposedRefs(forwardedRef, ownRef);

  var _useMeasure = useMeasure(forkedRef),
      _useMeasure2 = _slicedToArray(_useMeasure, 2),
      ref = _useMeasure2[0].ref,
      offsetWidth = _useMeasure2[1].offsetWidth;

  var fixedInfo = useFixedHeadColumn({
    index: (_ownRef$current$cellI = (_ownRef$current = ownRef.current) === null || _ownRef$current === void 0 ? void 0 : _ownRef$current.cellIndex) !== null && _ownRef$current$cellI !== void 0 ? _ownRef$current$cellI : -1,
    width: offsetWidth,
    fixed: fixed,
    style: style,
    colSpan: colSpan
  });
  return /*#__PURE__*/React.createElement(StyledHeadColumn, _objectSpread(_objectSpread({
    ref: ref
  }, fixedInfo), {}, {
    colSpan: colSpan
  }, props), children);
});
export default HeadColumn;