import React, { ComponentPropsWithoutRef, ReactNode } from 'react';
import Column from './Column';
import HeadColumn from './HeadColumn';
import { Row, StyledTableWrapperProps } from './styles';
declare const Head: React.ForwardRefExoticComponent<{
    children: ReactNode;
} & React.RefAttributes<HTMLTableSectionElement>>;
declare const Body: React.ForwardRefExoticComponent<{
    children: ReactNode;
} & React.RefAttributes<HTMLTableSectionElement>>;
export declare type TableProps = Omit<ComponentPropsWithoutRef<'table'>, 'width'> & Omit<StyledTableWrapperProps, 'hasHeader' | 'hasFooter' | 'hasFixed'> & {
    header?: ReactNode;
    footer?: ReactNode;
};
declare const Table: React.ForwardRefExoticComponent<Omit<Pick<React.DetailedHTMLProps<React.TableHTMLAttributes<HTMLTableElement>, HTMLTableElement>, "key" | keyof React.TableHTMLAttributes<HTMLTableElement>>, "width"> & Omit<StyledTableWrapperProps, "hasHeader" | "hasFooter" | "hasFixed"> & {
    header?: ReactNode;
    footer?: ReactNode;
} & React.RefAttributes<HTMLTableElement>> & {
    Head: typeof Head;
    HeadColumn: typeof HeadColumn;
    Body: typeof Body;
    Row: typeof Row;
    Column: typeof Column;
};
export { Table };
