import styled, { css } from 'styled-components';
import { maxHeight, textAlign, width } from 'styled-system';
var columnSharedStyle = css(["height:56px;padding:", " ", ";border:none;border-bottom:", " ", ";", ""], function (p) {
  return p.theme.paddings.xs;
}, function (p) {
  return p.theme.paddings.sm;
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return (p.showScrollShadowStart || p.showScrollShadowEnd) && css(["&::after{content:'';position:absolute;top:0;bottom:-1px;width:30px;pointer-events:none;", ";", " ", " ", " ", "}"], p.theme.transition, p.isLastFixedLeft && css(["right:0;transform:translateX(100%);"]), p.isFirstFixedRight && css(["left:0;transform:translateX(-100%);"]), p.showScrollShadowStart && css(["box-shadow:inset 10px 0 8px -8px rgb(0 0 0 / 15%);"]), p.showScrollShadowEnd && css(["box-shadow:inset -10px 0 8px -8px rgb(0 0 0 / 15%);"]));
});
export var StyledHeadColumn = styled.th.withConfig({
  componentId: "sc-12ad6r6-0"
})(["position:sticky;z-index:", ";top:0;background-color:", ";color:", ";font-weight:bold;", ";", ";", ";"], function (p) {
  return p.fixed ? 3 : 2;
}, function (p) {
  return p.theme.colors.surface2;
}, function (p) {
  return p.theme.colors.gray700;
}, columnSharedStyle, width, function (p) {
  return p.theme.transition;
});
export var StyledColumn = styled.td.withConfig({
  componentId: "sc-12ad6r6-1"
})(["background-color:", ";", " ", ";", ";"], function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.fixed && css(["position:sticky;z-index:1;"]);
}, columnSharedStyle, function (p) {
  return p.theme.transition;
});
export var Row = styled.tr.withConfig({
  componentId: "sc-12ad6r6-2"
})(["border-top:none;&:last-child > ", "{border-bottom:none;}"], StyledColumn);
export var StyledTable = styled.table.withConfig({
  componentId: "sc-12ad6r6-3"
})(["display:table;width:100%;margin:0;padding:0;border-spacing:0;border-collapse:separate;border-style:hidden;background-color:", ";font-size:", ";& > tbody > tr:hover > td{background-color:", ";}"], function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.fontSizes.base;
}, function (p) {
  return p.theme.colors.gray100;
});
export var StyledTableWrapper = styled.div.withConfig({
  componentId: "sc-12ad6r6-4"
})(["position:relative;flex:none;overflow-x:auto;overflow-y:", ";border-radius:", ";background-color:", ";", " ", ";", ";", ";"], function (p) {
  return p.maxHeight ? 'auto' : 'hidden';
}, function (p) {
  return p.theme.radii.xl;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return !p.hasHeader && !p.hasFooter && css(["box-shadow:", ";"], p.theme.shadows.base);
}, width, maxHeight, textAlign);
export var TableWrapper = styled.div.withConfig({
  componentId: "sc-12ad6r6-5"
})(["flex:none;overflow:hidden;border-radius:", ";background-color:", ";box-shadow:", ";& ", "{width:100%;border-radius:0;", " ", "}", ";"], function (p) {
  return p.theme.radii.xl;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.shadows.base;
}, StyledTableWrapper, function (p) {
  return p.hasHeader && css(["border-top:", " ", ";"], p.theme.borders.base, p.theme.colors.gray300);
}, function (p) {
  return p.hasFooter && css(["border-bottom:", " ", ";"], p.theme.borders.base, p.theme.colors.gray300);
}, width);