import { FC } from 'react';
import { SpaceProps } from 'styled-system';
import { Size } from './TabContext';
export interface TabProps {
    /**
     * label of tab
     */
    label: string;
    /**
     * Tab's value
     */
    value: string;
    /**
     * Disabled state of tab
     */
    disabled?: boolean;
}
export declare const Tab: FC<TabProps>;
interface StyledTabsProps extends SpaceProps {
    /**
     * Make the tabs position to bottom of parent
     */
    absolute?: boolean;
    /**
     * Set the tabs width to 100%
     */
    block?: boolean;
}
declare type TabsProps = StyledTabsProps & {
    /**
     * Initial active Tab's value, if `activeValue` is not set.
     */
    defaultActiveValue?: string;
    /**
     * Current Tab's value
     */
    activeValue?: string;
    /**
     * Callback executed when active tab is changed
     */
    onChange?: (activeValue: string) => void;
    /**
     * Pills style of tabs
     */
    pills?: boolean;
    /**
     * Preset tab bar size
     */
    size?: Size;
};
declare const Tabs: FC<TabsProps> & {
    Tab: typeof Tab;
};
export { Tabs };
