import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["label", "value"],
    _excluded2 = ["absolute", "pills", "size", "children", "defaultActiveValue", "activeValue", "onChange"];
import React, { useContext, useState } from 'react';
import styled, { css } from 'styled-components';
import { space } from 'styled-system';
import TabContext from './TabContext';
var StyledTab = styled.a.withConfig({
  componentId: "sc-1e0bfi7-0"
})(["display:inline-flex;position:relative;align-items:center;color:", ";text-align:center;text-decoration:none;cursor:pointer;&:hover{text-decoration:none;}&:disabled,&[disabled]{opacity:0.5;cursor:default;pointer-events:none;}&:not(:first-child){margin-left:", ";}", ";", ";", ";", ";"], function (p) {
  return p.theme.colors.gray800;
}, function (p) {
  return p.theme.space[2];
}, function (_ref) {
  var size = _ref.size,
      _ref$theme = _ref.theme,
      heights = _ref$theme.heights,
      paddings = _ref$theme.paddings,
      fontSizes = _ref$theme.fontSizes;
  return {
    sm: css(["height:", ";padding:0 ", ";font-size:", ";"], heights.sm, paddings.sm, fontSizes.sm),
    md: css(["height:", ";padding:0 ", ";font-size:", ";"], heights.base, paddings.md, fontSizes.base),
    lg: css(["height:", ";padding:0 ", ";font-size:", ";"], heights.lg, paddings.lg, fontSizes.lg)
  }[size];
}, function (_ref2) {
  var pills = _ref2.pills,
      active = _ref2.active,
      theme = _ref2.theme;
  return pills ? css(["border-radius:", ";color:", ";", ";"], theme.radii.lg, theme.colors.gray600, active ? css(["background-color:", ";color:", ";"], theme.colors.primary, theme.colors.light) : css(["&:hover{background-color:", ";color:", ";}"], theme.colors.gray300, theme.colors.gray700)) : css(["border-bottom:3px solid transparent;", ";"], active && css(["border-bottom-color:", ";"], theme.colors.primary));
}, function (p) {
  return p.theme.transition;
}
/* sc-declaration */
, space);
export var Tab = function Tab(_ref3) {
  var label = _ref3.label,
      value = _ref3.value,
      props = _objectWithoutProperties(_ref3, _excluded);

  var _useContext = useContext(TabContext),
      size = _useContext.size,
      pills = _useContext.pills,
      activeValue = _useContext.activeValue,
      setValue = _useContext.setValue;

  return /*#__PURE__*/React.createElement(StyledTab, _objectSpread({
    size: size,
    pills: pills,
    active: activeValue === value,
    onClick: function onClick() {
      return setValue(value);
    }
  }, props), label);
};
Tab.propTypes = {
  label: _pt.string.isRequired,
  value: _pt.string.isRequired,
  disabled: _pt.bool
};
var StyledTabs = styled.nav.withConfig({
  componentId: "sc-1e0bfi7-1"
})(["display:flex;", ";", ";", ";"], function (_ref4) {
  var absolute = _ref4.absolute;
  return absolute && css(["position:absolute;bottom:-3px;"]);
}, function (_ref5) {
  var block = _ref5.block;
  return block && css(["right:0;left:0;padding-right:inherit;padding-left:inherit;", "{flex-grow:1;}"], StyledTab
  /* sc-selector */
  );
}, space);

var Tabs = function Tabs(_ref6) {
  var _ref6$absolute = _ref6.absolute,
      absolute = _ref6$absolute === void 0 ? false : _ref6$absolute,
      _ref6$pills = _ref6.pills,
      pills = _ref6$pills === void 0 ? false : _ref6$pills,
      _ref6$size = _ref6.size,
      size = _ref6$size === void 0 ? 'md' : _ref6$size,
      children = _ref6.children,
      defaultActiveValue = _ref6.defaultActiveValue,
      activeValue = _ref6.activeValue,
      onChange = _ref6.onChange,
      otherProps = _objectWithoutProperties(_ref6, _excluded2);

  var _useState = useState(defaultActiveValue),
      _useState2 = _slicedToArray(_useState, 2),
      activeTab = _useState2[0],
      setActiveTab = _useState2[1];

  return /*#__PURE__*/React.createElement(TabContext.Provider, {
    value: {
      activeValue: activeValue || activeTab || '',
      setValue: function setValue(value) {
        setActiveTab(value);

        if (onChange && value) {
          onChange(value);
        }
      },
      size: size,
      pills: pills
    }
  }, /*#__PURE__*/React.createElement(StyledTabs, _objectSpread({
    absolute: absolute
  }, otherProps), children));
};

Tabs.Tab = Tab;
export { Tabs };