import React, { ComponentPropsWithoutRef, ReactNode } from 'react';
export interface TagProps extends Omit<ComponentPropsWithoutRef<'div'>, 'prefix' | 'onChange'> {
    /**
     * Whether the Tag can be closed
     */
    closable?: boolean;
    editable?: boolean;
    /**
     * Callback executed when close animation is completed
     */
    onClosed?: () => void;
    onClose?: () => void;
    canClose?: () => boolean | Promise<boolean>;
    onChange?: (previousValue: string, value: string) => void;
    children?: string;
    initialEditing?: boolean;
    invalid?: boolean;
    disabled?: boolean;
    prefix?: ReactNode;
}
declare const Tag: React.ForwardRefExoticComponent<TagProps & React.RefAttributes<HTMLDivElement>>;
export { Tag };
