import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["children", "editable", "initialEditing", "closable", "invalid", "disabled", "onClose", "onClosed", "canClose", "prefix", "onChange", "onClick"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { forwardRef, useCallback, useEffect, useState } from 'react';
import styled from 'styled-components';
import { MdClose } from 'react-icons/md';
import { animated, to, useSpring } from '@react-spring/web';
import { Ellipsis } from '../Ellipsis';
import { Icon } from '../Icon';
import { useMeasure, usePrevious } from '../hooks';
import { StyledTag, StyledTagInput, StyledTagPrefix } from './styles';
var StyledTagWrapper = styled.div.withConfig({
  componentId: "sc-1ibpnx6-0"
})(["display:inline-flex;overflow-x:hidden;"]);
var AnimatedStyledTagWrapper = animated(StyledTagWrapper);
var StyledCloseIcon = styled(Icon).withConfig({
  componentId: "sc-1ibpnx6-1"
})(["& svg{fill:", ";}&:hover svg{fill:", ";}"], function (p) {
  return p.theme.colors.primaryLight2;
}, function (p) {
  return p.theme.colors.primaryLight;
});

var CloseIcon = function CloseIcon(_ref) {
  var onClick = _ref.onClick,
      disabled = _ref.disabled,
      invalid = _ref.invalid;
  var fill;

  if (invalid) {
    fill = 'danger';
  }

  if (disabled) {
    fill = 'gray500';
  }

  return /*#__PURE__*/React.createElement(StyledCloseIcon, {
    size: "16",
    ml: "1",
    cursor: disabled ? 'not-allowed' : 'pointer',
    fill: fill,
    onClick: onClick,
    type: MdClose
  });
};

CloseIcon.propTypes = {
  onClick: _pt.func.isRequired,
  invalid: _pt.bool.isRequired,
  disabled: _pt.bool.isRequired
};
var Tag = /*#__PURE__*/forwardRef(function Tag(_ref2, ref) {
  var _ref2$children = _ref2.children,
      children = _ref2$children === void 0 ? '' : _ref2$children,
      _ref2$editable = _ref2.editable,
      editable = _ref2$editable === void 0 ? false : _ref2$editable,
      _ref2$initialEditing = _ref2.initialEditing,
      initialEditing = _ref2$initialEditing === void 0 ? false : _ref2$initialEditing,
      closable = _ref2.closable,
      _ref2$invalid = _ref2.invalid,
      invalid = _ref2$invalid === void 0 ? false : _ref2$invalid,
      _ref2$disabled = _ref2.disabled,
      disabled = _ref2$disabled === void 0 ? false : _ref2$disabled,
      onClose = _ref2.onClose,
      onClosed = _ref2.onClosed,
      canClose = _ref2.canClose,
      prefix = _ref2.prefix,
      onChange = _ref2.onChange,
      _onClick = _ref2.onClick,
      otherProps = _objectWithoutProperties(_ref2, _excluded);

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      closeDone = _useState2[0],
      setCloseDone = _useState2[1];

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      on = _useState4[0],
      setOn = _useState4[1];

  var _useState5 = useState(initialEditing),
      _useState6 = _slicedToArray(_useState5, 2),
      editing = _useState6[0],
      setEditing = _useState6[1];

  var previous = usePrevious(on);

  var _useMeasure = useMeasure(),
      _useMeasure2 = _slicedToArray(_useMeasure, 2),
      bind = _useMeasure2[0],
      width = _useMeasure2[1].width;

  var style = useSpring({
    opacity: on ? 1 : 0,
    marginRight: on ? 4 : 0,
    width: on ? width : 0,
    onRest: {
      opacity: function opacity(restOpacity) {
        if (restOpacity.value === 0) {
          setCloseDone(true);
        }
      }
    }
  });
  useEffect(function () {
    if (onClosed && closeDone) {
      onClosed();
    }
  }, [onClosed, closeDone]);
  var handleUpdate = useCallback(function (event) {
    var value = event.currentTarget.value;
    setEditing(false);

    if (onChange && children !== value) {
      onChange(children, value);
    }
  }, [children, onChange]);

  if (closeDone) {
    return null;
  }

  return /*#__PURE__*/React.createElement(AnimatedStyledTagWrapper, _objectSpread(_objectSpread({}, bind), {}, {
    style: _objectSpread(_objectSpread({}, style), {}, {
      width: to(style.width, function (springWidth) {
        return on && previous === on ? 'auto' : springWidth;
      })
    })
  }), /*#__PURE__*/React.createElement(StyledTag, _objectSpread({
    ref: ref,
    editable: editable,
    disabled: disabled,
    invalid: invalid,
    onClick: function onClick(event) {
      if (disabled) {
        return;
      }

      if (editable) {
        setEditing(true);
      }

      if (_onClick) {
        _onClick(event);
      }
    }
  }, otherProps), prefix && /*#__PURE__*/React.createElement(StyledTagPrefix, {
    invalid: invalid
  }, prefix), editing ? /*#__PURE__*/React.createElement(StyledTagInput, {
    autoFocus: true,
    defaultValue: children,
    onBlur: handleUpdate,
    onKeyPress: function onKeyPress(event) {
      if (event.key === 'Enter') {
        handleUpdate(event);
      }
    },
    onKeyDown: function onKeyDown(event) {
      if (event.key === 'Escape') {
        setEditing(false);
      }
    }
  }) : /*#__PURE__*/React.createElement(Ellipsis, null, children), closable && /*#__PURE__*/React.createElement(CloseIcon, {
    invalid: invalid,
    disabled: disabled,
    onClick: /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(event) {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!disabled) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                event.stopPropagation();
                _context.t0 = canClose;

                if (!_context.t0) {
                  _context.next = 8;
                  break;
                }

                _context.next = 7;
                return canClose();

              case 7:
                _context.t0 = !_context.sent;

              case 8:
                if (!_context.t0) {
                  _context.next = 10;
                  break;
                }

                return _context.abrupt("return");

              case 10:
                if (onClose) {
                  onClose();
                } else {
                  setOn(false);
                }

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }()
  })));
});
export { Tag };