import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["id", "name", "onChange", "onBlur"];
import IntlTelInput from 'react-intl-tel-input';
import React from 'react';
import { useFormField } from '../FormField';
import StyledTelInput from './style';

var TelInput = function TelInput(_ref) {
  var id = _ref.id,
      name = _ref.name,
      onChange = _ref.onChange,
      onBlur = _ref.onBlur,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useFormField = useFormField({
    id: id,
    value: props.value,
    defaultValue: props.defaultValue
  }),
      _useFormField2 = _slicedToArray(_useFormField, 3),
      invalid = _useFormField2[0],
      labelId = _useFormField2[1],
      setValue = _useFormField2[2];

  var onPhoneNumberChange = function onPhoneNumberChange(isValid, value, phoneInfo, fullPhoneNumber) {
    setValue(value);

    if (onChange) {
      onChange(isValid, value, phoneInfo, fullPhoneNumber);
    }
  };

  return /*#__PURE__*/React.createElement(StyledTelInput, {
    invalid: invalid
  }, /*#__PURE__*/React.createElement(IntlTelInput, _objectSpread({
    format: true,
    fieldId: labelId,
    fieldName: name,
    onPhoneNumberBlur: onBlur,
    onPhoneNumberChange: onPhoneNumberChange,
    preferredCountries: ['tw']
  }, props)));
};

TelInput.propTypes = {
  id: _pt.string,
  name: _pt.string,
  value: _pt.string,
  defaultValue: _pt.string,
  onChange: _pt.func,
  onBlur: _pt.func,
  placeholder: _pt.string,
  disabled: _pt.bool
};
export { TelInput };