import { ReactNode } from 'react';
import { InputProps, TextareaProps } from '../Input';
export declare type TextFieldSharedProps = {
    label?: ReactNode;
    value?: string;
    defaultValue?: string;
    maxLength?: number;
};
export declare type TextareaTextFieldProps = TextFieldSharedProps & ({
    textarea: true;
} & TextareaProps);
export declare type InputTextFieldProps = TextFieldSharedProps & InputProps;
export declare type TextFieldOverload = {
    (props: TextareaTextFieldProps): JSX.Element;
    (props: InputTextFieldProps): JSX.Element;
};
declare const TextField: TextFieldOverload;
export { TextField };
