import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _omit from "ramda/src/omit";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useContext, useState } from 'react';
import FormFieldContext from '../FormField/FormFieldContext';
import { Input, Textarea } from '../Input';
import { MaxLength, TextFieldContainer } from './styles';

var isTextarea = function isTextarea(props) {
  return 'textarea' in props && typeof props.textarea === 'boolean' && props.textarea;
};

var TextField = function TextField(props) {
  var _useContext = useContext(FormFieldContext),
      invalid = _useContext.invalid;

  var _useState = useState(props.defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      uncontrolledValue = _useState2[0],
      setUncontrolledValue = _useState2[1];

  var value = props.value || props.value === '' ? props.value : uncontrolledValue !== null && uncontrolledValue !== void 0 ? uncontrolledValue : '';
  var component = isTextarea(props) ? /*#__PURE__*/React.createElement(Textarea, _objectSpread(_objectSpread({}, _omit(['textarea', 'onChange'], props)), {}, {
    onChange: function onChange(event) {
      setUncontrolledValue(event.currentTarget.value);

      if (props.onChange) {
        props.onChange(event);
      }
    }
  })) : /*#__PURE__*/React.createElement(Input, _objectSpread(_objectSpread({}, _omit(['textarea', 'onChange'], props)), {}, {
    onChange: function onChange(event) {
      setUncontrolledValue(event.currentTarget.value);

      if (props.onChange) {
        props.onChange(event);
      }
    }
  }));
  var maxLength = props.maxLength,
      label = props.label;
  return /*#__PURE__*/React.createElement(TextFieldContainer, {
    empty: !value,
    invalid: invalid
  }, component, maxLength && !invalid && /*#__PURE__*/React.createElement(MaxLength, null, maxLength - value.length), label && /*#__PURE__*/React.createElement("label", null, label));
};

export { TextField };