import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["children", "Wrapper", "position", "content", "defaultVisible", "visible", "onVisibleChange", "mouseEnterDelay", "mouseLeaveDelay", "onOpenComplete", "onCloseComplete"];
import React, { useRef } from 'react';
import { Position } from '../constants';
import { Positioner } from '../Positioner';
import { useHoverTrigger, useRenderChildren, useTargetRef } from '../hooks';
import TooltipPopup from './TooltipPopup';

var Tooltip = function Tooltip(_ref) {
  var children = _ref.children,
      Wrapper = _ref.Wrapper,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? Position.TOP : _ref$position,
      content = _ref.content,
      _ref$defaultVisible = _ref.defaultVisible,
      defaultVisible = _ref$defaultVisible === void 0 ? false : _ref$defaultVisible,
      visibleFromProps = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      _ref$mouseEnterDelay = _ref.mouseEnterDelay,
      mouseEnterDelay = _ref$mouseEnterDelay === void 0 ? 0 : _ref$mouseEnterDelay,
      _ref$mouseLeaveDelay = _ref.mouseLeaveDelay,
      mouseLeaveDelay = _ref$mouseLeaveDelay === void 0 ? 200 : _ref$mouseLeaveDelay,
      onOpenComplete = _ref.onOpenComplete,
      onCloseComplete = _ref.onCloseComplete,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var popupRef = useRef(null);
  var targetRef = useTargetRef({
    children: children
  });

  var _useHoverTrigger = useHoverTrigger({
    visible: visibleFromProps,
    defaultVisible: defaultVisible,
    onVisibleChange: onVisibleChange,
    mouseEnterDelay: mouseEnterDelay,
    mouseLeaveDelay: mouseLeaveDelay
  }),
      visible = _useHoverTrigger.visible,
      handleOpen = _useHoverTrigger.handleOpen,
      handleClose = _useHoverTrigger.handleClose;

  var renderChildren = useRenderChildren({
    targetRef: targetRef,
    children: children,
    mergeProps: {
      onMouseEnter: handleOpen,
      onMouseLeave: handleClose
    }
  });
  return /*#__PURE__*/React.createElement(Positioner, {
    positionerRef: popupRef,
    targetRef: targetRef,
    visible: visible,
    onOpenComplete: onOpenComplete,
    onCloseComplete: onCloseComplete,
    position: position,
    positioner: /*#__PURE__*/React.createElement(TooltipPopup, _objectSpread({
      Wrapper: Wrapper,
      content: content,
      handleOpen: handleOpen,
      handleClose: handleClose
    }, otherProps))
  }, renderChildren);
};

Tooltip.propTypes = {
  Wrapper: _pt.elementType,
  defaultVisible: _pt.bool,
  visible: _pt.bool,
  onVisibleChange: _pt.func,
  content: _pt.node.isRequired,
  mouseEnterDelay: _pt.number,
  mouseLeaveDelay: _pt.number,
  onOpenComplete: _pt.func,
  onCloseComplete: _pt.func
};
export { Tooltip };