import React, { createContext, useCallback, useContext, useRef } from 'react';
var UIDContext = /*#__PURE__*/createContext(function () {
  return 'tailor_uid_0';
});
UIDContext.displayName = 'UIDContext';

var UIDProvider = function UIDProvider(_ref) {
  var children = _ref.children;
  var UID = useRef(0);
  var getUID = useCallback(function () {
    UID.current += 1;
    return "tailor_uid_".concat(UID.current);
  }, []);
  return /*#__PURE__*/React.createElement(UIDContext.Provider, {
    value: getUID
  }, children);
};

var useUID = function useUID() {
  return useContext(UIDContext);
};

export { UIDContext, UIDProvider, useUID };