import _pt from "prop-types";

/* eslint camelcase: off */
import React from 'react';
import { Helmet } from 'react-helmet';
import { ThemeProvider } from 'styled-components';
import { GlobalStyle } from '../GlobalStyle';
import { HooksMessageProvider } from '../message/HooksMessageProvider';
import { HooksModalProvider } from '../Modal/HooksModalProvider';
import { HooksNotificationProvider } from '../notification/HooksNotificationProvider';
import { LocaleProvider } from '../locale/LocaleProvider';
import { locales } from '../locale';
import { theme as defaultTheme, fontStyle } from '../theme';
import { UIDProvider } from './UIDContext';
var en_US = locales.en_US;

var UIProvider = function UIProvider(_ref) {
  var children = _ref.children,
      _ref$theme = _ref.theme,
      theme = _ref$theme === void 0 ? defaultTheme : _ref$theme,
      _ref$locale = _ref.locale,
      locale = _ref$locale === void 0 ? en_US : _ref$locale;
  return /*#__PURE__*/React.createElement(ThemeProvider, {
    theme: theme
  }, /*#__PURE__*/React.createElement(LocaleProvider, {
    locale: locale
  }, /*#__PURE__*/React.createElement(UIDProvider, null, /*#__PURE__*/React.createElement(HooksModalProvider, null, /*#__PURE__*/React.createElement(HooksMessageProvider, null, /*#__PURE__*/React.createElement(HooksNotificationProvider, null, /*#__PURE__*/React.createElement(Helmet, null, /*#__PURE__*/React.createElement("style", {
    type: "text/css"
  }, fontStyle)), /*#__PURE__*/React.createElement(GlobalStyle, null), children))))));
};

UIProvider.propTypes = {
  children: _pt.node.isRequired
};
export { UIProvider };