/**
 * Stacking order contains z-index values that are used through.
 * Note that the Stack component might increase the z-index for certain components.
 */
declare const StackingOrder: {
    /**
     * Used as the default for the StackingContext.
     */
    STACKING_CONTEXT: number;
    /**
     * Used as the default for the Positioner.
     */
    POSITIONER: number;
    /**
     * Used for the notification.
     */
    NOTIFICATION: number;
    /**
     * Used for the Overlay and everything that's inside such as Dialog + SideSheet.
     */
    OVERLAY: number;
    /**
     * Used for the toasts in the toaster. Appears on top of everything else.
     */
    MESSAGE: number;
};
export { StackingOrder };
