import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["label", "name", "required", "options", "direction"];
import React from 'react';
import { useField } from 'formik';
import { CheckboxGroup, FormField } from '../..';
import { mergeEventProps } from '../../utils';

var CheckboxField = function CheckboxField(_ref) {
  var fieldLabel = _ref.label,
      name = _ref.name,
      required = _ref.required,
      options = _ref.options,
      direction = _ref.direction,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useField = useField(name),
      _useField2 = _slicedToArray(_useField, 3),
      field = _useField2[0],
      meta = _useField2[1],
      helpers = _useField2[2];

  return /*#__PURE__*/React.createElement(FormField, {
    required: required,
    label: fieldLabel,
    validationMessage: meta.error && meta.touched ? meta.error : null
  }, /*#__PURE__*/React.createElement(CheckboxGroup, _objectSpread({
    direction: direction,
    value: field.value,
    options: options
  }, mergeEventProps(otherProps, {
    onChange: function onChange(value) {
      return helpers.setValue(value);
    }
  }))));
};

CheckboxField.propTypes = {
  name: _pt.string.isRequired,
  label: _pt.string,
  required: _pt.bool
};
export { CheckboxField };