import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["label", "name", "required"];
import React from 'react';
import { useField } from 'formik';
import { FormField, Input } from '../..';
import { mergeEventProps } from '../../utils';

var InputField = function InputField(_ref) {
  var label = _ref.label,
      name = _ref.name,
      required = _ref.required,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useField = useField(name),
      _useField2 = _slicedToArray(_useField, 3),
      field = _useField2[0],
      meta = _useField2[1],
      helpers = _useField2[2];

  var id = "input-".concat(name);
  return /*#__PURE__*/React.createElement(FormField, {
    required: required,
    label: label,
    validationMessage: meta.touched && meta.error ? meta.error : null
  }, /*#__PURE__*/React.createElement(Input, _objectSpread(_objectSpread({}, field), {}, {
    id: id
  }, mergeEventProps(otherProps, {
    onBlur: function onBlur(event) {
      helpers.setValue(event.target.value.trim());
      field.onBlur(event);
    }
  }))));
};

InputField.propTypes = {
  name: _pt.string.isRequired,
  label: _pt.string,
  required: _pt.bool
};
export { InputField };