import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _typeof from "@babel/runtime/helpers/typeof";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["required", "label", "name"];
import React from 'react';
import { useField } from 'formik';
import { FormField, Select } from '../..';
import { mergeEventProps } from '../../utils';

var SelectField = function SelectField(_ref) {
  var required = _ref.required,
      label = _ref.label,
      name = _ref.name,
      otherProps = _objectWithoutProperties(_ref, _excluded);

  var _useField = useField(name),
      _useField2 = _slicedToArray(_useField, 3),
      field = _useField2[0],
      meta = _useField2[1],
      helpers = _useField2[2];

  var id = "select-".concat(name);
  return /*#__PURE__*/React.createElement(FormField, {
    required: required,
    label: label,
    validationMessage: meta.error && meta.touched ? meta.error : null
  }, /*#__PURE__*/React.createElement(Select, _objectSpread({
    id: id,
    name: name,
    value: field.value
  }, mergeEventProps(otherProps, {
    onBlur: field.onBlur,
    onChange: function onChange(selectedOption) {
      if (!selectedOption) {
        helpers.setValue(null);
        return;
      }

      if (Array.isArray(selectedOption)) {
        helpers.setValue(selectedOption);
        return;
      }

      var changedValue = _typeof(selectedOption) === 'object' ? selectedOption.value : selectedOption;
      helpers.setValue(changedValue);
    }
  }))));
};

SelectField.propTypes = {
  name: _pt.string.isRequired,
  label: _pt.string,
  required: _pt.bool
};
export { SelectField };