import React, { useCallback, useEffect } from 'react';

var useClickOutside = function useClickOutside(_ref) {
  var _ref$listening = _ref.listening,
      listening = _ref$listening === void 0 ? true : _ref$listening,
      onClickOutside = _ref.onClickOutside,
      refs = _ref.refs;
  var handleClick = useCallback(function (event) {
    var clickInside = refs.some(function (ref) {
      if (!ref.current) {
        return false;
      }

      return ref.current.contains(event.target);
    });

    if (!clickInside) {
      onClickOutside();
    }
  }, [onClickOutside, refs]);
  useEffect(function () {
    if (listening) {
      document.body.addEventListener('click', handleClick);
      document.body.addEventListener('touchend', handleClick);
      return function () {
        document.body.removeEventListener('click', handleClick, false);
        document.body.removeEventListener('touchend', handleClick, false);
      };
    }

    document.body.removeEventListener('click', handleClick, false);
    document.body.removeEventListener('touchend', handleClick, false);
    return function () {};
  }, [listening, onClickOutside, handleClick]);
  return null;
};

export { useClickOutside };