import React, { useCallback, useEffect } from 'react';
export var ESC_KEY_CODE = 27;

var useKeydown = function useKeydown(_ref) {
  var _ref$listening = _ref.listening,
      listening = _ref$listening === void 0 ? true : _ref$listening,
      targetKeyCode = _ref.keyCode,
      onKeydown = _ref.onKeydown;
  var handleKeydown = useCallback(function (event) {
    if (event.keyCode === targetKeyCode && onKeydown) {
      onKeydown(event);
    }
  }, [targetKeyCode, onKeydown]);
  useEffect(function () {
    if (listening) {
      document.body.addEventListener('keydown', handleKeydown);
      return function () {
        document.body.removeEventListener('keydown', handleKeydown, false);
      };
    }

    document.body.removeEventListener('keydown', handleKeydown, false);
    return function () {};
  }, [listening, targetKeyCode, onKeydown, handleKeydown]);
  return null;
};

export { useKeydown };