import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import ResizeObserver from 'resize-observer-polyfill';
import React, { useEffect, useRef, useState } from 'react';
import { useComposedRefs } from '@reach/utils/compose-refs';
import { tuplify } from '../utils';

var useMeasure = function useMeasure() {
  var targetRef = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var measureRef = useRef(null);
  var ref = useComposedRefs(measureRef, targetRef);

  var _useState = useState({
    left: 0,
    top: 0,
    width: 0,
    height: 0,
    offsetWidth: 0,
    offsetHeight: 0
  }),
      _useState2 = _slicedToArray(_useState, 2),
      bounds = _useState2[0],
      set = _useState2[1];

  var _useState3 = useState(function () {
    return new ResizeObserver(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 1),
          entry = _ref2[0];

      set({
        left: entry.contentRect.left,
        top: entry.contentRect.top,
        width: entry.contentRect.width,
        height: entry.contentRect.height,
        offsetWidth: entry.target.clientWidth,
        offsetHeight: entry.target.clientHeight
      });
    });
  }),
      _useState4 = _slicedToArray(_useState3, 1),
      ro = _useState4[0];

  useEffect(function () {
    if (measureRef.current) {
      ro.observe(measureRef.current);
    }

    return function () {
      return ro.disconnect();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return tuplify({
    ref: ref
  }, bounds);
};

export { useMeasure };