import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useCallback, useMemo, useState } from 'react';
import { tuplify } from '../utils';

var useOwnValue = function useOwnValue(props, options) {
  var _useState = useState(function () {
    return props.value || props.defaultValue || options.fallbackValue;
  }),
      _useState2 = _slicedToArray(_useState, 2),
      ownValue = _useState2[0],
      setOwnValue = _useState2[1];

  var value = useMemo(function () {
    return props.value !== undefined ? props.value : ownValue;
  }, [ownValue, props.value]);
  var onChange = useCallback(function (newValue) {
    setOwnValue(newValue);

    if (props.onChange) {
      props.onChange(newValue);
    }
  }, // eslint-disable-next-line react-hooks/exhaustive-deps
  [props]);
  return tuplify(value, onChange);
};

export { useOwnValue };