import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import React, { cloneElement, isValidElement, useCallback } from 'react';
import { mergeEventProps } from '../utils';

var useRenderChildren = function useRenderChildren(_ref) {
  var children = _ref.children,
      targetRef = _ref.targetRef,
      mergeProps = _ref.mergeProps;
  var renderChildren = useCallback(function () {
    if (children instanceof Function) {
      return children({
        ref: targetRef,
        bind: function bind(props) {
          return mergeEventProps(props, mergeProps);
        }
      });
    }

    if (! /*#__PURE__*/isValidElement(children)) {
      return children;
    }

    return /*#__PURE__*/cloneElement(children, _objectSpread({
      ref: targetRef
    }, mergeEventProps(children.props, mergeProps)));
  }, [children, mergeProps, targetRef]);
  return renderChildren;
};

export { useRenderChildren };