import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import React, { useCallback, useEffect, useState } from 'react';

var useToggleTrigger = function useToggleTrigger(_ref) {
  var visibleFromProps = _ref.visible,
      defaultVisible = _ref.defaultVisible,
      onVisibleChange = _ref.onVisibleChange;

  var _useState = useState(defaultVisible || visibleFromProps || false),
      _useState2 = _slicedToArray(_useState, 2),
      visibleFromSelf = _useState2[0],
      setVisibleFromSelf = _useState2[1];

  var hasVisibleFromProps = typeof visibleFromProps !== 'undefined';
  var visible = hasVisibleFromProps ? visibleFromProps : visibleFromSelf;
  useEffect(function () {
    if (hasVisibleFromProps && onVisibleChange && visibleFromProps !== visibleFromSelf) {
      setVisibleFromSelf(visibleFromProps);
      onVisibleChange(visibleFromProps);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [hasVisibleFromProps, onVisibleChange, visibleFromProps]);
  var handleOpen = useCallback(function () {
    if (onVisibleChange) {
      onVisibleChange(true);
    }

    setVisibleFromSelf(true);
  }, [onVisibleChange]);
  var handleClose = useCallback(function () {
    if (onVisibleChange) {
      onVisibleChange(false);
    }

    setVisibleFromSelf(false);
  }, [onVisibleChange]);
  var toggle = useCallback(function () {
    if (visible) {
      handleClose();
    } else {
      handleOpen();
    }
  }, [visible, handleClose, handleOpen]);
  return {
    visible: visible,
    handleOpen: handleOpen,
    handleClose: handleClose,
    toggle: toggle
  };
};

export { useToggleTrigger };