import React, { PropsWithoutRef, ReactElement, ReactNode, Ref } from 'react';
import { SelectOption } from './types';
interface MultipleSelectProps<T extends SelectOption> {
    id?: string;
    loading?: boolean;
    searchable?: boolean;
    clearable?: boolean;
    creatable?: boolean;
    disabled?: boolean;
    width?: string | number;
    options: T[];
    value?: T[];
    defaultValue?: T[];
    onChange: (item: T[]) => void;
    placeholder?: string;
    noOptionsMessage?: () => ReactNode;
    onCreateOption?: (value: string) => void;
    formatCreateLabel?: (labelInfo: {
        value: string;
        active: boolean;
        hovered: boolean;
    }) => ReactNode;
    isValidNewOption?: (value: string) => boolean;
}
declare const MultipleSelect: <T extends SelectOption>(p: MultipleSelectProps<T> & {
    ref?: React.Ref<HTMLDivElement> | undefined;
}) => ReactElement;
export { MultipleSelect };
