import React, { PropsWithoutRef, ReactElement, ReactNode, Ref } from 'react';
import { SelectOption } from './types';
interface SelectProps<T extends SelectOption, V = T | null> {
    id?: string;
    loading?: boolean;
    searchable?: boolean;
    clearable?: boolean;
    creatable?: boolean;
    disabled?: boolean;
    width?: string | number;
    options: T[];
    value?: V;
    defaultValue?: V;
    onChange: (item: V) => void;
    onSearch?: (value: string) => void;
    placeholder?: string;
    noOptionsMessage?: () => ReactNode;
    onCreateOption?: (value: string) => void;
    formatCreateLabel?: (labelInfo: {
        value: string;
        active: boolean;
        hovered: boolean;
    }) => ReactNode;
    isValidNewOption?: (value: string) => boolean;
}
declare const Select: <T extends SelectOption>(p: SelectProps<T, T | null> & {
    ref?: React.Ref<HTMLDivElement> | undefined;
}) => ReactElement;
export { Select };
