import _pt from "prop-types";
import React from 'react';
import { MdClose, MdKeyboardArrowUp } from 'react-icons/md';
import { Icon } from '../../Icon';
import { ArrowIconWrapper, ClearIconWrapper, SelectLoading, SelectSuffixWrapper } from './styles';

var SelectSuffix = function SelectSuffix(_ref) {
  var loading = _ref.loading,
      clearable = _ref.clearable,
      onClearIconClick = _ref.onClearIconClick,
      hasSelectedItem = _ref.hasSelectedItem,
      visible = _ref.visible;

  if (loading) {
    return /*#__PURE__*/React.createElement(SelectLoading, null);
  }

  return /*#__PURE__*/React.createElement(SelectSuffixWrapper, null, clearable && hasSelectedItem && /*#__PURE__*/React.createElement(ClearIconWrapper, null, /*#__PURE__*/React.createElement(Icon, {
    type: MdClose,
    fill: "gray400",
    size: "20",
    cursor: "pointer",
    onClick: function onClick(event) {
      event.stopPropagation();
      onClearIconClick();
    }
  })), /*#__PURE__*/React.createElement(ArrowIconWrapper, {
    visible: visible
  }, /*#__PURE__*/React.createElement(Icon, {
    type: MdKeyboardArrowUp,
    size: "20",
    fill: "gray400",
    style: {
      pointerEvents: 'none'
    }
  })));
};

SelectSuffix.propTypes = {
  loading: _pt.bool.isRequired,
  clearable: _pt.bool.isRequired,
  visible: _pt.bool.isRequired,
  hasSelectedItem: _pt.bool.isRequired,
  onClearIconClick: _pt.func.isRequired
};
export default SelectSuffix;