import styled, { css, keyframes } from 'styled-components';
export var SelectWrapper = styled.div.withConfig({
  componentId: "sc-1tmvtys-0"
})(["display:inline-flex;cursor:pointer;"]);
export var StyledSelectOption = styled.div.withConfig({
  componentId: "sc-1tmvtys-1"
})(["display:flex;position:absolute;top:0;left:0;align-items:center;width:100%;padding:0 24px;background-color:", ";color:", ";font-size:", ";cursor:", ";"], function (p) {
  return p.hovered ? p.theme.colors.primaryLight : p.theme.colors.light;
}, function (p) {
  if (p.hovered) {
    return p.theme.colors.light;
  }

  if (p.active) {
    return p.theme.colors.primaryLight;
  }

  if (p.disabled) {
    return p.theme.colors.gray300;
  }

  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  return p.disabled ? 'not-allowed' : 'pointer';
});
export var StyledSelectedOption = styled.div.withConfig({
  componentId: "sc-1tmvtys-2"
})(["display:inline-flex;align-items:center;max-width:100%;min-height:calc(", " - 10px);margin-top:2px;margin-right:8px;margin-bottom:2px;padding:0 8px;border:", ";border-radius:", ";border-color:", ";background-color:", ";color:", ";font-size:", ";> span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}svg{fill:", ";}&:hover svg{fill:", ";}"], function (p) {
  return p.theme.heights.base;
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.colors.surface2;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  return p.theme.colors.primaryLight2;
}, function (p) {
  return p.theme.colors.primaryLight;
});
export var StyledSelect = styled.div.withConfig({
  componentId: "sc-1tmvtys-3"
})(["display:inline-flex;align-items:center;width:100%;max-width:100%;min-height:", ";padding-top:", ";padding-right:", ";padding-bottom:", ";padding-left:", ";border:", ";border-radius:", ";border-color:", ";outline:none;background-color:", ";color:", ";line-height:", ";cursor:pointer;appearance:none;&:hover{border-color:", ";}", " ", " ", " input{flex:1;width:100%;overflow:hidden;border:none;outline:none;background-color:transparent;font-size:", ";text-overflow:ellipsis;pointer-events:none;&::placeholder{color:", ";}}", ";"], function (p) {
  return p.theme.heights.base;
}, function (p) {
  return p.multiple ? '2px' : '4px';
}, function (p) {
  return p.theme.paddings.sm;
}, function (p) {
  return p.multiple ? '0' : '4px';
}, function (p) {
  return p.theme.paddings.sm;
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.lineHeight;
}, function (p) {
  return p.theme.colors.primary;
}, function (p) {
  return p.focused && css(["border-color:", ";"], p.theme.colors.primary);
}, function (p) {
  return p.invalid && css(["border-color:", " !important;"], p.theme.colors.danger);
}, function (p) {
  return p.disabled && css(["border-color:", ";background-color:", ";cursor:not-allowed;&:hover{border-color:", ";}input{color:", ";}", "{border-color:", ";background-color:", ";color:", ";pointer-events:none;}"], p.theme.colors.gray400, p.theme.colors.gray300, p.theme.colors.gray400, p.theme.colors.gray500, StyledSelectedOption, p.theme.colors.gray400, p.theme.colors.gray200, p.theme.colors.gray400);
}, function (p) {
  return p.theme.fontSizes.base;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.transition;
});
export var StyledPopover = styled.div.withConfig({
  componentId: "sc-1tmvtys-4"
})(["position:relative;width:100%;max-height:182px;overflow-y:auto;border:", ";border-radius:", ";border-color:", ";box-shadow:", ";color:", ";font-size:", ";text-align:left;white-space:nowrap;"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return p.theme.shadows.xl;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
});
var spin = keyframes(["0%{transform:rotate(0deg);}100%{transform:rotate(360deg);}"]);
export var SelectLoading = styled.div.withConfig({
  componentId: "sc-1tmvtys-5"
})(["flex:none;width:16px;height:16px;margin:2px;border:", ";border-radius:50%;border-color:", ";border-top-color:transparent;border-right-color:transparent;animation:", " 0.7s linear infinite;"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.colors.gray400;
}, spin);
export var ClearIconWrapper = styled.i.withConfig({
  componentId: "sc-1tmvtys-6"
})(["position:absolute;z-index:1;width:22px;height:22px;padding:1px;border-radius:50%;opacity:0;background-color:", ";", ";"], function (p) {
  return p.theme.colors.gray200;
}, function (p) {
  return p.theme.transition;
});
export var ArrowIconWrapper = styled.div.withConfig({
  componentId: "sc-1tmvtys-7"
})(["width:20px;height:20px;margin:1px;transform:rotate(", "deg);", ";"], function (p) {
  return p.visible ? 0 : 180;
}, function (p) {
  return p.theme.transition;
});
export var SelectSuffixWrapper = styled.div.withConfig({
  componentId: "sc-1tmvtys-8"
})(["display:inline-flex;position:relative;flex:none;width:22px;height:26px;padding:2px 0;&:hover ", "{opacity:1;}"], ClearIconWrapper);