import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _pt from "prop-types";
var _excluded = ["children", "value"],
    _excluded2 = ["size", "type", "children", "defaultValue", "value", "onChange"];
import React, { useContext, useEffect, useRef, useState } from 'react';
import { useSpring } from '@react-spring/web';
import TabContext from './TabContext';
import { StyledTab, StyledTabs, TabActiveLine, TabLine } from './styles';
export var Tab = function Tab(_ref) {
  var children = _ref.children,
      value = _ref.value,
      props = _objectWithoutProperties(_ref, _excluded);

  var _useContext = useContext(TabContext),
      activeTabRef = _useContext.activeTabRef,
      activeValue = _useContext.activeValue,
      setValue = _useContext.setValue;

  var isActive = activeValue === value;
  return /*#__PURE__*/React.createElement(StyledTab, _objectSpread({
    ref: isActive ? activeTabRef : undefined,
    className: isActive ? 'active' : '',
    onClick: function onClick() {
      return setValue(value);
    }
  }, props), children);
};
Tab.propTypes = {
  value: _pt.string.isRequired
};

var Tabs = function Tabs(_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 'md' : _ref2$size,
      _ref2$type = _ref2.type,
      type = _ref2$type === void 0 ? 'line' : _ref2$type,
      children = _ref2.children,
      defaultValue = _ref2.defaultValue,
      value = _ref2.value,
      onChange = _ref2.onChange,
      otherProps = _objectWithoutProperties(_ref2, _excluded2);

  var tabsRef = useRef(null);
  var activeTabRef = useRef(null);

  var _useState = useState(defaultValue),
      _useState2 = _slicedToArray(_useState, 2),
      tabValue = _useState2[0],
      setTabValue = _useState2[1];

  var _useState3 = useState(true),
      _useState4 = _slicedToArray(_useState3, 2),
      immediate = _useState4[0],
      setImmediate = _useState4[1];

  var _useState5 = useState({
    offset: 0,
    width: 0
  }),
      _useState6 = _slicedToArray(_useState5, 2),
      springState = _useState6[0],
      setSpringState = _useState6[1];

  var activeValue = value || tabValue || '';
  var props = useSpring({
    immediate: immediate,
    width: springState.width,
    transform: "translateX(".concat(springState.offset, "px)")
  });
  useEffect(function () {
    if (springState.width !== 0) {
      setImmediate(false);
    }
  }, [springState.width]);
  useEffect(function () {
    if (type === 'line' && tabsRef.current && activeTabRef.current) {
      var tabsRect = tabsRef.current.getBoundingClientRect();
      var activeTabRect = activeTabRef.current.getBoundingClientRect();
      setSpringState({
        offset: activeTabRect.left - tabsRect.left,
        width: activeTabRect.width
      });
    }
  }, [type, activeValue]);
  return /*#__PURE__*/React.createElement(TabContext.Provider, {
    value: {
      activeTabRef: activeTabRef,
      activeValue: activeValue,
      setValue: function setValue(newValue) {
        setTabValue(newValue);

        if (onChange && newValue) {
          onChange(newValue);
        }
      }
    }
  }, /*#__PURE__*/React.createElement(StyledTabs, _objectSpread({
    ref: tabsRef,
    size: size,
    type: type
  }, otherProps), children, type === 'line' && /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TabActiveLine, {
    style: props
  }), /*#__PURE__*/React.createElement(TabLine, null))));
};

Tabs.defaultProps = {
  size: 'md',
  type: 'line',
  defaultValue: ''
};
Tabs.Tab = Tab;
export { Tabs };