import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
var _excluded = ["children", "id", "DEBUG_STYLE", "content"];
import React, { Children, cloneElement, forwardRef } from 'react';
import { TooltipPopup, useTooltip } from '@reach/tooltip';
import { animated, useTransition } from '@react-spring/web';
import { Stack } from '../../Stack';
import { TooltipStyle } from './styles';
var AnimatedTooltipContent = animated(TooltipPopup);
var Tooltip = /*#__PURE__*/forwardRef(function (_ref, forwardedRef) {
  var children = _ref.children,
      id = _ref.id,
      DEBUG_STYLE = _ref.DEBUG_STYLE,
      content = _ref.content,
      props = _objectWithoutProperties(_ref, _excluded);

  var child = Children.only(children);

  var _useTooltip = useTooltip({
    id: id,
    onMouseEnter: child.props.onMouseEnter,
    onMouseMove: child.props.onMouseMove,
    onMouseLeave: child.props.onMouseLeave,
    onFocus: child.props.onFocus,
    onBlur: child.props.onBlur,
    onKeyDown: child.props.onKeyDown,
    onMouseDown: child.props.onMouseDown,
    ref: child.ref,
    DEBUG_STYLE: DEBUG_STYLE
  }),
      _useTooltip2 = _slicedToArray(_useTooltip, 3),
      trigger = _useTooltip2[0],
      tooltip = _useTooltip2[1],
      isVisible = _useTooltip2[2];

  var transitions = useTransition(isVisible ? tooltip : null, {
    from: {
      opacity: 0,
      transform: 'scale(0.9)'
    },
    enter: {
      opacity: 1,
      transform: 'scale(1)'
    },
    leave: {
      opacity: 0,
      transform: 'scale(1)'
    },
    config: function config(item) {
      return {
        mass: 1,
        tension: item ? 500 : 1500,
        friction: item ? 40 : 1200
      };
    }
  });
  return /*#__PURE__*/React.createElement(Stack, null, function (stackingOrder) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(TooltipStyle, null), /*#__PURE__*/cloneElement(child, trigger), transitions(function (style, item) {
      return item && /*#__PURE__*/React.createElement(AnimatedTooltipContent, _objectSpread(_objectSpread(_objectSpread({
        ref: forwardedRef,
        label: content
      }, item), props), {}, {
        style: _objectSpread(_objectSpread({}, style), {}, {
          zIndex: stackingOrder
        })
      }));
    }));
  });
});
export { Tooltip };