'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _slicedToArray = require('@babel/runtime/helpers/slicedToArray');
var _objectSpread = require('@babel/runtime/helpers/objectSpread2');
var _objectWithoutProperties = require('@babel/runtime/helpers/objectWithoutProperties');
var _pt = require('prop-types');
var React = require('react');
var web = require('@react-spring/web');
var styled = require('styled-components');
var polished = require('polished');
var downshift = require('downshift');
var reactDom = require('react-dom');
var rect = require('@reach/rect');
var debounce = require('lodash.debounce');
var ResizeObserver = require('resize-observer-polyfill');
var composeRefs = require('@reach/utils/compose-refs');
var system = require('styled-system');
var Popover = require('@reach/popover');
var md = require('react-icons/md');
var reactVirtual = require('react-virtual');
var DatePicker = require('rc-picker/lib/locale/en_US');
require('rc-picker/lib/locale/zh_TW');
var _toConsumableArray = require('@babel/runtime/helpers/toConsumableArray');
var _typeof = require('@babel/runtime/helpers/typeof');
var fuzzaldrin = require('fuzzaldrin-plus');
var utils = require('@reach/utils');
var _asyncToGenerator = require('@babel/runtime/helpers/asyncToGenerator');
var _regeneratorRuntime = require('@babel/runtime/regenerator');
var tooltip = require('@reach/tooltip');
var _taggedTemplateLiteral = require('@babel/runtime/helpers/taggedTemplateLiteral');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e['default'] : e; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      n[k] = e[k];
    });
  }
  n['default'] = e;
  return Object.freeze(n);
}

var _slicedToArray__default = /*#__PURE__*/_interopDefaultLegacy(_slicedToArray);
var _objectSpread__default = /*#__PURE__*/_interopDefaultLegacy(_objectSpread);
var _objectWithoutProperties__default = /*#__PURE__*/_interopDefaultLegacy(_objectWithoutProperties);
var _pt__default = /*#__PURE__*/_interopDefaultLegacy(_pt);
var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var styled__default = /*#__PURE__*/_interopDefaultLegacy(styled);
var debounce__default = /*#__PURE__*/_interopDefaultLegacy(debounce);
var ResizeObserver__default = /*#__PURE__*/_interopDefaultLegacy(ResizeObserver);
var system__namespace = /*#__PURE__*/_interopNamespace(system);
var Popover__default = /*#__PURE__*/_interopDefaultLegacy(Popover);
var DatePicker__default = /*#__PURE__*/_interopDefaultLegacy(DatePicker);
var _toConsumableArray__default = /*#__PURE__*/_interopDefaultLegacy(_toConsumableArray);
var _typeof__default = /*#__PURE__*/_interopDefaultLegacy(_typeof);
var fuzzaldrin__default = /*#__PURE__*/_interopDefaultLegacy(fuzzaldrin);
var _asyncToGenerator__default = /*#__PURE__*/_interopDefaultLegacy(_asyncToGenerator);
var _regeneratorRuntime__default = /*#__PURE__*/_interopDefaultLegacy(_regeneratorRuntime);
var _taggedTemplateLiteral__default = /*#__PURE__*/_interopDefaultLegacy(_taggedTemplateLiteral);

var TabContext = /*#__PURE__*/React.createContext({
  activeTabRef: {
    current: null
  },
  activeValue: '',
  setValue: function setValue() {}
});
TabContext.displayName = 'TabContext';

var StyledTab = styled__default.a.withConfig({
  componentId: "sc-4h1awc-0"
})(["display:inline-flex;position:relative;align-items:center;font-weight:bold;text-align:center;text-decoration:none;cursor:pointer;", ";"], function (p) {
  return p.theme.transition;
}
/* sc-declaration */
);
var TabLine = styled__default(web.animated.div).withConfig({
  componentId: "sc-4h1awc-1"
})(["position:absolute;z-index:1;bottom:0;width:100%;height:3px;border-radius:", ";background-color:", ";"], function (p) {
  return p.theme.radii.base;
}, function (p) {
  return polished.rgba(p.theme.colors.primaryDark, 0.5);
});
var TabActiveLine = styled__default(web.animated.div).withConfig({
  componentId: "sc-4h1awc-2"
})(["position:absolute;z-index:2;bottom:0;height:3px;border-radius:", ";background-color:", ";"], function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.secondary;
});
var StyledTabs = styled__default.nav.withConfig({
  componentId: "sc-4h1awc-3"
})(["display:flex;position:relative;", " ", "{", ";}", ""], function (p) {
  return p.type === 'card' ? styled.css(["", "{background-color:", ";color:", ";border-top:", " transparent;&:hover{color:", ";}&:active{color:", ";}&:first-child{border-top-left-radius:", ";border-left:", " transparent;}&:last-child{border-top-right-radius:", ";border-right:", " transparent;}&.active{z-index:1;background-color:", ";color:", ";border-color:", ";box-shadow:0px -2px 4px -4px rgba(100,120,168,0.3),4px 0px 4px -4px rgba(100,120,168,0.3),-4px 0px 4px -4px rgba(100,120,168,0.3);}}", ":not(.active) + ", ":not(.active)::before{content:'';position:absolute;left:0;width:1px;height:", ";background-color:", ";}"], StyledTab, p.theme.colors.primaryLight2, p.theme.colors.gray500, p.theme.borders.base, p.theme.colors.primaryLight, p.theme.colors.primary, p.theme.radii.xl, p.theme.borders.base, p.theme.radii.xl, p.theme.borders.base, p.theme.colors.light, p.theme.colors.primaryLight, p.theme.colors.primaryLight2, StyledTab, StyledTab, p.theme.fontSizes[p.size === 'md' ? 'base' : p.size], p.theme.colors.gray500) : styled.css(["", "{background-color:transparent;color:", ";&:hover{color:", ";}&:active{color:", ";}}"], StyledTab, p.theme.colors.gray300, p.theme.colors.light, p.theme.colors.secondary);
}, StyledTab, function (p) {
  return {
    sm: styled.css(["height:40px;padding:0 20px;font-size:", ";"], p.theme.fontSizes.sm),
    md: styled.css(["height:48px;padding:0 24px;font-size:", ";"], p.theme.fontSizes.base),
    lg: styled.css(["height:56px;padding:0 28px;font-size:", ";"], p.theme.fontSizes.lg)
  }[p.size];
}, function (p) {
  return p.theme.transition;
});

var _excluded$7 = ["children", "value"],
    _excluded2 = ["size", "type", "children", "defaultValue", "value", "onChange"];
var Tab = function Tab(_ref) {
  var children = _ref.children,
      value = _ref.value,
      props = _objectWithoutProperties__default(_ref, _excluded$7);

  var _useContext = React.useContext(TabContext),
      activeTabRef = _useContext.activeTabRef,
      activeValue = _useContext.activeValue,
      setValue = _useContext.setValue;

  var isActive = activeValue === value;
  return /*#__PURE__*/React__default.createElement(StyledTab, _objectSpread__default({
    ref: isActive ? activeTabRef : undefined,
    className: isActive ? 'active' : '',
    onClick: function onClick() {
      return setValue(value);
    }
  }, props), children);
};
Tab.propTypes = {
  value: _pt__default.string.isRequired
};

var Tabs = function Tabs(_ref2) {
  var _ref2$size = _ref2.size,
      size = _ref2$size === void 0 ? 'md' : _ref2$size,
      _ref2$type = _ref2.type,
      type = _ref2$type === void 0 ? 'line' : _ref2$type,
      children = _ref2.children,
      defaultValue = _ref2.defaultValue,
      value = _ref2.value,
      onChange = _ref2.onChange,
      otherProps = _objectWithoutProperties__default(_ref2, _excluded2);

  var tabsRef = React.useRef(null);
  var activeTabRef = React.useRef(null);

  var _useState = React.useState(defaultValue),
      _useState2 = _slicedToArray__default(_useState, 2),
      tabValue = _useState2[0],
      setTabValue = _useState2[1];

  var _useState3 = React.useState(true),
      _useState4 = _slicedToArray__default(_useState3, 2),
      immediate = _useState4[0],
      setImmediate = _useState4[1];

  var _useState5 = React.useState({
    offset: 0,
    width: 0
  }),
      _useState6 = _slicedToArray__default(_useState5, 2),
      springState = _useState6[0],
      setSpringState = _useState6[1];

  var activeValue = value || tabValue || '';
  var props = web.useSpring({
    immediate: immediate,
    width: springState.width,
    transform: "translateX(".concat(springState.offset, "px)")
  });
  React.useEffect(function () {
    if (springState.width !== 0) {
      setImmediate(false);
    }
  }, [springState.width]);
  React.useEffect(function () {
    if (type === 'line' && tabsRef.current && activeTabRef.current) {
      var tabsRect = tabsRef.current.getBoundingClientRect();
      var activeTabRect = activeTabRef.current.getBoundingClientRect();
      setSpringState({
        offset: activeTabRect.left - tabsRect.left,
        width: activeTabRect.width
      });
    }
  }, [type, activeValue]);
  return /*#__PURE__*/React__default.createElement(TabContext.Provider, {
    value: {
      activeTabRef: activeTabRef,
      activeValue: activeValue,
      setValue: function setValue(newValue) {
        setTabValue(newValue);

        if (onChange && newValue) {
          onChange(newValue);
        }
      }
    }
  }, /*#__PURE__*/React__default.createElement(StyledTabs, _objectSpread__default({
    ref: tabsRef,
    size: size,
    type: type
  }, otherProps), children, type === 'line' && /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(TabActiveLine, {
    style: props
  }), /*#__PURE__*/React__default.createElement(TabLine, null))));
};

Tabs.defaultProps = {
  size: 'md',
  type: 'line',
  defaultValue: ''
};
Tabs.Tab = Tab;

var Position = {
  TOP: 'top',
  TOP_LEFT: 'top-left',
  TOP_RIGHT: 'top-right',
  BOTTOM: 'bottom',
  BOTTOM_LEFT: 'bottom-left',
  BOTTOM_RIGHT: 'bottom-right',
  LEFT: 'left',
  RIGHT: 'right'
};

/**
 * Stacking order contains z-index values that are used through.
 * Note that the Stack component might increase the z-index for certain components.
 */
var StackingOrder = {
  /**
   * Used as the default for the StackingContext.
   */
  STACKING_CONTEXT: 5,

  /**
   * Used as the default for the Positioner.
   */
  POSITIONER: 10,

  /**
   * Used for the notification.
   */
  NOTIFICATION: 15,

  /**
   * Used for the Overlay and everything that's inside such as Dialog + SideSheet.
   */
  OVERLAY: 20,

  /**
   * Used for the toasts in the toaster. Appears on top of everything else.
   */
  MESSAGE: 30
};

/**
 * Context used to manage the layering of z-indexes of components.
 */

var StackingContext = /*#__PURE__*/React__default.createContext(StackingOrder.STACKING_CONTEXT);
StackingContext.displayName = 'StackingContext';

var Stack = function Stack(_ref) {
  var _ref$defaultOrder = _ref.defaultOrder,
      defaultOrder = _ref$defaultOrder === void 0 ? StackingOrder.STACKING_CONTEXT : _ref$defaultOrder,
      children = _ref.children;
  var previousOrder = React.useContext(StackingContext);
  var currentOrder = Math.max(defaultOrder, previousOrder);
  var nextOrder = currentOrder + 1;
  return /*#__PURE__*/React__default.createElement(StackingContext.Provider, {
    value: nextOrder
  }, children(currentOrder));
};

Stack.propTypes = {
  defaultOrder: _pt__default.number,
  children: _pt__default.func.isRequired
};

var portalContainer;

var canUseDom = function canUseDom() {
  return Boolean(typeof window !== 'undefined' && window.document && window.document.createElement);
};

var createMountNode = function createMountNode(zIndex) {
  var element = document.createElement('div');
  element.style.position = 'fixed';
  element.style.top = '0';
  element.style.left = '0';
  element.style.zIndex = String(zIndex);
  return element;
};

var Portal = function Portal(_ref) {
  var defaultOrder = _ref.defaultOrder,
      children = _ref.children;
  var elementRef = React.useRef();
  React.useEffect(function () {
    return function () {
      if (elementRef.current) {
        portalContainer.removeChild(elementRef.current);
      }
    };
  }, []);
  var getElement = React.useCallback(function (zIndex) {
    if (elementRef.current) {
      return elementRef.current;
    }

    if (!portalContainer) {
      portalContainer = document.createElement('div');
      portalContainer.setAttribute('portal-container', '');
      document.body.appendChild(portalContainer);
    }

    elementRef.current = createMountNode(zIndex || 5);
    portalContainer.appendChild(elementRef.current);
    return elementRef.current;
  }, []); // This fixes SSR

  if (!canUseDom()) {
    return null;
  }

  return /*#__PURE__*/React__default.createElement(Stack, {
    defaultOrder: defaultOrder
  }, function (stackingOrder) {
    return /*#__PURE__*/reactDom.createPortal(children, getElement(stackingOrder));
  });
};

Portal.propTypes = {
  defaultOrder: _pt__default.number
};

var makeRect = function makeRect(_ref, _ref2) {
  var width = _ref.width,
      height = _ref.height;
  var left = _ref2.left,
      top = _ref2.top;
  var ceiledLeft = Math.ceil(left);
  var ceiledTop = Math.ceil(top);
  return {
    width: width,
    height: height,
    left: ceiledLeft,
    top: ceiledTop,
    right: ceiledLeft + width,
    bottom: ceiledTop + height
  };
};

var flipHorizontal = function flipHorizontal(position) {
  switch (position) {
    case Position.TOP_LEFT:
      return Position.BOTTOM_LEFT;

    case Position.TOP:
    default:
      return Position.BOTTOM;

    case Position.TOP_RIGHT:
      return Position.BOTTOM_RIGHT;

    case Position.BOTTOM_LEFT:
      return Position.TOP_LEFT;

    case Position.BOTTOM:
      return Position.TOP;

    case Position.BOTTOM_RIGHT:
      return Position.TOP_RIGHT;
  }
};
/**
 * Function that returns if position is aligned on top.
 * @param {Position} position
 * @return {Boolean}
 */


var isAlignedOnTop = function isAlignedOnTop(position) {
  switch (position) {
    case Position.TOP_LEFT:
    case Position.TOP:
    case Position.TOP_RIGHT:
      return true;

    default:
      return false;
  }
};

var isAlignedHorizontal = function isAlignedHorizontal(position) {
  switch (position) {
    case Position.LEFT:
    case Position.RIGHT:
      return true;

    default:
      return false;
  }
};

var getFitsOnBottom = function getFitsOnBottom(rect, viewport, viewportOffset) {
  return rect.bottom < viewport.height - viewportOffset;
};

var getFitsOnTop = function getFitsOnTop(rect, viewportOffset) {
  return rect.top > viewportOffset;
};

var getFitsOnRight = function getFitsOnRight(rect, viewport, viewportOffset) {
  return rect.right < viewport.width - viewportOffset;
};

var getFitsOnLeft = function getFitsOnLeft(rect, viewportOffset) {
  return rect.left > viewportOffset;
};

var getTransformOrigin = function getTransformOrigin(_ref3) {
  var rect = _ref3.rect,
      position = _ref3.position,
      dimensions = _ref3.dimensions,
      targetCenter = _ref3.targetCenter;
  var centerY = Math.round(targetCenter - rect.top);

  if (position === Position.LEFT) {
    /* Syntax: x-offset | y-offset */
    return "".concat(dimensions.width, "px ").concat(centerY, "px");
  }

  if (position === Position.RIGHT) {
    /* Syntax: x-offset | y-offset */
    return "0px ".concat(centerY, "px");
  }

  var centerX = Math.round(targetCenter - rect.left);

  if (isAlignedOnTop(position)) {
    /* Syntax: x-offset | y-offset */
    return "".concat(centerX, "px ").concat(dimensions.height, "px ");
  }
  /* Syntax: x-offset | y-offset */


  return "".concat(centerX, "px 0px ");
};

function getRect(_ref4) {
  var position = _ref4.position,
      targetOffset = _ref4.targetOffset,
      dimensions = _ref4.dimensions,
      targetRect = _ref4.targetRect;
  var leftRect = targetRect.left + targetRect.width / 2 - dimensions.width / 2;
  var alignedTopY = targetRect.top - dimensions.height - targetOffset;
  var alignedBottomY = targetRect.bottom + targetOffset;
  var alignedRightX = targetRect.right - dimensions.width;
  var alignedLeftRightY = targetRect.top + targetRect.height / 2 - dimensions.height / 2;

  switch (position) {
    case Position.LEFT:
      return makeRect(dimensions, {
        left: targetRect.left - dimensions.width - targetOffset,
        top: alignedLeftRightY
      });

    case Position.RIGHT:
      return makeRect(dimensions, {
        left: targetRect.right + targetOffset,
        top: alignedLeftRightY
      });

    case Position.TOP:
      return makeRect(dimensions, {
        left: leftRect,
        top: alignedTopY
      });

    case Position.TOP_LEFT:
      return makeRect(dimensions, {
        left: targetRect.left,
        top: alignedTopY
      });

    case Position.TOP_RIGHT:
      return makeRect(dimensions, {
        left: alignedRightX,
        top: alignedTopY
      });

    default:
    case Position.BOTTOM:
      return makeRect(dimensions, {
        left: leftRect,
        top: alignedBottomY
      });

    case Position.BOTTOM_LEFT:
      return makeRect(dimensions, {
        left: targetRect.left,
        top: alignedBottomY
      });

    case Position.BOTTOM_RIGHT:
      return makeRect(dimensions, {
        left: alignedRightX,
        top: alignedBottomY
      });
  }
}

function getPosition(_ref5) {
  var position = _ref5.position,
      dimensions = _ref5.dimensions,
      targetRect = _ref5.targetRect,
      targetOffset = _ref5.targetOffset,
      viewport = _ref5.viewport,
      _ref5$viewportOffset = _ref5.viewportOffset,
      viewportOffset = _ref5$viewportOffset === void 0 ? 8 : _ref5$viewportOffset;
  var isHorizontal = isAlignedHorizontal(position); // Handle left and right positions

  if (isHorizontal) {
    var leftRect = getRect({
      position: Position.LEFT,
      dimensions: dimensions,
      targetRect: targetRect,
      targetOffset: targetOffset
    });
    var rightRect = getRect({
      position: Position.RIGHT,
      dimensions: dimensions,
      targetRect: targetRect,
      targetOffset: targetOffset
    });
    var fitsOnLeft = getFitsOnLeft(leftRect, viewportOffset);
    var fitsOnRight = getFitsOnRight(rightRect, viewport, viewportOffset);

    if (position === Position.LEFT) {
      if (fitsOnLeft) {
        return {
          position: position,
          rect: leftRect
        };
      }

      if (fitsOnRight) {
        return {
          position: Position.RIGHT,
          rect: rightRect
        };
      }
    }

    if (position === Position.RIGHT) {
      if (fitsOnRight) {
        return {
          position: position,
          rect: rightRect
        };
      }

      if (fitsOnLeft) {
        return {
          position: Position.LEFT,
          rect: leftRect
        };
      }
    } // Default to using the position with the most space


    var spaceRight = Math.abs(viewport.width - viewportOffset - rightRect.right);
    var spaceLeft = Math.abs(leftRect.left - viewportOffset);

    if (spaceRight < spaceLeft) {
      return {
        position: Position.RIGHT,
        rect: rightRect
      };
    }

    return {
      position: Position.LEFT,
      rect: leftRect
    };
  }

  var positionIsAlignedOnTop = isAlignedOnTop(position);
  var topRect;
  var bottomRect;

  if (positionIsAlignedOnTop) {
    topRect = getRect({
      position: position,
      dimensions: dimensions,
      targetRect: targetRect,
      targetOffset: targetOffset
    });
    bottomRect = getRect({
      position: flipHorizontal(position),
      dimensions: dimensions,
      targetRect: targetRect,
      targetOffset: targetOffset
    });
  } else {
    topRect = getRect({
      position: flipHorizontal(position),
      dimensions: dimensions,
      targetRect: targetRect,
      targetOffset: targetOffset
    });
    bottomRect = getRect({
      position: position,
      dimensions: dimensions,
      targetRect: targetRect,
      targetOffset: targetOffset
    });
  }

  var topRectFitsOnTop = getFitsOnTop(topRect, viewportOffset);
  var bottomRectFitsOnBottom = getFitsOnBottom(bottomRect, viewport, viewportOffset);

  if (positionIsAlignedOnTop) {
    if (topRectFitsOnTop) {
      return {
        position: position,
        rect: topRect
      };
    }

    if (bottomRectFitsOnBottom) {
      return {
        position: flipHorizontal(position),
        rect: bottomRect
      };
    }
  }

  if (!positionIsAlignedOnTop) {
    if (bottomRectFitsOnBottom) {
      return {
        position: position,
        rect: bottomRect
      };
    }

    if (topRectFitsOnTop) {
      return {
        position: flipHorizontal(position),
        rect: topRect
      };
    }
  } // Default to most spacious if there is no fit.


  var spaceBottom = Math.abs(viewport.height - viewportOffset - bottomRect.bottom);
  var spaceTop = Math.abs(topRect.top - viewportOffset);

  if (spaceBottom < spaceTop) {
    return {
      position: positionIsAlignedOnTop ? flipHorizontal(position) : position,
      rect: bottomRect
    };
  }

  return {
    position: positionIsAlignedOnTop ? position : flipHorizontal(position),
    rect: topRect
  };
}

function getFittedPosition(_ref6) {
  var position = _ref6.position,
      dimensions = _ref6.dimensions,
      targetRect = _ref6.targetRect,
      targetOffset = _ref6.targetOffset,
      viewport = _ref6.viewport,
      _ref6$viewportOffset = _ref6.viewportOffset,
      viewportOffset = _ref6$viewportOffset === void 0 ? 8 : _ref6$viewportOffset;

  var _getPosition = getPosition({
    position: position,
    dimensions: dimensions,
    targetRect: targetRect,
    targetOffset: targetOffset,
    viewport: viewport,
    viewportOffset: viewportOffset
  }),
      rect = _getPosition.rect,
      finalPosition = _getPosition.position; // Push rect to the right if overflowing on the left side of the viewport.


  if (rect.left < viewportOffset) {
    rect.right += Math.ceil(Math.abs(rect.left - viewportOffset));
    rect.left = Math.ceil(viewportOffset);
  } // Push rect to the left if overflowing on the right side of the viewport.


  if (rect.right > viewport.width - viewportOffset) {
    var delta = Math.ceil(rect.right - (viewport.width - viewportOffset));
    rect.left -= delta;
    rect.right -= delta;
  } // Push rect down if overflowing on the top side of the viewport.


  if (rect.top < viewportOffset) {
    rect.top += Math.ceil(Math.abs(rect.top - viewportOffset));
    rect.bottom = Math.ceil(viewportOffset);
  } // Push rect up if overflowing on the bottom side of the viewport.


  if (rect.bottom > viewport.height - viewportOffset) {
    var _delta = Math.ceil(rect.bottom - (viewport.height - viewportOffset));

    rect.top -= _delta;
    rect.right -= _delta;
  }

  var targetCenter = isAlignedHorizontal(position) ? targetRect.top + targetRect.height / 2 : targetRect.left + targetRect.width / 2;
  var transformOrigin = getTransformOrigin({
    rect: rect,
    position: finalPosition,
    dimensions: dimensions,
    targetCenter: targetCenter
  });
  return {
    rect: rect,
    position: finalPosition,
    transformOrigin: transformOrigin
  };
}

var StyledPositionerWrapper = styled__default.div.withConfig({
  componentId: "sc-12izl5s-0"
})(["position:absolute;top:0;left:0;will-change:transform;"]);
var targetOffset = 6;
var bodyOffset = 6;

var getPositionerProps = function getPositionerProps(_ref) {
  var position = _ref.position,
      positionerRef = _ref.positionerRef,
      positionerRect = _ref.positionerRect,
      targetRect = _ref.targetRect,
      entered = _ref.entered,
      prevDimensions = _ref.prevDimensions;

  if (!positionerRect) {
    return {
      positionerStyle: {
        visibility: 'hidden'
      }
    };
  }

  var height;
  var width;

  if (entered || !positionerRef.current) {
    height = Math.round(positionerRect.height);
    width = Math.round(positionerRect.width);
  } else {
    var prevHeight = prevDimensions.height,
        prevWidth = prevDimensions.width;
    height = Math.max(positionerRef.current.offsetHeight, prevHeight);
    width = Math.max(positionerRef.current.offsetWidth, prevWidth);
  }

  var viewportHeight = document.documentElement.clientHeight;
  var viewportWidth = document.documentElement.clientWidth;

  var _getPosition = getFittedPosition({
    position: position,
    targetRect: targetRect,
    targetOffset: targetOffset,
    dimensions: {
      height: height,
      width: width
    },
    viewport: {
      width: viewportWidth,
      height: viewportHeight
    },
    viewportOffset: bodyOffset
  }),
      rect = _getPosition.rect,
      transformOrigin = _getPosition.transformOrigin;

  return {
    positionerStyle: {
      transform: "translate3d(".concat(rect.left, "px, ").concat(rect.top, "px, 0px)")
    },
    transformOrigin: transformOrigin
  };
};

var PositionerImpl = function PositionerImpl(_ref2) {
  var style = _ref2.style,
      position = _ref2.position,
      positioner = _ref2.positioner,
      targetRef = _ref2.targetRef,
      positionerRefFromProps = _ref2.positionerRef;
  var prevDimensions = React.useRef({
    height: 0,
    width: 0
  });
  var positionerRefFromSelf = React.useRef(null);
  var positionerRef = React.useMemo(function () {
    return positionerRefFromProps || positionerRefFromSelf;
  }, [positionerRefFromProps]);
  var targetRect = rect.useRect(targetRef);
  var positionerRect = rect.useRect(positionerRef, {
    onChange: function onChange(rect) {
      prevDimensions.current = {
        height: rect.height,
        width: rect.width
      };
    }
  });

  if (!targetRect) {
    return null;
  }

  var _getPositionerProps = getPositionerProps({
    entered: style.opacity.get() === 1,
    position: position,
    positionerRef: positionerRef,
    positionerRect: positionerRect,
    targetRect: targetRect,
    prevDimensions: prevDimensions.current
  }),
      positionerStyle = _getPositionerProps.positionerStyle,
      transformOrigin = _getPositionerProps.transformOrigin;

  return /*#__PURE__*/React__default.createElement(StyledPositionerWrapper, {
    style: positionerStyle
  }, /*#__PURE__*/React__default.createElement(web.animated.div, {
    ref: positionerRef,
    style: _objectSpread__default(_objectSpread__default({}, style), {}, {
      transformOrigin: transformOrigin
    })
  }, positioner instanceof Function ? positioner({
    ref: positionerRef
  }) : positioner));
};

PositionerImpl.propTypes = {
  style: _pt__default.shape({}).isRequired
};

var Positioner = function Positioner(_ref) {
  var visible = _ref.visible,
      targetRefFromProps = _ref.targetRef,
      positionerRef = _ref.positionerRef,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? Position.TOP_RIGHT : _ref$position,
      children = _ref.children,
      positioner = _ref.positioner,
      onOpenComplete = _ref.onOpenComplete,
      onCloseComplete = _ref.onCloseComplete;
  var targetRefFromSelf = React.useRef(null);
  var targetRef = targetRefFromProps || targetRefFromSelf;
  React.useEffect(function () {
    var originalWarn = console.warn;

    console.warn = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (/You need to place the ref/.test(args[0])) {
        return;
      }

      originalWarn.call.apply(originalWarn, [console].concat(args));
    };

    return function () {
      console.warn = originalWarn;
    };
  }, []);
  var transition = web.useTransition(visible, {
    keys: function keys(value) {
      return value ? 'on' : 'off';
    },
    from: {
      opacity: 0,
      transform: 'scale(0.9)'
    },
    enter: {
      opacity: 1,
      transform: 'scale(1)'
    },
    leave: {
      opacity: 0,
      transform: 'scale(1)',
      pointerEvents: 'none'
    },
    onDestroyed: function onDestroyed(isDestroyed) {
      if (isDestroyed) {
        if (!visible && onCloseComplete) {
          onCloseComplete();
        }
      } else if (visible && onOpenComplete) {
        if (onOpenComplete) {
          onOpenComplete();
        }
      }
    },
    config: {
      mass: 1,
      tension: 500,
      friction: 40
    }
  });
  return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, children instanceof Function ? children({
    ref: targetRef
  }) : children, transition(function (style, item) {
    return item && /*#__PURE__*/React__default.createElement(Portal, {
      defaultOrder: StackingOrder.POSITIONER
    }, /*#__PURE__*/React__default.createElement(PositionerImpl, {
      style: style,
      positioner: positioner,
      position: position,
      targetRef: targetRef,
      positionerRef: positionerRef
    }));
  }));
};

Positioner.propTypes = {
  visible: _pt__default.bool,
  targetOffset: _pt__default.number,
  bodyOffset: _pt__default.number,
  onOpenComplete: _pt__default.func,
  onCloseComplete: _pt__default.func
};

var useHoverTrigger = function useHoverTrigger(_ref) {
  var visibleFromProps = _ref.visible,
      defaultVisible = _ref.defaultVisible,
      onVisibleChange = _ref.onVisibleChange,
      mouseEnterDelay = _ref.mouseEnterDelay,
      mouseLeaveDelay = _ref.mouseLeaveDelay;
  var cancelEnterDebounce = React.useRef();
  var cancelLeaveDebounce = React.useRef();

  var _useState = React.useState(defaultVisible),
      _useState2 = _slicedToArray__default(_useState, 2),
      visibleFromSelf = _useState2[0],
      setVisibleFromSelf = _useState2[1];

  var hasVisibleFromProps = typeof visibleFromProps !== 'undefined';
  var visible = hasVisibleFromProps ? visibleFromProps : visibleFromSelf;
  var open = React.useCallback(function () {
    if (onVisibleChange) {
      onVisibleChange(true);
    }

    if (!hasVisibleFromProps) {
      setVisibleFromSelf(true);
    }
  }, [hasVisibleFromProps, onVisibleChange]);
  var close = React.useCallback(function () {
    if (onVisibleChange) {
      onVisibleChange(false);
    }

    if (!hasVisibleFromProps) {
      setVisibleFromSelf(false);
    }
  }, [hasVisibleFromProps, onVisibleChange]);
  var handleOpen = React.useCallback(function () {
    if (cancelLeaveDebounce.current) {
      cancelLeaveDebounce.current();
      cancelLeaveDebounce.current = null;
    }

    if (mouseEnterDelay === 0) {
      open();
    } else {
      var debounced = debounce__default(open, mouseEnterDelay);
      debounced();
      cancelEnterDebounce.current = debounced.cancel;
    }
  }, [mouseEnterDelay, open]);
  var handleClose = React.useCallback(function () {
    if (cancelEnterDebounce.current) {
      cancelEnterDebounce.current();
      cancelEnterDebounce.current = null;
    }

    if (mouseLeaveDelay === 0) {
      close();
    } else {
      var debounced = debounce__default(close, mouseLeaveDelay);
      debounced();
      cancelLeaveDebounce.current = debounced.cancel;
    }
  }, [close, mouseLeaveDelay]);
  return {
    handleOpen: handleOpen,
    handleClose: handleClose,
    visible: visible
  };
};

// https://github.com/renatorib/react-powerplug/blob/master/src/utils/composeEvents.js
var mergeEventProps = function mergeEventProps() {
  for (var _len = arguments.length, objEvents = new Array(_len), _key = 0; _key < _len; _key++) {
    objEvents[_key] = arguments[_key];
  }

  return objEvents.reduce(function (allEvents, events) {
    var append = {};
    Object.keys(events).forEach(function (key) {
      append[key] = allEvents[key] ? // Already have this event: let's merge
      function () {
        events[key].apply(events, arguments);
        allEvents[key].apply(allEvents, arguments);
      } : // Don't have this event yet: just assign the event
      events[key];
    });
    return _objectSpread__default(_objectSpread__default({}, allEvents), append);
  });
};

function tuplify() {
  for (var _len = arguments.length, elements = new Array(_len), _key = 0; _key < _len; _key++) {
    elements[_key] = arguments[_key];
  }

  return elements;
}

var useMeasure = function useMeasure() {
  var targetRef = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  var measureRef = React.useRef(null);
  var ref = composeRefs.useComposedRefs(measureRef, targetRef);

  var _useState = React.useState({
    left: 0,
    top: 0,
    width: 0,
    height: 0,
    offsetWidth: 0,
    offsetHeight: 0
  }),
      _useState2 = _slicedToArray__default(_useState, 2),
      bounds = _useState2[0],
      set = _useState2[1];

  var _useState3 = React.useState(function () {
    return new ResizeObserver__default(function (_ref) {
      var _ref2 = _slicedToArray__default(_ref, 1),
          entry = _ref2[0];

      set({
        left: entry.contentRect.left,
        top: entry.contentRect.top,
        width: entry.contentRect.width,
        height: entry.contentRect.height,
        offsetWidth: entry.target.clientWidth,
        offsetHeight: entry.target.clientHeight
      });
    });
  }),
      _useState4 = _slicedToArray__default(_useState3, 1),
      ro = _useState4[0];

  React.useEffect(function () {
    if (measureRef.current) {
      ro.observe(measureRef.current);
    }

    return function () {
      return ro.disconnect();
    }; // eslint-disable-next-line react-hooks/exhaustive-deps
  }, []);
  return tuplify({
    ref: ref
  }, bounds);
};

var usePrevious = function usePrevious(value) {
  var ref = React.useRef();
  React.useEffect(function () {
    ref.current = value;
  }, [value]);
  return ref.current;
};

var useRenderChildren = function useRenderChildren(_ref) {
  var children = _ref.children,
      targetRef = _ref.targetRef,
      mergeProps = _ref.mergeProps;
  var renderChildren = React.useCallback(function () {
    if (children instanceof Function) {
      return children({
        ref: targetRef,
        bind: function bind(props) {
          return mergeEventProps(props, mergeProps);
        }
      });
    }

    if (! /*#__PURE__*/React.isValidElement(children)) {
      return children;
    }

    return /*#__PURE__*/React.cloneElement(children, _objectSpread__default({
      ref: targetRef
    }, mergeEventProps(children.props, mergeProps)));
  }, [children, mergeProps, targetRef]);
  return renderChildren;
};

var useTargetRef = function useTargetRef(_ref) {
  var children = _ref.children;
  var targetRefFromSelf = React.useRef(null);
  var targetRef = children && children.ref ? children.ref : targetRefFromSelf;
  return targetRef;
};

var text = system.compose(system.color, system.typography);
styled__default('span').withConfig({
  componentId: "kn4tt7-0"
})(text);

var heading = system.compose(text, system.space);
var headingStyles = styled.css(["margin:0;color:", ";font-weight:bold;line-height:1.5;", ";"], function (p) {
  return p.theme.colors.gray700;
}, heading);
var Hero = styled__default.h1.withConfig({
  componentId: "dh6qcl-0"
})(["font-size:", ";", ";"], polished.rem('32px'), headingStyles);
var H1 = styled__default.h1.withConfig({
  componentId: "dh6qcl-1"
})(["font-size:", ";", ";"], polished.rem('28px'), headingStyles);
var H2 = styled__default.h2.withConfig({
  componentId: "dh6qcl-2"
})(["font-size:", ";", ";"], polished.rem('24px'), headingStyles);
var H3 = styled__default.h3.withConfig({
  componentId: "dh6qcl-3"
})(["font-size:", ";", ";"], polished.rem('20px'), headingStyles);
var H4 = styled__default.h4.withConfig({
  componentId: "dh6qcl-4"
})(["font-size:", ";", ";"], polished.rem('18px'), headingStyles);
var H5 = styled__default.h5.withConfig({
  componentId: "dh6qcl-5"
})(["font-size:", ";", ";"], polished.rem('16px'), headingStyles);
var H6 = styled__default.h6.withConfig({
  componentId: "dh6qcl-6"
})(["font-size:", ";", ";"], polished.rem('14px'), headingStyles);
var Heading = {
  Hero: Hero,
  H1: H1,
  H2: H2,
  H3: H3,
  H4: H4,
  H5: H5,
  H6: H6
};

styled__default.div.withConfig({
  componentId: "x5yy4f-0"
})(["padding:", " ", ";border:", ";border-radius:", ";border-color:", ";background-color:", ";box-shadow:", ";color:", ";font-size:", ";text-align:left;white-space:nowrap;", " ", " ", ""], function (p) {
  return p.theme.space[2];
}, function (p) {
  return p.theme.space[3];
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.shadows.base;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
}, system.space, system.minWidth, system.minHeight);
styled__default.div.withConfig({
  componentId: "x5yy4f-1"
})(["margin-bottom:", ";"], function (p) {
  return p.theme.space[2];
});

var ClickOutsideContext = /*#__PURE__*/React.createContext({
  setHasChild: function setHasChild() {}
});
ClickOutsideContext.displayName = 'ClickOutsideContext';

({
  Wrapper: _pt__default.elementType,
  defaultVisible: _pt__default.bool,
  visible: _pt__default.bool,
  onVisibleChange: _pt__default.func,
  title: _pt__default.oneOfType([_pt__default.node, _pt__default.func]),
  content: _pt__default.oneOfType([_pt__default.node, _pt__default.func]).isRequired,
  onOpenComplete: _pt__default.func,
  onCloseComplete: _pt__default.func
});

var box = system__namespace.compose(system__namespace.gridArea, system__namespace.position, system__namespace.space, system__namespace.background, system__namespace.typography, system__namespace.color, system__namespace.border, system__namespace.shadow, system__namespace.layout, system__namespace.flexbox);
var Box = styled__default('div').withConfig({
  componentId: "sc-1nz5gok-0"
})({
  boxSizing: 'border-box'
}, box);

var Flex = styled__default('div').withConfig({
  componentId: "sc-69g3g9-0"
})({
  display: 'flex',
  boxSizing: 'border-box'
}, box);

var gridProps = system.compose(system.grid, box);
styled__default('div').withConfig({
  componentId: "sc-18523tx-0"
})({
  display: 'grid'
}, gridProps);

var UIDContext = /*#__PURE__*/React.createContext(function () {
  return 'tailor_uid_0';
});
UIDContext.displayName = 'UIDContext';

var FormFieldContext = /*#__PURE__*/React.createContext({
  invalid: false,
  labelId: undefined,
  setValue: function setValue() {},
  setLabelId: function setLabelId() {}
});
FormFieldContext.displayName = 'FormFieldContext';

styled__default.label.withConfig({
  componentId: "sc-1jr9qdq-0"
})(["display:block;margin-bottom:2px;padding-left:2px;color:", ";font-size:", ";letter-spacing:0.2px;", ""], function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  return p.required && styled.css(["&::after{content:'*';margin-left:", ";}"], p.theme.space[1]);
});
styled__default.div.withConfig({
  componentId: "sc-1jr9qdq-1"
})(["margin-top:2px;padding-left:2px;color:", ";font-size:", ";"], function (p) {
  return p.theme.colors.danger;
}, function (p) {
  return p.theme.fontSizes.sm;
});

({
  label: _pt__default.node,
  required: _pt__default.bool,
  validationMessage: _pt__default.node
});

var useFormField = function useFormField(_ref) {
  var id = _ref.id,
      value = _ref.value,
      defaultValue = _ref.defaultValue;

  var _useContext = React.useContext(FormFieldContext),
      invalid = _useContext.invalid,
      setValue = _useContext.setValue,
      setLabelId = _useContext.setLabelId,
      labelId = _useContext.labelId;

  React.useEffect(function () {
    if (id) {
      setLabelId(id);
    }
  }, [id, setLabelId]);
  React.useEffect(function () {
    var fieldValue = value || defaultValue;

    if (fieldValue) {
      setValue(fieldValue);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, []);
  return tuplify(invalid, id || labelId, setValue);
};

var StyledTooltip = styled__default.div.withConfig({
  componentId: "v1e2or-0"
})(["border-radius:", ";background-color:", ";color:", ";font-size:", ";white-space:nowrap;", ";"], function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return polished.rgba(p.theme.colors.gray800, 0.9);
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.fontSizes.sm;
}, system.space);
StyledTooltip.defaultProps = {
  p: 2
};

var _excluded$6 = ["content", "handleOpen", "handleClose", "Wrapper"];
var TooltipPopup = /*#__PURE__*/React.memo(function TooltipPopup(_ref) {
  var content = _ref.content,
      handleOpen = _ref.handleOpen,
      handleClose = _ref.handleClose,
      _ref$Wrapper = _ref.Wrapper,
      Wrapper = _ref$Wrapper === void 0 ? StyledTooltip : _ref$Wrapper,
      otherProps = _objectWithoutProperties__default(_ref, _excluded$6);

  return /*#__PURE__*/React__default.createElement(Wrapper, _objectSpread__default({
    onMouseEnter: handleOpen,
    onMouseLeave: handleClose
  }, otherProps), content);
});

var _excluded$5 = ["children", "Wrapper", "position", "content", "defaultVisible", "visible", "onVisibleChange", "mouseEnterDelay", "mouseLeaveDelay", "onOpenComplete", "onCloseComplete"];

var Tooltip$1 = function Tooltip(_ref) {
  var children = _ref.children,
      Wrapper = _ref.Wrapper,
      _ref$position = _ref.position,
      position = _ref$position === void 0 ? Position.TOP : _ref$position,
      content = _ref.content,
      _ref$defaultVisible = _ref.defaultVisible,
      defaultVisible = _ref$defaultVisible === void 0 ? false : _ref$defaultVisible,
      visibleFromProps = _ref.visible,
      onVisibleChange = _ref.onVisibleChange,
      _ref$mouseEnterDelay = _ref.mouseEnterDelay,
      mouseEnterDelay = _ref$mouseEnterDelay === void 0 ? 0 : _ref$mouseEnterDelay,
      _ref$mouseLeaveDelay = _ref.mouseLeaveDelay,
      mouseLeaveDelay = _ref$mouseLeaveDelay === void 0 ? 200 : _ref$mouseLeaveDelay,
      onOpenComplete = _ref.onOpenComplete,
      onCloseComplete = _ref.onCloseComplete,
      otherProps = _objectWithoutProperties__default(_ref, _excluded$5);

  var popupRef = React.useRef(null);
  var targetRef = useTargetRef({
    children: children
  });

  var _useHoverTrigger = useHoverTrigger({
    visible: visibleFromProps,
    defaultVisible: defaultVisible,
    onVisibleChange: onVisibleChange,
    mouseEnterDelay: mouseEnterDelay,
    mouseLeaveDelay: mouseLeaveDelay
  }),
      visible = _useHoverTrigger.visible,
      handleOpen = _useHoverTrigger.handleOpen,
      handleClose = _useHoverTrigger.handleClose;

  var renderChildren = useRenderChildren({
    targetRef: targetRef,
    children: children,
    mergeProps: {
      onMouseEnter: handleOpen,
      onMouseLeave: handleClose
    }
  });
  return /*#__PURE__*/React__default.createElement(Positioner, {
    positionerRef: popupRef,
    targetRef: targetRef,
    visible: visible,
    onOpenComplete: onOpenComplete,
    onCloseComplete: onCloseComplete,
    position: position,
    positioner: /*#__PURE__*/React__default.createElement(TooltipPopup, _objectSpread__default({
      Wrapper: Wrapper,
      content: content,
      handleOpen: handleOpen,
      handleClose: handleClose
    }, otherProps))
  }, renderChildren);
};

Tooltip$1.propTypes = {
  Wrapper: _pt__default.elementType,
  defaultVisible: _pt__default.bool,
  visible: _pt__default.bool,
  onVisibleChange: _pt__default.func,
  content: _pt__default.node.isRequired,
  mouseEnterDelay: _pt__default.number,
  mouseLeaveDelay: _pt__default.number,
  onOpenComplete: _pt__default.func,
  onCloseComplete: _pt__default.func
};

var _excluded$4 = ["children", "tooltipProps"];
var EllipsisText = styled__default.div.withConfig({
  componentId: "sc-15l93jq-0"
})(["width:100%;overflow-x:hidden;text-overflow:ellipsis;white-space:nowrap;"]);

var Ellipsis = function Ellipsis(_ref) {
  var children = _ref.children,
      _ref$tooltipProps = _ref.tooltipProps,
      tooltipProps = _ref$tooltipProps === void 0 ? {} : _ref$tooltipProps,
      props = _objectWithoutProperties__default(_ref, _excluded$4);

  var ref = React.useRef(null);
  var isTextOverflow = ref.current ? ref.current.scrollWidth > ref.current.offsetWidth : false;
  var Content = /*#__PURE__*/React__default.createElement(EllipsisText, _objectSpread__default({
    ref: ref
  }, props), children);
  return isTextOverflow ? /*#__PURE__*/React__default.createElement(Tooltip$1, _objectSpread__default({
    content: /*#__PURE__*/React__default.createElement(Box, {
      minWidth: "200px",
      maxWidth: "280px",
      style: {
        whiteSpace: 'pre-line',
        wordBreak: 'break-word'
      }
    }, children),
    position: Position.BOTTOM,
    mouseLeaveDelay: 0
  }, tooltipProps), Content) : Content;
};

var AnalyticsIcon$1 = function AnalyticsIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M7 19h1V6a2 2 0 1 1 4 0v13h1v-8a2 2 0 1 1 4 0v8h1v-2a2 2 0 1 1 4 0v2a2 2 0 0 1-2 2H5a2 2 0 0 1-2-2v-6a2 2 0 1 1 4 0v6z"
  }));
};

var DangerIcon = function DangerIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "32",
    height: "32",
    viewBox: "0 0 32 32"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M21.009 5.639l10.2 16.032c1.614 2.536.68 5.792-2.087 7.271a6.207 6.207 0 0 1-2.922.725H5.8c-3.204 0-5.8-2.38-5.8-5.317 0-.942.273-1.866.79-2.68L10.99 5.64c1.614-2.537 5.165-3.393 7.932-1.914a5.583 5.583 0 0 1 2.087 1.914zm-6.787 3.583v8.968c0 .4.07.687.2.932.131.244.323.436.568.567.244.13.531.2.932.2h.156c.4 0 .688-.07.932-.2.245-.131.437-.323.567-.567.131-.245.2-.532.2-.932V9.222h-3.555zm1.7 12.445c-.4 0-.688.07-.932.2-.245.13-.437.323-.567.567-.131.244-.2.532-.2.932v.157c0 .4.069.687.2.932.13.244.322.436.567.567.244.13.531.2.932.2h.156c.4 0 .688-.07.932-.2.245-.13.437-.323.567-.567.131-.245.2-.532.2-.932v-.157c0-.4-.069-.688-.2-.932a1.363 1.363 0 0 0-.567-.567c-.244-.13-.531-.2-.932-.2h-.156z"
  }));
};

var InfoIcon = function InfoIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "32",
    height: "32",
    viewBox: "0 0 32 32"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M9 1h14a8 8 0 0 1 8 8v14a8 8 0 0 1-8 8H9a8 8 0 0 1-8-8V9a8 8 0 0 1 8-8zm6.5 12a1.5 1.5 0 0 0-1.5 1.5V25h4V14.5a1.5 1.5 0 0 0-1.5-1.5h-1zm0-6A1.5 1.5 0 0 0 14 8.5v1a1.5 1.5 0 0 0 1.5 1.5h1A1.5 1.5 0 0 0 18 9.5v-1A1.5 1.5 0 0 0 16.5 7h-1z"
  }));
};

var KuratorIcon = function KuratorIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "https://www.w3.org/2000/svg",
    xmlnsXlink: "https://www.w3.org/1999/xlink",
    viewBox: "0 0 48 48"
  }, /*#__PURE__*/React__default.createElement("title", null, "Kurator Icon"), /*#__PURE__*/React__default.createElement("defs", null, /*#__PURE__*/React__default.createElement("path", {
    id: "kurator_a",
    d: "M39.367 5a5.64 5.64 0 0 0-5.502 6.84l-7.229 3.617a5.62 5.62 0 0 0-4.26-1.955 5.64 5.64 0 0 0-5.633 5.636 5.64 5.64 0 0 0 5.633 5.636c.441 0 .87-.053 1.283-.15l3.46 5.194a5.624 5.624 0 0 0-1.8 5.137l-10.285 1.716a5.642 5.642 0 0 0-5.401-4.04A5.64 5.64 0 0 0 4 38.268a5.64 5.64 0 0 0 5.633 5.636c2.696 0 4.955-1.905 5.504-4.441l11.364-1.896a5.622 5.622 0 0 0 4.37 2.086 5.64 5.64 0 0 0 5.634-5.636 5.64 5.64 0 0 0-5.634-5.635c-.441 0-.87.053-1.282.149l-3.46-5.194a5.623 5.623 0 0 0 1.749-5.402l7.229-3.617a5.618 5.618 0 0 0 4.26 1.955A5.64 5.64 0 0 0 45 10.636 5.64 5.64 0 0 0 39.367 5zM9.633 41.133a2.868 2.868 0 0 1-2.863-2.866 2.868 2.868 0 0 1 2.863-2.866 2.867 2.867 0 0 1 2.862 2.866 2.868 2.868 0 0 1-2.862 2.866zm24.102-7.117a2.868 2.868 0 0 1-2.864 2.866 2.867 2.867 0 0 1-2.862-2.866 2.867 2.867 0 0 1 2.862-2.865 2.868 2.868 0 0 1 2.864 2.865zM19.513 19.138a2.867 2.867 0 0 1 2.863-2.866 2.867 2.867 0 0 1 2.863 2.866 2.867 2.867 0 0 1-2.863 2.866 2.867 2.867 0 0 1-2.863-2.866zm19.854-5.636a2.867 2.867 0 0 1-2.862-2.866 2.867 2.867 0 0 1 2.862-2.866 2.867 2.867 0 0 1 2.863 2.866 2.868 2.868 0 0 1-2.863 2.866z"
  })), /*#__PURE__*/React__default.createElement("g", {
    fillRule: "evenodd"
  }, /*#__PURE__*/React__default.createElement("mask", {
    id: "kurator_b",
    fill: "#fff"
  }, /*#__PURE__*/React__default.createElement("use", {
    xlinkHref: "#kurator_a"
  })), /*#__PURE__*/React__default.createElement("use", {
    fill: "#000",
    fillRule: "nonzero",
    xlinkHref: "#kurator_a"
  }), /*#__PURE__*/React__default.createElement("g", {
    stroke: "#0C0D19",
    mask: "url(#kurator_b)"
  }, /*#__PURE__*/React__default.createElement("path", {
    d: "M-.5-.5h49v49h-49z"
  }))));
};

var LineIcon = function LineIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("g", {
    fill: "none",
    fillRule: "nonzero"
  }, /*#__PURE__*/React__default.createElement("path", {
    fill: "#00B900",
    d: "M5.343.127h13.488a5.157 5.157 0 0 1 5.157 5.157v13.488a5.157 5.157 0 0 1-5.157 5.157H5.343a5.157 5.157 0 0 1-5.157-5.157V5.284A5.157 5.157 0 0 1 5.343.127z"
  }), /*#__PURE__*/React__default.createElement("path", {
    fill: "#FFF",
    d: "M20.715 10.98c0-3.877-3.887-7.03-8.665-7.03-4.779 0-8.666 3.153-8.666 7.03 0 3.478 3.082 6.39 7.247 6.943.282.061.667.186.764.428.068.256.077.524.028.784l-.123.741c-.038.219-.175.857.75.466.924-.39 4.99-2.937 6.809-5.03 1.255-1.378 1.856-2.776 1.856-4.328"
  }), /*#__PURE__*/React__default.createElement("path", {
    fill: "#00B900",
    d: "M10.288 9.106h-.607a.169.169 0 0 0-.168.169v3.768a.169.169 0 0 0 .168.169h.607a.169.169 0 0 0 .169-.169V9.275a.169.169 0 0 0-.169-.169M14.48 9.106h-.616a.169.169 0 0 0-.168.169v2.243l-1.73-2.337-.014-.015-.012-.01H11.25a.169.169 0 0 0-.168.168v3.769a.169.169 0 0 0 .168.168h.61a.169.169 0 0 0 .168-.168v-2.285l1.733 2.34c.011.017.025.031.042.042h.022c.014.002.029.002.043 0h.611a.169.169 0 0 0 .169-.169V9.253a.169.169 0 0 0-.169-.169M8.824 12.274H7.172v-3a.169.169 0 0 0-.168-.168h-.61a.169.169 0 0 0-.168.169v3.768c0 .044.017.086.048.117.031.03.073.048.117.048h2.43a.169.169 0 0 0 .168-.169v-.609a.169.169 0 0 0-.169-.168M17.83 10.052a.169.169 0 0 0 .168-.168v-.607a.169.169 0 0 0-.169-.17h-2.427a.175.175 0 0 0-.117.047.17.17 0 0 0-.046.115v3.768c0 .044.016.085.046.117.03.031.073.048.117.048h2.427a.169.169 0 0 0 .169-.169v-.609a.169.169 0 0 0-.169-.168h-1.652v-.637h1.652a.17.17 0 0 0 .169-.17v-.607a.169.169 0 0 0-.169-.169h-1.652v-.639l1.652.018z"
  })));
};

var MessengerIcon$1 = function MessengerIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("defs", null, /*#__PURE__*/React__default.createElement("linearGradient", {
    id: "a",
    x1: "50%",
    x2: "50%",
    y1: "0%",
    y2: "100.001%"
  }, /*#__PURE__*/React__default.createElement("stop", {
    offset: "0%",
    stopColor: "#00B2FF"
  }), /*#__PURE__*/React__default.createElement("stop", {
    offset: "100%",
    stopColor: "#006AFF"
  }))), /*#__PURE__*/React__default.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /*#__PURE__*/React__default.createElement("path", {
    fill: "url(#a)",
    d: "M12 .012c-6.76 0-12 4.952-12 11.64 0 3.499 1.434 6.522 3.769 8.61.196.177.314.42.324.684l.065 2.134a.962.962 0 0 0 1.347.85l2.38-1.05a.958.958 0 0 1 .64-.049c1.094.302 2.26.462 3.475.462 6.76 0 12-4.953 12-11.64C24 4.963 18.76.012 12 .012z"
  }), /*#__PURE__*/React__default.createElement("path", {
    fill: "#FFF",
    d: "M4.795 15.057L8.32 9.465a1.802 1.802 0 0 1 2.603-.48l2.803 2.102a.72.72 0 0 0 .867-.002l3.786-2.873c.505-.384 1.166.222.826.758l-3.523 5.59a1.802 1.802 0 0 1-2.603.48l-2.803-2.103a.72.72 0 0 0-.867.002l-3.788 2.876c-.505.384-1.166-.222-.826-.758z"
  })));
};

var OpenInNewIcon = function OpenInNewIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "evenodd",
    clipRule: "evenodd",
    d: "M15.9931 17.9913H6.99875V8.99688H11.7558L13.7545 6.99813H5.99938C5.44972 6.99813 5 7.44785 5 7.9975V18.9906C5 19.5403 5.44972 19.99 5.99938 19.99H16.9925C17.5422 19.99 17.9919 19.5403 17.9919 18.9906V11.2455L15.9931 13.2442V17.9913ZM19.9906 4H14.9938C14.4441 4 13.9944 4.44972 13.9944 4.99938C13.9944 5.54903 14.4441 5.99875 14.9938 5.99875H17.5821L12.2954 11.2854C12.1056 11.4753 11.9956 11.7252 11.9956 11.995C11.9956 12.5447 12.4453 12.9944 12.995 12.9944C13.2748 12.9944 13.5247 12.8844 13.7046 12.7046L18.9913 7.41786V10.0062C18.9913 10.5559 19.441 11.0056 19.9906 11.0056C20.5403 11.0056 20.99 10.5559 20.99 10.0062V5.00937C20.99 4.44972 20.5403 4 19.9906 4Z"
  }));
};

var MessengerIcon = function MessengerIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M9 19l-5 4V7a2 2 0 0 1 2-2h12a2 2 0 0 1 2 2v10a2 2 0 0 1-2 2H9zM2 8h1v8H2a1 1 0 0 1-1-1V9a1 1 0 0 1 1-1zm19 0h1a1 1 0 0 1 1 1v6a1 1 0 0 1-1 1h-1V8zM8.5 12a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zm7 0a1.5 1.5 0 1 0 0-3 1.5 1.5 0 0 0 0 3zM11 14a1 1 0 0 0 0 2h2a1 1 0 0 0 0-2h-2zm.5-12h1A1.5 1.5 0 0 1 14 3.5V4h-4v-.5A1.5 1.5 0 0 1 11.5 2z"
  }));
};

var SettingsIcon = function SettingsIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M5.964 9.5l-1.83-1.83a1.25 1.25 0 0 1 0-1.768l1.768-1.768a1.25 1.25 0 0 1 1.767 0L9.5 5.964V3.25c0-.69.56-1.25 1.25-1.25h2.5c.69 0 1.25.56 1.25 1.25v2.803l2.008-2.008a1.25 1.25 0 0 1 1.768 0l1.768 1.768a1.25 1.25 0 0 1 0 1.768L18.124 9.5h2.626c.69 0 1.25.56 1.25 1.25v2.5c0 .69-.56 1.25-1.25 1.25h-2.714l2.008 2.008a1.25 1.25 0 0 1 0 1.768l-1.768 1.768a1.25 1.25 0 0 1-1.768 0L14.5 18.036v2.714c0 .69-.56 1.25-1.25 1.25h-2.5c-.69 0-1.25-.56-1.25-1.25v-2.626l-1.83 1.831a1.25 1.25 0 0 1-1.768 0l-1.768-1.768a1.25 1.25 0 0 1 0-1.768l1.92-1.919H3.25c-.69 0-1.25-.56-1.25-1.25v-2.5c0-.69.56-1.25 1.25-1.25h2.714zm6.036 6a3.5 3.5 0 1 0 0-7 3.5 3.5 0 0 0 0 7zm0-1.5a2 2 0 1 1 0-4 2 2 0 0 1 0 4z"
  }));
};

var SuccessIcon = function SuccessIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "32",
    height: "32",
    viewBox: "0 0 32 32"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M16 31C7.716 31 1 24.284 1 16 1 7.716 7.716 1 16 1c8.284 0 15 6.716 15 15 0 8.284-6.716 15-15 15zm6.113-20.19l-9.066 8.73-3.017-3.586a2 2 0 0 0-3.06 2.576l3.705 4.403a3 3 0 0 0 4.227.364c.076-.066.076-.066.15-.135l9.835-9.471a2 2 0 1 0-2.774-2.882z"
  }));
};

var TagsIcon = function TagsIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "https://www.w3.org/2000/svg",
    xmlnsXlink: "https://www.w3.org/1999/xlink",
    viewBox: "0 0 48 48"
  }, /*#__PURE__*/React__default.createElement("title", null, "Tags Icon"), /*#__PURE__*/React__default.createElement("defs", null, /*#__PURE__*/React__default.createElement("path", {
    d: "M15.6726835,15.4500602 C16.4588888,16.2202205 16.8519856,17.1588392 16.8519856,18.2659446 C16.8519856,19.3730501 16.4588888,20.3196912 15.6726835,21.1058965 C14.8864782,21.8921018 13.9478594,22.2851986 12.856799,22.2851986 C11.7657386,22.2851986 10.8271199,21.8921018 10.0409146,21.1058965 C9.25470927,20.3196912 8.86161252,19.3730501 8.86161252,18.2659446 C8.86161252,17.1588392 9.25470927,16.2202205 10.0409146,15.4500602 C10.8271199,14.6798999 11.7657386,14.2948255 12.856799,14.2948255 C13.9478594,14.2948255 14.8864782,14.6798999 15.6726835,15.4500602 Z M13.5306859,18.9638989 C13.723226,18.7713588 13.8194946,18.5467321 13.8194946,18.290012 C13.8194946,18.0332919 13.723226,17.8086652 13.5306859,17.6161252 C13.3381458,17.4235851 13.1135191,17.3273165 12.856799,17.3273165 C12.6000789,17.3273165 12.3754522,17.4235851 12.1829122,17.6161252 C11.9903721,17.8086652 11.8941035,18.0332919 11.8941035,18.290012 C11.8941035,18.5467321 11.9903721,18.7713588 12.1829122,18.9638989 C12.3754522,19.156439 12.6000789,19.2527076 12.856799,19.2527076 C13.1135191,19.2527076 13.3381458,19.156439 13.5306859,18.9638989 Z M43.1817088,27.0505415 C43.727239,27.6281617 44,28.326109 44,29.1444043 C44,29.9626996 43.7111942,30.6446022 43.133574,31.1901324 L33.0252708,41.2021661 C32.4155605,41.7797863 31.7095909,42.0685921 30.9073406,42.0685921 C30.1050903,42.0685921 29.3991206,41.7797863 28.7894103,41.2021661 L27.4416366,39.8543923 L26.0938628,41.2021661 C25.4841526,41.7797863 24.7701605,42.0685921 23.9518652,42.0685921 C23.1335699,42.0685921 22.4356226,41.7797863 21.8580024,41.2021661 L4.57761733,24.1624549 C4.19253718,23.7452847 4,23.2639418 4,22.7184116 L4,11.9362214 C4,11.1339711 4.28880578,10.4440462 4.86642599,9.86642599 C5.44404621,9.28880578 6.15001588,9 6.9843562,9 L24.4091456,9 C24.9867658,9 25.4681088,9.20858195 25.8531889,9.62575211 L43.1817088,27.0505415 Z M36.2021661,31.1901324 L29.6077016,37.7364621 L30.9073406,38.9879663 L40.9193742,29.1203369 L24.0240674,12.032491 L21.3285199,12.032491 L36.2021661,27.0505415 C36.7797863,27.6281617 37.0685921,28.326109 37.0685921,29.1444043 C37.0685921,29.9626996 36.7797863,30.6446022 36.2021661,31.1901324 Z M7.03249097,22.2851986 L23.9759326,38.9879663 L25.4681107,37.4957882 L27.2490975,35.7629362 L33.9879663,29.1203369 L17.0926594,12.032491 L7.03249097,12.032491 L7.03249097,22.2851986 Z",
    id: "tags_a"
  })), /*#__PURE__*/React__default.createElement("g", {
    fillRule: "evenodd"
  }, /*#__PURE__*/React__default.createElement("mask", {
    id: "tags_b",
    fill: "white"
  }, /*#__PURE__*/React__default.createElement("use", {
    xlinkHref: "#tags_a"
  })), /*#__PURE__*/React__default.createElement("use", {
    fill: "#000000",
    xlinkHref: "#tags_a"
  }), /*#__PURE__*/React__default.createElement("g", {
    mask: "url(#tags_b)"
  }, /*#__PURE__*/React__default.createElement("rect", {
    id: "Rectangle",
    x: "0",
    y: "0",
    width: "48",
    height: "48"
  }))));
};

var TouchIcon = function TouchIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M6.444 14.009v6.95a1.111 1.111 0 0 1-2.222 0v-6.95H4a2 2 0 0 1-2-2v-3a2 2 0 0 1 2-2h2.444v7zm1.112-7l9.743-3.857a1 1 0 0 1 1.368.93v12.916a1 1 0 0 1-1.368.93L7.556 14.07V7.009zm12.222.133c1.227 0 2.222.995 2.222 2.222v2.352a2.222 2.222 0 0 1-2.222 2.222V7.142z"
  }));
};

var AnalyticsIcon = function AnalyticsIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "24",
    height: "24",
    viewBox: "0 0 24 24"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M4 19.824V4.353C4 3.053 4.995 2 6.222 2h12.139c.307 0 .556.263.556.588 0 .325-.25.588-.556.588H7.222c-.613 0-1.11.527-1.11 1.177s.526 1.176 1.176 1.176h11.156c.614 0 1.112.527 1.112 1.177v13.118c0 .65-.498 1.176-1.112 1.176H5.111C4.497 21 4 20.473 4 19.824zm6.712-5.659c0 .518.29.914.87.914.546 0 .718-.331.942-.763.204-.51.46-.762 1-1.194.798-.604 1.476-1.201 1.476-2.439C15 8.986 13.716 8 11.885 8c-1.028 0-1.805.295-2.292.755C9.23 9.101 9 9.554 9 10c0 .439.257.82.757.82.303 0 .481-.137.705-.388.31-.44.705-.648 1.219-.648.625 0 1.185.381 1.185 1.036 0 .597-.408.92-.988 1.403-.817.676-1.166 1.173-1.166 1.942zm-.296 2.842c0 .69.52 1.137 1.153 1.137.632 0 1.146-.446 1.146-1.137 0-.69-.514-1.137-1.146-1.137-.633 0-1.153.446-1.153 1.137z"
  }));
};

var UnderstoodIcon = function UnderstoodIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "https://www.w3.org/2000/svg",
    xmlnsXlink: "https://www.w3.org/1999/xlink",
    viewBox: "0 0 48 48"
  }, /*#__PURE__*/React__default.createElement("title", null, "Understood Icon"), /*#__PURE__*/React__default.createElement("defs", null, /*#__PURE__*/React__default.createElement("path", {
    id: "understood_a",
    d: "M44.19 27.947l-3.358-6.718c-.175-11.063-10.26-19.586-21.619-17.38-7.11 1.382-12.775 7.101-14.096 14.232-.93 5.02.187 10.013 3.144 14.059 2.415 3.303 3.744 7.266 3.745 11.159 0 .663.537 1.201 1.2 1.201h16.817c.664 0 1.201-.538 1.201-1.201v-3.14c0-.344.28-.624.625-.624h5.381a3.608 3.608 0 0 0 3.604-3.604v-3.603h.65c1.056 0 2.019-.537 2.574-1.436.556-.899.605-2 .133-2.945zm-2.175 1.682a.616.616 0 0 1-.532.297h-1.85c-.664 0-1.201.537-1.201 1.2v4.806c0 .662-.54 1.2-1.202 1.2h-5.38a3.03 3.03 0 0 0-3.028 3.028v1.938H14.371c-.245-4.004-1.704-8.002-4.17-11.376-2.564-3.507-3.53-7.84-2.722-12.203 1.143-6.169 6.043-11.116 12.192-12.31 9.86-1.916 18.76 5.51 18.76 15.308 0 .187.044.37.127.537l3.484 6.968a.616.616 0 0 1-.027.607zM22.816 10.707c-5.96 0-10.81 4.85-10.81 10.81 0 5.961 4.85 10.811 10.81 10.811 5.961 0 10.81-4.85 10.81-10.81 0-5.962-4.849-10.811-10.81-10.811zm0 19.219c-4.636 0-8.408-3.772-8.408-8.409 0-4.636 3.772-8.408 8.408-8.408 4.636 0 8.408 3.772 8.408 8.408 0 4.637-3.772 8.409-8.408 8.409zm5.654-11.66a1.2 1.2 0 0 0-1.698 0l-5.157 5.156-2.754-2.754a1.201 1.201 0 1 0-1.699 1.699l3.604 3.603a1.197 1.197 0 0 0 1.698 0l6.006-6.006c.47-.469.47-1.23 0-1.698z"
  })), /*#__PURE__*/React__default.createElement("g", {
    fillRule: "evenodd"
  }, /*#__PURE__*/React__default.createElement("mask", {
    id: "understood_b",
    fill: "#fff"
  }, /*#__PURE__*/React__default.createElement("use", {
    xlinkHref: "#understood_a"
  })), /*#__PURE__*/React__default.createElement("use", {
    fill: "#000",
    fillRule: "nonzero",
    xlinkHref: "#understood_a"
  }), /*#__PURE__*/React__default.createElement("g", {
    stroke: "#0C0D19",
    mask: "url(#understood_b)"
  }, /*#__PURE__*/React__default.createElement("path", {
    d: "M-.5-.5h49v49h-49z"
  }))));
};

var WarningIcon = function WarningIcon() {
  return /*#__PURE__*/React__default.createElement("svg", {
    xmlns: "http://www.w3.org/2000/svg",
    width: "32",
    height: "32",
    viewBox: "0 0 32 32"
  }, /*#__PURE__*/React__default.createElement("path", {
    fillRule: "nonzero",
    d: "M20.566 3.47l7.964 7.964c1.587 1.588 1.998 2.329 2.268 3.22.27.89.27 1.801 0 2.692-.27.891-.68 1.632-2.268 3.22l-7.964 7.964c-1.588 1.587-2.329 1.998-3.22 2.268-.89.27-1.801.27-2.692 0-.891-.27-1.632-.68-3.22-2.268L3.47 20.566c-1.587-1.588-1.998-2.329-2.268-3.22a4.577 4.577 0 0 1 0-2.692c.27-.891.68-1.632 2.268-3.22l7.964-7.964c1.588-1.587 2.329-1.998 3.22-2.268.89-.27 1.801-.27 2.692 0 .891.27 1.632.68 3.22 2.268zM14 7v10.215c0 .503.07.773.2 1.018.131.244.323.436.567.567.245.13.515.2 1.018.2h.43c.503 0 .773-.07 1.018-.2.244-.131.436-.323.567-.567.13-.245.2-.515.2-1.018V7h-4zm1.785 14c-.503 0-.773.07-1.018.2-.244.131-.436.323-.567.567-.13.245-.2.515-.2 1.018v.43c0 .503.07.773.2 1.018.131.244.323.436.567.567.245.13.515.2 1.018.2h.43c.503 0 .773-.07 1.018-.2.244-.131.436-.323.567-.567.13-.245.2-.515.2-1.018v-.43c0-.503-.07-.773-.2-1.018a1.363 1.363 0 0 0-.567-.567c-.245-.13-.515-.2-1.018-.2h-.43z"
  }));
};

var icons = {
  line: LineIcon,
  messenger: MessengerIcon$1,
  info: InfoIcon,
  success: SuccessIcon,
  warning: WarningIcon,
  danger: DangerIcon,
  error: DangerIcon,
  robot: MessengerIcon,
  understood: UnderstoodIcon,
  kurator: KuratorIcon,
  touch: TouchIcon,
  analytics: AnalyticsIcon$1,
  tags: TagsIcon,
  settings: SettingsIcon,
  tutorial: AnalyticsIcon,
  'open-in-new': OpenInNewIcon
};

var _excluded$3 = ["type", "cursor", "size"];
var styledFill = system.style({
  prop: 'fill',
  cssProperty: 'fill',
  key: 'colors'
});
var styledSize = styled.css(["width:", "px;height:", "px;"], function (p) {
  return p.size;
}, function (p) {
  return p.size;
});
var IconWrapper = styled__default.i.withConfig({
  componentId: "sc-10g5g0q-0"
})(["display:inline-flex;line-height:1;cursor:", ";pointer-events:", ";svg{fill:", ";vertical-align:middle;pointer-events:none;", ";}&&& svg{", ";", ";}", ";"], function (p) {
  return p.cursor;
}, function (p) {
  return p.pointerEvents;
}, function (p) {
  return p.theme.colors.gray500;
}, function (p) {
  return p.theme.transition;
}
/* sc-declaration */
, styledFill, styledSize, system.space);
var Icon = /*#__PURE__*/React.forwardRef(function Icon(_ref, ref) {
  var type = _ref.type,
      _ref$cursor = _ref.cursor,
      cursor = _ref$cursor === void 0 ? 'default' : _ref$cursor,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? 24 : _ref$size,
      otherProps = _objectWithoutProperties__default(_ref, _excluded$3);

  var IconComponent;

  if (typeof type === 'string') {
    var BuiltInIcon = icons[type];

    if (!BuiltInIcon) {
      console.error('Built-in icon does not exists!');
      return null;
    }

    IconComponent = BuiltInIcon;
  } else {
    IconComponent = type;
  }

  return /*#__PURE__*/React__default.createElement(IconWrapper, _objectSpread__default({
    ref: ref,
    cursor: cursor,
    size: size
  }, otherProps), /*#__PURE__*/React__default.createElement(IconComponent, null));
});

var en_US = {
  locale: 'en_US',
  DatePicker: DatePicker__default,
  Modal: {
    confirmText: 'Confirm',
    cancelText: 'Cancel'
  },
  Popconfirm: {
    confirmText: 'Confirm',
    cancelText: 'Cancel'
  },
  Select: {
    noDataText: 'No data'
  },
  Upload: {
    uploadText: 'Click to Upload',
    uploadingText: 'Uploading...',
    uploadedText: 'Upload Completed!',
    failedText: 'Upload Failed!'
  }
};

/* eslint camelcase: off */
var LocaleContext = /*#__PURE__*/React.createContext({
  locale: en_US
});
LocaleContext.displayName = 'LocaleContext';

var useLocale = function useLocale() {
  return React.useContext(LocaleContext);
};

styled__default.div.withConfig({
  componentId: "sc-1tmvtys-0"
})(["display:inline-flex;cursor:pointer;"]);
var StyledSelectOption = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-1"
})(["display:flex;position:absolute;top:0;left:0;align-items:center;width:100%;padding:0 24px;background-color:", ";color:", ";font-size:", ";cursor:", ";"], function (p) {
  return p.hovered ? p.theme.colors.primaryLight : p.theme.colors.light;
}, function (p) {
  if (p.hovered) {
    return p.theme.colors.light;
  }

  if (p.active) {
    return p.theme.colors.primaryLight;
  }

  if (p.disabled) {
    return p.theme.colors.gray300;
  }

  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  return p.disabled ? 'not-allowed' : 'pointer';
});
var StyledSelectedOption = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-2"
})(["display:inline-flex;align-items:center;max-width:100%;min-height:calc(", " - 10px);margin-top:2px;margin-right:8px;margin-bottom:2px;padding:0 8px;border:", ";border-radius:", ";border-color:", ";background-color:", ";color:", ";font-size:", ";> span{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;}svg{fill:", ";}&:hover svg{fill:", ";}"], function (p) {
  return p.theme.heights.base;
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.colors.surface2;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  return p.theme.colors.primaryLight2;
}, function (p) {
  return p.theme.colors.primaryLight;
});
var StyledSelect = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-3"
})(["display:inline-flex;align-items:center;width:100%;max-width:100%;min-height:", ";padding-top:", ";padding-right:", ";padding-bottom:", ";padding-left:", ";border:", ";border-radius:", ";border-color:", ";outline:none;background-color:", ";color:", ";line-height:", ";cursor:pointer;appearance:none;&:hover{border-color:", ";}", " ", " ", " input{flex:1;width:100%;overflow:hidden;border:none;outline:none;background-color:transparent;font-size:", ";text-overflow:ellipsis;pointer-events:none;&::placeholder{color:", ";}}", ";"], function (p) {
  return p.theme.heights.base;
}, function (p) {
  return p.multiple ? '2px' : '4px';
}, function (p) {
  return p.theme.paddings.sm;
}, function (p) {
  return p.multiple ? '0' : '4px';
}, function (p) {
  return p.theme.paddings.sm;
}, function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.base;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.lineHeight;
}, function (p) {
  return p.theme.colors.primary;
}, function (p) {
  return p.focused && styled.css(["border-color:", ";"], p.theme.colors.primary);
}, function (p) {
  return p.invalid && styled.css(["border-color:", " !important;"], p.theme.colors.danger);
}, function (p) {
  return p.disabled && styled.css(["border-color:", ";background-color:", ";cursor:not-allowed;&:hover{border-color:", ";}input{color:", ";}", "{border-color:", ";background-color:", ";color:", ";pointer-events:none;}"], p.theme.colors.gray400, p.theme.colors.gray300, p.theme.colors.gray400, p.theme.colors.gray500, StyledSelectedOption, p.theme.colors.gray400, p.theme.colors.gray200, p.theme.colors.gray400);
}, function (p) {
  return p.theme.fontSizes.base;
}, function (p) {
  return p.theme.colors.gray400;
}, function (p) {
  return p.theme.transition;
});
var StyledPopover = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-4"
})(["position:relative;width:100%;max-height:182px;overflow-y:auto;border:", ";border-radius:", ";border-color:", ";box-shadow:", ";color:", ";font-size:", ";text-align:left;white-space:nowrap;"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return p.theme.colors.gray300;
}, function (p) {
  return p.theme.shadows.xl;
}, function (p) {
  return p.theme.colors.gray700;
}, function (p) {
  return p.theme.fontSizes.sm;
});
var spin = styled.keyframes(["0%{transform:rotate(0deg);}100%{transform:rotate(360deg);}"]);
var SelectLoading = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-5"
})(["flex:none;width:16px;height:16px;margin:2px;border:", ";border-radius:50%;border-color:", ";border-top-color:transparent;border-right-color:transparent;animation:", " 0.7s linear infinite;"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.colors.gray400;
}, spin);
var ClearIconWrapper = styled__default.i.withConfig({
  componentId: "sc-1tmvtys-6"
})(["position:absolute;z-index:1;width:22px;height:22px;padding:1px;border-radius:50%;opacity:0;background-color:", ";", ";"], function (p) {
  return p.theme.colors.gray200;
}, function (p) {
  return p.theme.transition;
});
var ArrowIconWrapper = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-7"
})(["width:20px;height:20px;margin:1px;transform:rotate(", "deg);", ";"], function (p) {
  return p.visible ? 0 : 180;
}, function (p) {
  return p.theme.transition;
});
var SelectSuffixWrapper = styled__default.div.withConfig({
  componentId: "sc-1tmvtys-8"
})(["display:inline-flex;position:relative;flex:none;width:22px;height:26px;padding:2px 0;&:hover ", "{opacity:1;}"], ClearIconWrapper);

var CREATE_OPTION = 'CREATE_OPTION';
var isObjectOption = function isObjectOption(item) {
  return _typeof__default(item) === 'object' && Boolean(item);
};
var isCreateOption = function isCreateOption(item) {
  return isObjectOption(item) && item.label === CREATE_OPTION;
};
var itemToString = function itemToString(item) {
  if (isObjectOption(item)) {
    return item.label;
  }

  if (item === null || typeof item === 'undefined') {
    return '';
  }

  return String(item);
};
var filter = function filter(items, input) {
  var wrappedItems = items.map(function (item) {
    return {
      key: itemToString(item),
      item: item
    };
  });
  return fuzzaldrin__default.filter(wrappedItems, input, {
    key: 'key'
  }).map(function (_ref) {
    var item = _ref.item;
    return item;
  });
};
var useSelectOptions = function useSelectOptions(_ref2) {
  var onSearch = _ref2.onSearch,
      options = _ref2.options,
      creatable = _ref2.creatable,
      isValidNewOption = _ref2.isValidNewOption;

  var _useState = React.useState(''),
      _useState2 = _slicedToArray__default(_useState, 2),
      searchValue = _useState2[0],
      setSearchValue = _useState2[1];

  var _useState3 = React.useState(options),
      _useState4 = _slicedToArray__default(_useState3, 2),
      selectOptions = _useState4[0],
      setSelectOptions = _useState4[1];

  utils.useIsomorphicLayoutEffect(function () {
    if (onSearch && searchValue.trim() !== '') {
      onSearch(searchValue);
    }
  }, [searchValue]);
  utils.useIsomorphicLayoutEffect(function () {
    var searchOptions = options;

    if (!onSearch) {
      searchOptions = searchValue !== '' ? filter(options, searchValue) : options;
    }

    var additionOptions = creatable && isValidNewOption(searchValue) ? [{
      label: CREATE_OPTION,
      value: searchValue
    }] : [];
    setSelectOptions([].concat(_toConsumableArray__default(searchOptions), additionOptions));
  }, [searchValue, options]);
  return {
    searchValue: searchValue,
    setSearchValue: setSearchValue,
    selectOptions: selectOptions
  };
};
var useIgnoreDownshiftUselessWarning = function useIgnoreDownshiftUselessWarning() {
  React.useEffect(function () {
    var originalError = console.error;

    console.error = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (/downshift: The ref prop "ref" from/.test(args[0])) {
        return;
      }

      originalError.call.apply(originalError, [console].concat(args));
    };

    return function () {
      console.error = originalError;
    };
  }, []);
};

function getCollisions(targetRect, popoverRect) {
  var offsetLeft = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var offsetBottom = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var collisions = {
    top: targetRect.top - popoverRect.height < 0,
    right: window.innerWidth < targetRect.left + popoverRect.width - offsetLeft,
    bottom: window.innerHeight < targetRect.bottom + popoverRect.height - offsetBottom,
    left: targetRect.left + targetRect.width - popoverRect.width < 0
  };
  var directionRight = collisions.right && !collisions.left;
  var directionLeft = collisions.left && !collisions.right;
  var directionUp = collisions.bottom && !collisions.top;
  var directionDown = collisions.top && !collisions.bottom;
  return {
    directionRight: directionRight,
    directionLeft: directionLeft,
    directionUp: directionUp,
    directionDown: directionDown
  };
}

var POSITION_Y_OFFSET = 5;

function getTopPosition(targetRect, popoverRect) {
  var _getCollisions = getCollisions(targetRect, popoverRect),
      directionUp = _getCollisions.directionUp;

  return {
    top: directionUp ? "".concat(targetRect.top - popoverRect.height + window.pageYOffset - POSITION_Y_OFFSET, "px") : "".concat(targetRect.top + targetRect.height + window.pageYOffset + POSITION_Y_OFFSET, "px")
  };
}

var positionMatchWidth = function positionMatchWidth(targetRect, popoverRect) {
  if (!targetRect || !popoverRect) {
    return {};
  }

  return _objectSpread__default({
    width: targetRect.width,
    left: targetRect.left
  }, getTopPosition(targetRect, popoverRect));
};

var DefaultNoOptionsMessage = function DefaultNoOptionsMessage() {
  var _useLocale = useLocale(),
      locale = _useLocale.locale;

  return /*#__PURE__*/React__default.createElement(Flex, {
    py: "3",
    alignItems: "center",
    justifyContent: "center",
    style: {
      cursor: 'not-allowed'
    }
  }, /*#__PURE__*/React__default.createElement(Icon, {
    type: md.MdHighlightOff,
    mr: "2"
  }), /*#__PURE__*/React__default.createElement(Heading.H5, {
    color: "gray500"
  }, locale.Select.noDataText));
};

var SelectOptions = function SelectOptions(_ref) {
  var selectRef = _ref.selectRef,
      getMenuProps = _ref.getMenuProps,
      getItemProps = _ref.getItemProps,
      visible = _ref.visible,
      options = _ref.options,
      selectedItem = _ref.selectedItem,
      selectedItems = _ref.selectedItems,
      highlightedIndex = _ref.highlightedIndex,
      formatCreateLabel = _ref.formatCreateLabel,
      _ref$noOptionsMessage = _ref.noOptionsMessage,
      noOptionsMessage = _ref$noOptionsMessage === void 0 ? function () {
    return /*#__PURE__*/React__default.createElement(DefaultNoOptionsMessage, null);
  } : _ref$noOptionsMessage;
  var listRef = React.useRef(null);

  var _useVirtual = reactVirtual.useVirtual({
    size: options.length,
    parentRef: listRef,
    estimateSize: React.useCallback(function () {
      return 36;
    }, []),
    overscan: 3
  }),
      virtualItems = _useVirtual.virtualItems,
      totalSize = _useVirtual.totalSize,
      scrollToIndex = _useVirtual.scrollToIndex;

  React.useEffect(function () {
    if (visible && highlightedIndex !== -1) {
      scrollToIndex(highlightedIndex);
    }
  }, [visible, scrollToIndex, highlightedIndex]);
  return /*#__PURE__*/React__default.createElement(Stack, null, function (stackingOrder) {
    return /*#__PURE__*/React__default.createElement(Popover__default, {
      targetRef: selectRef,
      hidden: !visible,
      position: positionMatchWidth,
      style: {
        zIndex: stackingOrder
      }
    }, /*#__PURE__*/React__default.createElement(StyledPopover, _objectSpread__default({}, getMenuProps({
      ref: listRef
    })), visible && /*#__PURE__*/React__default.createElement(React__default.Fragment, null, virtualItems.length === 0 && /*#__PURE__*/React__default.createElement(Box, {
      bg: "light"
    }, noOptionsMessage()), /*#__PURE__*/React__default.createElement("div", {
      style: {
        height: totalSize
      }
    }, virtualItems.map(function (virtualRow) {
      var _ref2;

      var item = options[virtualRow.index];
      var itemString = itemToString(item);
      var itemDisabled = (_ref2 = isObjectOption(item) && item.disabled) !== null && _ref2 !== void 0 ? _ref2 : false;
      var hovered = highlightedIndex === virtualRow.index;
      var active = selectedItems ? selectedItems.map(itemToString).includes(itemString) : itemToString(selectedItem) === itemString;
      var content = isCreateOption(item) ? formatCreateLabel({
        value: item.value,
        active: active,
        hovered: hovered
      }) : itemString;
      var hint = isObjectOption(item) ? item.hint : undefined;
      return /*#__PURE__*/React__default.createElement(StyledSelectOption, _objectSpread__default({
        key: itemString,
        hovered: hovered,
        active: active
      }, getItemProps({
        item: item,
        index: virtualRow.index,
        disabled: itemDisabled,
        style: {
          height: virtualRow.size,
          transform: "translateY(".concat(virtualRow.start, "px)")
        }
      })), selectedItems && /*#__PURE__*/React__default.createElement(Box, {
        display: "inline-flex",
        flex: "none",
        width: "16px",
        mr: "8px"
      }, active && /*#__PURE__*/React__default.createElement(Icon, {
        type: md.MdCheck,
        fill: hovered ? 'light' : 'primaryLight',
        size: "16px"
      })), hint ? /*#__PURE__*/React__default.createElement(Tooltip$1, {
        content: hint,
        mouseLeaveDelay: 0
      }, /*#__PURE__*/React__default.createElement("div", {
        style: {
          width: '100%'
        }
      }, content)) : /*#__PURE__*/React__default.createElement(Ellipsis, null, content));
    })))));
  });
};

SelectOptions.propTypes = {
  visible: _pt__default.bool.isRequired,
  getMenuProps: _pt__default.any.isRequired,
  getItemProps: _pt__default.any.isRequired,
  options: _pt__default.array.isRequired,
  selectedItems: _pt__default.array,
  highlightedIndex: _pt__default.number.isRequired,
  formatCreateLabel: _pt__default.func.isRequired,
  noOptionsMessage: _pt__default.func
};

var SelectSuffix = function SelectSuffix(_ref) {
  var loading = _ref.loading,
      clearable = _ref.clearable,
      onClearIconClick = _ref.onClearIconClick,
      hasSelectedItem = _ref.hasSelectedItem,
      visible = _ref.visible;

  if (loading) {
    return /*#__PURE__*/React__default.createElement(SelectLoading, null);
  }

  return /*#__PURE__*/React__default.createElement(SelectSuffixWrapper, null, clearable && hasSelectedItem && /*#__PURE__*/React__default.createElement(ClearIconWrapper, null, /*#__PURE__*/React__default.createElement(Icon, {
    type: md.MdClose,
    fill: "gray400",
    size: "20",
    cursor: "pointer",
    onClick: function onClick(event) {
      event.stopPropagation();
      onClearIconClick();
    }
  })), /*#__PURE__*/React__default.createElement(ArrowIconWrapper, {
    visible: visible
  }, /*#__PURE__*/React__default.createElement(Icon, {
    type: md.MdKeyboardArrowUp,
    size: "20",
    fill: "gray400",
    style: {
      pointerEvents: 'none'
    }
  })));
};

SelectSuffix.propTypes = {
  loading: _pt__default.bool.isRequired,
  clearable: _pt__default.bool.isRequired,
  visible: _pt__default.bool.isRequired,
  hasSelectedItem: _pt__default.bool.isRequired,
  onClearIconClick: _pt__default.func.isRequired
};

var Select = /*#__PURE__*/React.forwardRef(function Select(_ref, ref) {
  var id = _ref.id,
      _ref$loading = _ref.loading,
      loading = _ref$loading === void 0 ? false : _ref$loading,
      _ref$searchable = _ref.searchable,
      searchable = _ref$searchable === void 0 ? false : _ref$searchable,
      _ref$clearable = _ref.clearable,
      clearable = _ref$clearable === void 0 ? false : _ref$clearable,
      _ref$creatable = _ref.creatable,
      creatable = _ref$creatable === void 0 ? false : _ref$creatable,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 240 : _ref$width,
      options = _ref.options,
      value = _ref.value,
      defaultValue = _ref.defaultValue,
      onChange = _ref.onChange,
      onSearch = _ref.onSearch,
      placeholder = _ref.placeholder,
      noOptionsMessage = _ref.noOptionsMessage,
      onCreateOption = _ref.onCreateOption,
      _ref$formatCreateLabe = _ref.formatCreateLabel,
      formatCreateLabel = _ref$formatCreateLabe === void 0 ? function (info) {
    return "Create new option: ".concat(info.value);
  } : _ref$formatCreateLabe,
      _ref$isValidNewOption = _ref.isValidNewOption,
      isValidNewOption = _ref$isValidNewOption === void 0 ? function (optionValue) {
    return optionValue.trim() !== '';
  } : _ref$isValidNewOption;

  var _useFormField = useFormField({
    id: id,
    value: value,
    defaultValue: defaultValue
  }),
      _useFormField2 = _slicedToArray__default(_useFormField, 3),
      invalid = _useFormField2[0],
      labelId = _useFormField2[1],
      setValue = _useFormField2[2];

  var _useContext = React.useContext(ClickOutsideContext),
      setHasChild = _useContext.setHasChild;

  var selectRef = React.useRef(null);

  var _useSelectOptions = useSelectOptions({
    onSearch: onSearch,
    options: options,
    creatable: creatable,
    isValidNewOption: isValidNewOption
  }),
      searchValue = _useSelectOptions.searchValue,
      setSearchValue = _useSelectOptions.setSearchValue,
      selectOptions = _useSelectOptions.selectOptions;

  useIgnoreDownshiftUselessWarning();

  var handleChange = function handleChange(_ref2) {
    var selectedItem = _ref2.selectedItem;
    var selection = selectedItem !== null && selectedItem !== void 0 ? selectedItem : null;

    if (isCreateOption(selection)) {
      if (onCreateOption) {
        setSearchValue('');
        onChange(null);
        onCreateOption(selection.value);
      }
    } else {
      onChange(selection);
      setValue(selection);
    }
  };

  var getDefaultHighlightIndex = function getDefaultHighlightIndex() {
    if (searchable && searchValue !== '') {
      return 0;
    }

    var index = selectOptions.findIndex(function (item) {
      return itemToString(item) === itemToString(value !== null && value !== void 0 ? value : defaultValue);
    });
    return index !== -1 ? index : 0;
  };

  var _useCombobox = downshift.useCombobox({
    id: labelId,
    itemToString: itemToString,
    items: selectOptions,
    inputValue: searchValue,
    selectedItem: value,
    initialSelectedItem: defaultValue,
    defaultHighlightedIndex: getDefaultHighlightIndex(),
    scrollIntoView: function scrollIntoView() {},
    onSelectedItemChange: handleChange,
    onIsOpenChange: function onIsOpenChange(_ref3) {
      var visible = _ref3.isOpen;
      setHasChild(Boolean(visible));

      if (visible) {
        setSearchValue('');
      }
    }
  }),
      selectedItem = _useCombobox.selectedItem,
      highlightedIndex = _useCombobox.highlightedIndex,
      getToggleButtonProps = _useCombobox.getToggleButtonProps,
      getMenuProps = _useCombobox.getMenuProps,
      getInputProps = _useCombobox.getInputProps,
      getComboboxProps = _useCombobox.getComboboxProps,
      getItemProps = _useCombobox.getItemProps,
      selectItem = _useCombobox.selectItem,
      isOpen = _useCombobox.isOpen;

  var selectedItemString = itemToString(selectedItem);
  return /*#__PURE__*/React__default.createElement("div", _objectSpread__default({}, getComboboxProps({
    ref: ref,
    style: {
      width: width
    }
  })), /*#__PURE__*/React__default.createElement(StyledSelect, _objectSpread__default(_objectSpread__default({}, getToggleButtonProps({
    ref: selectRef,
    disabled: disabled || loading
  })), {}, {
    invalid: invalid,
    focused: isOpen
  }), /*#__PURE__*/React__default.createElement("input", _objectSpread__default({}, getInputProps(_objectSpread__default(_objectSpread__default({}, (searchable || creatable) && isOpen ? {} : {
    value: selectedItemString
  }), {}, {
    readOnly: !searchable && !creatable || loading,
    placeholder: placeholder !== null && placeholder !== void 0 ? placeholder : selectedItemString,
    onChange: function onChange(event) {
      var newInputValue = event.currentTarget.value;

      if (isOpen && (searchable || creatable)) {
        if (newInputValue === CREATE_OPTION) {
          setSearchValue('');
        } else {
          setSearchValue(newInputValue);
        }
      }
    }
  })))), /*#__PURE__*/React__default.createElement(SelectSuffix, {
    loading: loading,
    hasSelectedItem: selectedItem !== null,
    clearable: clearable,
    onClearIconClick: function onClearIconClick() {
      return selectItem(null);
    },
    visible: isOpen
  })), /*#__PURE__*/React__default.createElement(SelectOptions, {
    selectRef: selectRef,
    getMenuProps: getMenuProps,
    getItemProps: getItemProps,
    visible: isOpen,
    options: selectOptions,
    selectedItem: selectedItem,
    highlightedIndex: highlightedIndex,
    formatCreateLabel: formatCreateLabel,
    noOptionsMessage: noOptionsMessage
  }));
});

var _excluded$2 = ["fontSize"];
var MirrorSpan = styled__default.span.withConfig({
  componentId: "sc-128a4xv-0"
})(["visibility:hidden;position:absolute;pointer-events:none;"]);
var MIN_INPUT_WIDTH = 18;
var AutoSizeInput = /*#__PURE__*/React.forwardRef(function AutoSizeInput(_ref, ref) {
  var _ref$fontSize = _ref.fontSize,
      fontSize = _ref$fontSize === void 0 ? 14 : _ref$fontSize,
      props = _objectWithoutProperties__default(_ref, _excluded$2);

  var _useState = React.useState(props.value || props.defaultValue || ''),
      _useState2 = _slicedToArray__default(_useState, 2),
      value = _useState2[0],
      setValue = _useState2[1];

  var _useState3 = React.useState(MIN_INPUT_WIDTH),
      _useState4 = _slicedToArray__default(_useState3, 2),
      width = _useState4[0],
      setWidth = _useState4[1];

  var mirrorInputRef = React.useRef(null);
  React.useEffect(function () {
    if (mirrorInputRef.current) {
      setWidth(mirrorInputRef.current.scrollWidth + MIN_INPUT_WIDTH);
    }
  }, [value]);
  React.useEffect(function () {
    if (props.value !== undefined && props.value !== value) {
      setValue(props.value);
    } // eslint-disable-next-line react-hooks/exhaustive-deps

  }, [props.value]);
  var inputProps = mergeEventProps(props, {
    onChange: function onChange(e) {
      return setValue(e.target.value);
    }
  });
  return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement("input", _objectSpread__default({
    ref: ref,
    style: {
      width: width,
      boxSizing: 'content-box'
    }
  }, inputProps)), /*#__PURE__*/React__default.createElement(MirrorSpan, {
    ref: mirrorInputRef,
    style: {
      fontSize: fontSize
    }
  }, value === '' && props.placeholder !== undefined ? props.placeholder : value));
});

var StyledTag = styled__default.div.withConfig({
  componentId: "sc-1ub0w4p-0"
})(["display:inline-flex;align-items:center;height:28px;padding:0 8px;border:", ";border-radius:", ";border-color:", ";background-color:", ";color:", ";font-size:", ";white-space:nowrap;cursor:", ";input{color:", ";}"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  if (p.disabled) {
    return p.theme.colors.gray500;
  }

  if (p.invalid) {
    return p.theme.colors.danger;
  }

  return p.theme.colors.primaryLight;
}, function (p) {
  if (p.disabled) {
    return p.theme.colors.gray300;
  }

  if (p.invalid) {
    return p.theme.colors.light;
  }

  return p.theme.colors.surface2;
}, function (p) {
  if (p.disabled) {
    return p.theme.colors.gray500;
  }

  if (p.invalid) {
    return p.theme.colors.danger;
  }

  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.fontSizes.sm;
}, function (p) {
  if (p.disabled) {
    return 'not-allowed';
  }

  if (p.editable || Boolean(p.onClick)) {
    return 'pointer';
  }

  return 'auto';
}, function (p) {
  return p.invalid ? p.theme.colors.danger : p.theme.colors.primaryLight;
});
var StyledTagPrefix = styled__default.span.withConfig({
  componentId: "sc-1ub0w4p-1"
})(["display:inline-flex;align-items:center;height:100%;margin-right:8px;padding-right:8px;border-right:", ";border-color:", ";color:", ";font-size:", ";"], function (p) {
  return p.theme.borders.base;
}, function (p) {
  return p.invalid ? p.theme.colors.danger : p.theme.colors.primaryLight;
}, function (p) {
  return p.invalid ? p.theme.colors.danger : p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.fontSizes.sm;
});
var StyledTagInput = styled__default(AutoSizeInput).withConfig({
  componentId: "sc-1ub0w4p-2"
})(["display:inline-flex;margin:0;padding:0;border:none;outline:none;background-color:transparent;font-size:", ";"], function (p) {
  return p.theme.fontSizes.sm;
});

var _excluded$1 = ["children", "editable", "initialEditing", "closable", "invalid", "disabled", "onClose", "onClosed", "canClose", "prefix", "onChange", "onClick"];
var StyledTagWrapper = styled__default.div.withConfig({
  componentId: "sc-1ibpnx6-0"
})(["display:inline-flex;overflow-x:hidden;"]);
var AnimatedStyledTagWrapper = web.animated(StyledTagWrapper);
var StyledCloseIcon = styled__default(Icon).withConfig({
  componentId: "sc-1ibpnx6-1"
})(["& svg{fill:", ";}&:hover svg{fill:", ";}"], function (p) {
  return p.theme.colors.primaryLight2;
}, function (p) {
  return p.theme.colors.primaryLight;
});

var CloseIcon = function CloseIcon(_ref) {
  var onClick = _ref.onClick,
      disabled = _ref.disabled,
      invalid = _ref.invalid;
  var fill;

  if (invalid) {
    fill = 'danger';
  }

  if (disabled) {
    fill = 'gray500';
  }

  return /*#__PURE__*/React__default.createElement(StyledCloseIcon, {
    size: "16",
    ml: "1",
    cursor: disabled ? 'not-allowed' : 'pointer',
    fill: fill,
    onClick: onClick,
    type: md.MdClose
  });
};

CloseIcon.propTypes = {
  onClick: _pt__default.func.isRequired,
  invalid: _pt__default.bool.isRequired,
  disabled: _pt__default.bool.isRequired
};
var Tag = /*#__PURE__*/React.forwardRef(function Tag(_ref2, ref) {
  var _ref2$children = _ref2.children,
      children = _ref2$children === void 0 ? '' : _ref2$children,
      _ref2$editable = _ref2.editable,
      editable = _ref2$editable === void 0 ? false : _ref2$editable,
      _ref2$initialEditing = _ref2.initialEditing,
      initialEditing = _ref2$initialEditing === void 0 ? false : _ref2$initialEditing,
      closable = _ref2.closable,
      _ref2$invalid = _ref2.invalid,
      invalid = _ref2$invalid === void 0 ? false : _ref2$invalid,
      _ref2$disabled = _ref2.disabled,
      disabled = _ref2$disabled === void 0 ? false : _ref2$disabled,
      onClose = _ref2.onClose,
      onClosed = _ref2.onClosed,
      canClose = _ref2.canClose,
      prefix = _ref2.prefix,
      onChange = _ref2.onChange,
      _onClick = _ref2.onClick,
      otherProps = _objectWithoutProperties__default(_ref2, _excluded$1);

  var _useState = React.useState(false),
      _useState2 = _slicedToArray__default(_useState, 2),
      closeDone = _useState2[0],
      setCloseDone = _useState2[1];

  var _useState3 = React.useState(true),
      _useState4 = _slicedToArray__default(_useState3, 2),
      on = _useState4[0],
      setOn = _useState4[1];

  var _useState5 = React.useState(initialEditing),
      _useState6 = _slicedToArray__default(_useState5, 2),
      editing = _useState6[0],
      setEditing = _useState6[1];

  var previous = usePrevious(on);

  var _useMeasure = useMeasure(),
      _useMeasure2 = _slicedToArray__default(_useMeasure, 2),
      bind = _useMeasure2[0],
      width = _useMeasure2[1].width;

  var style = web.useSpring({
    opacity: on ? 1 : 0,
    marginRight: on ? 4 : 0,
    width: on ? width : 0,
    onRest: {
      opacity: function opacity(restOpacity) {
        if (restOpacity.value === 0) {
          setCloseDone(true);
        }
      }
    }
  });
  React.useEffect(function () {
    if (onClosed && closeDone) {
      onClosed();
    }
  }, [onClosed, closeDone]);
  var handleUpdate = React.useCallback(function (event) {
    var value = event.currentTarget.value;
    setEditing(false);

    if (onChange && children !== value) {
      onChange(children, value);
    }
  }, [children, onChange]);

  if (closeDone) {
    return null;
  }

  return /*#__PURE__*/React__default.createElement(AnimatedStyledTagWrapper, _objectSpread__default(_objectSpread__default({}, bind), {}, {
    style: _objectSpread__default(_objectSpread__default({}, style), {}, {
      width: web.to(style.width, function (springWidth) {
        return on && previous === on ? 'auto' : springWidth;
      })
    })
  }), /*#__PURE__*/React__default.createElement(StyledTag, _objectSpread__default({
    ref: ref,
    editable: editable,
    disabled: disabled,
    invalid: invalid,
    onClick: function onClick(event) {
      if (disabled) {
        return;
      }

      if (editable) {
        setEditing(true);
      }

      if (_onClick) {
        _onClick(event);
      }
    }
  }, otherProps), prefix && /*#__PURE__*/React__default.createElement(StyledTagPrefix, {
    invalid: invalid
  }, prefix), editing ? /*#__PURE__*/React__default.createElement(StyledTagInput, {
    autoFocus: true,
    defaultValue: children,
    onBlur: handleUpdate,
    onKeyPress: function onKeyPress(event) {
      if (event.key === 'Enter') {
        handleUpdate(event);
      }
    },
    onKeyDown: function onKeyDown(event) {
      if (event.key === 'Escape') {
        setEditing(false);
      }
    }
  }) : /*#__PURE__*/React__default.createElement(Ellipsis, null, children), closable && /*#__PURE__*/React__default.createElement(CloseIcon, {
    invalid: invalid,
    disabled: disabled,
    onClick: /*#__PURE__*/function () {
      var _ref3 = _asyncToGenerator__default( /*#__PURE__*/_regeneratorRuntime__default.mark(function _callee(event) {
        return _regeneratorRuntime__default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (!disabled) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                event.stopPropagation();
                _context.t0 = canClose;

                if (!_context.t0) {
                  _context.next = 8;
                  break;
                }

                _context.next = 7;
                return canClose();

              case 7:
                _context.t0 = !_context.sent;

              case 8:
                if (!_context.t0) {
                  _context.next = 10;
                  break;
                }

                return _context.abrupt("return");

              case 10:
                if (onClose) {
                  onClose();
                } else {
                  setOn(false);
                }

              case 11:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref3.apply(this, arguments);
      };
    }()
  })));
});

var MultipleSelect = /*#__PURE__*/React.forwardRef(function MultipleSelect(_ref, ref) {
  var id = _ref.id,
      _ref$loading = _ref.loading,
      loading = _ref$loading === void 0 ? false : _ref$loading,
      _ref$searchable = _ref.searchable,
      searchable = _ref$searchable === void 0 ? false : _ref$searchable,
      _ref$clearable = _ref.clearable,
      clearable = _ref$clearable === void 0 ? false : _ref$clearable,
      _ref$creatable = _ref.creatable,
      creatable = _ref$creatable === void 0 ? false : _ref$creatable,
      _ref$disabled = _ref.disabled,
      disabled = _ref$disabled === void 0 ? false : _ref$disabled,
      _ref$width = _ref.width,
      width = _ref$width === void 0 ? 240 : _ref$width,
      options = _ref.options,
      value = _ref.value,
      defaultValue = _ref.defaultValue,
      onChange = _ref.onChange,
      placeholder = _ref.placeholder,
      noOptionsMessage = _ref.noOptionsMessage,
      onCreateOption = _ref.onCreateOption,
      _ref$formatCreateLabe = _ref.formatCreateLabel,
      formatCreateLabel = _ref$formatCreateLabe === void 0 ? function (info) {
    return "Create new option: ".concat(info.value);
  } : _ref$formatCreateLabe,
      _ref$isValidNewOption = _ref.isValidNewOption,
      isValidNewOption = _ref$isValidNewOption === void 0 ? function (optionValue) {
    return optionValue.trim() !== '';
  } : _ref$isValidNewOption;
  var inputRef = React.useRef(null);

  var _useFormField = useFormField({
    id: id,
    value: value,
    defaultValue: defaultValue
  }),
      _useFormField2 = _slicedToArray__default(_useFormField, 3),
      invalid = _useFormField2[0],
      labelId = _useFormField2[1],
      setValue = _useFormField2[2];

  var _useContext = React.useContext(ClickOutsideContext),
      setHasChild = _useContext.setHasChild;

  var selectRef = React.useRef(null);

  var _useSelectOptions = useSelectOptions({
    options: options,
    creatable: creatable,
    isValidNewOption: isValidNewOption
  }),
      searchValue = _useSelectOptions.searchValue,
      setSearchValue = _useSelectOptions.setSearchValue,
      selectOptions = _useSelectOptions.selectOptions;

  useIgnoreDownshiftUselessWarning();

  var handleChange = function handleChange(_ref2) {
    var selectedItems = _ref2.selectedItems;
    var selection = selectedItems !== null && selectedItems !== void 0 ? selectedItems : [];
    var createOption = selection.find(isCreateOption);

    if (createOption && onCreateOption) {
      setSearchValue('');
      onCreateOption(createOption.value);
    } else {
      onChange(selectedItems);
      setValue(selectedItems);
    }
  };

  var _useMultipleSelection = downshift.useMultipleSelection({
    onSelectedItemsChange: handleChange,
    selectedItems: value,
    initialSelectedItems: defaultValue
  }),
      getSelectedItemProps = _useMultipleSelection.getSelectedItemProps,
      getDropdownProps = _useMultipleSelection.getDropdownProps,
      selectedItems = _useMultipleSelection.selectedItems,
      setSelectedItems = _useMultipleSelection.setSelectedItems;

  var _useCombobox = downshift.useCombobox({
    id: labelId,
    itemToString: itemToString,
    items: selectOptions,
    inputValue: searchValue,
    scrollIntoView: function scrollIntoView() {},
    onIsOpenChange: function onIsOpenChange(_ref3) {
      var visible = _ref3.isOpen;
      return setHasChild(Boolean(visible));
    },
    stateReducer: function stateReducer(state, actionAndChanges) {
      var changes = actionAndChanges.changes,
          type = actionAndChanges.type;

      if (type === downshift.useCombobox.stateChangeTypes.InputKeyDownEnter || type === downshift.useCombobox.stateChangeTypes.ItemClick) {
        setSearchValue('');
        var selectedItem = changes.selectedItem;
        var selectedItemString = itemToString(selectedItem);

        if (selectedItems.map(itemToString).includes(selectedItemString)) {
          setSelectedItems(selectedItems.filter(function (item) {
            return itemToString(item) !== selectedItemString;
          }));
        } else {
          setSelectedItems([].concat(_toConsumableArray__default(selectedItems), [selectedItem]));
        }

        var newHighlightedIndex = options.findIndex(function (item) {
          return itemToString(item) === selectedItemString;
        });
        return _objectSpread__default(_objectSpread__default({}, changes), {}, {
          highlightedIndex: newHighlightedIndex,
          isOpen: true // keep the menu open after selection.

        });
      }

      return changes;
    }
  }),
      highlightedIndex = _useCombobox.highlightedIndex,
      getToggleButtonProps = _useCombobox.getToggleButtonProps,
      getMenuProps = _useCombobox.getMenuProps,
      getInputProps = _useCombobox.getInputProps,
      getComboboxProps = _useCombobox.getComboboxProps,
      getItemProps = _useCombobox.getItemProps,
      isOpen = _useCombobox.isOpen;

  return /*#__PURE__*/React__default.createElement("div", _objectSpread__default({}, getComboboxProps({
    ref: ref,
    style: {
      width: width
    }
  })), /*#__PURE__*/React__default.createElement(StyledSelect, _objectSpread__default(_objectSpread__default({}, getToggleButtonProps({
    ref: selectRef,
    disabled: disabled || loading
  })), {}, {
    multiple: true,
    invalid: invalid,
    focused: isOpen
  }), /*#__PURE__*/React__default.createElement(Flex, {
    flex: "auto",
    flexWrap: "wrap",
    width: "calc(100% - 26px)"
  }, selectedItems.map(function (selectedItem, index) {
    return /*#__PURE__*/React__default.createElement(Tag, _objectSpread__default({
      key: itemToString(selectedItem),
      closable: true,
      disabled: loading || disabled,
      style: {
        marginBottom: 2,
        maxWidth: '100%'
      },
      onClose: function onClose() {
        var _inputRef$current;

        setSelectedItems(selectedItems.filter(function (item) {
          return itemToString(item) !== itemToString(selectedItem);
        }));
        (_inputRef$current = inputRef.current) === null || _inputRef$current === void 0 ? void 0 : _inputRef$current.focus();
      }
    }, getSelectedItemProps({
      selectedItem: selectedItem,
      index: index
    })), itemToString(selectedItem));
  }), /*#__PURE__*/React__default.createElement("input", _objectSpread__default({}, getInputProps(_objectSpread__default(_objectSpread__default({}, getDropdownProps({
    ref: inputRef,
    preventKeyAction: isOpen,
    readOnly: !searchable && !creatable || loading,
    placeholder: placeholder
  })), {}, {
    onChange: function onChange(event) {
      return setSearchValue(event.currentTarget.value);
    }
  }))))), /*#__PURE__*/React__default.createElement(SelectSuffix, {
    loading: loading,
    hasSelectedItem: selectedItems.length > 0,
    clearable: clearable,
    onClearIconClick: function onClearIconClick() {
      return setSelectedItems([]);
    },
    visible: isOpen
  })), /*#__PURE__*/React__default.createElement(SelectOptions, {
    selectRef: selectRef,
    getMenuProps: getMenuProps,
    getItemProps: getItemProps,
    visible: isOpen,
    options: selectOptions,
    selectedItems: selectedItems,
    highlightedIndex: highlightedIndex,
    formatCreateLabel: formatCreateLabel,
    noOptionsMessage: noOptionsMessage
  }));
});

var _templateObject;
var tooltipStyles = styled.css([":root{--reach-tooltip:1;}[data-reach-tooltip]{position:absolute;z-index:1;padding:", ";border-radius:", ";background-color:", ";color:", ";font-size:", ";white-space:nowrap;pointer-events:none;}"], function (p) {
  return p.theme.space[2];
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return polished.rgba(p.theme.colors.gray800, 0.9);
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.fontSizes.sm;
});
var TooltipStyle = styled.createGlobalStyle(_templateObject || (_templateObject = _taggedTemplateLiteral__default(["", ""])), tooltipStyles);

var _excluded = ["children", "id", "DEBUG_STYLE", "content"];
var AnimatedTooltipContent = web.animated(tooltip.TooltipPopup);
var Tooltip = /*#__PURE__*/React.forwardRef(function (_ref, forwardedRef) {
  var children = _ref.children,
      id = _ref.id,
      DEBUG_STYLE = _ref.DEBUG_STYLE,
      content = _ref.content,
      props = _objectWithoutProperties__default(_ref, _excluded);

  var child = React.Children.only(children);

  var _useTooltip = tooltip.useTooltip({
    id: id,
    onMouseEnter: child.props.onMouseEnter,
    onMouseMove: child.props.onMouseMove,
    onMouseLeave: child.props.onMouseLeave,
    onFocus: child.props.onFocus,
    onBlur: child.props.onBlur,
    onKeyDown: child.props.onKeyDown,
    onMouseDown: child.props.onMouseDown,
    ref: child.ref,
    DEBUG_STYLE: DEBUG_STYLE
  }),
      _useTooltip2 = _slicedToArray__default(_useTooltip, 3),
      trigger = _useTooltip2[0],
      tooltip$1 = _useTooltip2[1],
      isVisible = _useTooltip2[2];

  var transitions = web.useTransition(isVisible ? tooltip$1 : null, {
    from: {
      opacity: 0,
      transform: 'scale(0.9)'
    },
    enter: {
      opacity: 1,
      transform: 'scale(1)'
    },
    leave: {
      opacity: 0,
      transform: 'scale(1)'
    },
    config: function config(item) {
      return {
        mass: 1,
        tension: item ? 500 : 1500,
        friction: item ? 40 : 1200
      };
    }
  });
  return /*#__PURE__*/React__default.createElement(Stack, null, function (stackingOrder) {
    return /*#__PURE__*/React__default.createElement(React__default.Fragment, null, /*#__PURE__*/React__default.createElement(TooltipStyle, null), /*#__PURE__*/React.cloneElement(child, trigger), transitions(function (style, item) {
      return item && /*#__PURE__*/React__default.createElement(AnimatedTooltipContent, _objectSpread__default(_objectSpread__default(_objectSpread__default({
        ref: forwardedRef,
        label: content
      }, item), props), {}, {
        style: _objectSpread__default(_objectSpread__default({}, style), {}, {
          zIndex: stackingOrder
        })
      }));
    }));
  });
});

exports.MultipleSelect = MultipleSelect;
exports.Select = Select;
exports.Tab = Tab;
exports.Tabs = Tabs;
exports.Tooltip = Tooltip;
//# sourceMappingURL=index.cjs.js.map
