import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _pt from "prop-types";
var _excluded = ["life"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { useCallback, useRef, useState } from 'react';
import styled from 'styled-components';
import { MdClose } from 'react-icons/md';
import { animated, useTransition } from '@react-spring/web';
import { useIsomorphicLayoutEffect } from '@reach/utils';
import { Box } from '../Layout';
import { Icon } from '../Icon';
import { Portal } from '../Portal';
import { StackingOrder } from '../constants';
import { useUID } from '../UIProvider/UIDContext';
var MessageContainer = styled.div.withConfig({
  componentId: "sc-1038x7-0"
})(["display:flex;position:fixed;right:10px;bottom:10px;flex-direction:column;"]);
var MessageBox = styled.div.withConfig({
  componentId: "sc-1038x7-1"
})(["position:relative;box-sizing:border-box;flex:none;width:280px;overflow:hidden;"]);
var MessageContent = styled.div.withConfig({
  componentId: "sc-1038x7-2"
})(["display:flex;position:relative;height:auto;margin-top:", ";padding:", ";overflow:hidden;border-radius:", ";background-color:", ";color:", ";font-size:", ";"], function (p) {
  return p.theme.space[2];
}, function (p) {
  return p.theme.space[3];
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return p.theme.colors.gray800;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.fontSizes.sm;
});
var Life = styled(animated.div).withConfig({
  componentId: "sc-1038x7-3"
})(["position:absolute;z-index:1;bottom:0;left:0;width:auto;height:3px;background-color:", ";"], function (p) {
  return p.theme.colors.primaryLight;
});
var AnimatedMessageBox = animated(MessageBox);
var config = {
  tension: 125,
  friction: 20,
  precision: 0.1
};

var HooksMessage = function HooksMessage(_ref) {
  var triggerRef = _ref.triggerRef;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      mounted = _useState2[0],
      setMounted = _useState2[1];

  var refMap = useRef(new WeakMap());
  var cancelMap = useRef(new WeakMap());

  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      messages = _useState4[0],
      setMessages = _useState4[1];

  var getUid = useUID();
  useIsomorphicLayoutEffect(function () {
    setMounted(true);
  }, []);
  var trigger = useCallback(function (_ref2, type) {
    var content = _ref2.content,
        duration = _ref2.duration;
    return new Promise(function (resolve) {
      var key = getUid();
      var icon = /*#__PURE__*/React.createElement(Icon, {
        type: type,
        fill: type,
        size: "20",
        mr: "2"
      });
      var newMessage = {
        key: key,
        icon: icon,
        content: content,
        duration: duration,
        resolve: resolve
      };
      setMessages(function (prevMessages) {
        return [].concat(_toConsumableArray(prevMessages), [newMessage]);
      });
    });
  }, [getUid]);
  useIsomorphicLayoutEffect(function () {
    // eslint-disable-next-line no-param-reassign
    triggerRef.current = trigger;
  }, [trigger, triggerRef]);
  var transition = useTransition(messages, {
    keys: function keys(message) {
      return message.key;
    },
    from: {
      opacity: 0,
      height: 0,
      life: '100%'
    },
    enter: function enter(message) {
      return /*#__PURE__*/function () {
        var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(next, stop) {
          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  cancelMap.current.set(message, function () {
                    stop();
                    setMessages(function (prevMessages) {
                      return prevMessages.filter(function (prevMessage) {
                        return prevMessage.key !== message.key;
                      });
                    });
                  });
                  _context.next = 3;
                  return next({
                    opacity: 1,
                    height: refMap.current.get(message).offsetHeight + 8,
                    config: config
                  });

                case 3:
                  _context.next = 5;
                  return next({
                    life: '0%',
                    config: {
                      duration: message.duration
                    }
                  });

                case 5:
                  cancelMap.current.get(message)();

                case 6:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        return function (_x, _x2) {
          return _ref3.apply(this, arguments);
        };
      }();
    },
    leave: function leave(item) {
      return /*#__PURE__*/function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(next) {
          return _regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return next({
                    opacity: 0
                  });

                case 2:
                  item.resolve(true);
                  _context2.next = 5;
                  return next({
                    height: 0
                  });

                case 5:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        return function (_x3) {
          return _ref4.apply(this, arguments);
        };
      }();
    },
    config: config
  });

  if (!mounted) {
    return null;
  }

  return /*#__PURE__*/React.createElement(Portal, {
    defaultOrder: StackingOrder.MESSAGE
  }, /*#__PURE__*/React.createElement(MessageContainer, null, transition(function (_ref5, message) {
    var life = _ref5.life,
        style = _objectWithoutProperties(_ref5, _excluded);

    return /*#__PURE__*/React.createElement(AnimatedMessageBox, {
      style: style
    }, /*#__PURE__*/React.createElement(MessageContent, {
      ref: function ref(_ref6) {
        if (_ref6) {
          refMap.current.set(message, _ref6);
        }
      }
    }, message.icon, /*#__PURE__*/React.createElement(Box, {
      flex: "auto"
    }, message.content), /*#__PURE__*/React.createElement(Icon, {
      type: MdClose,
      fill: "light",
      size: "16",
      role: "button",
      cursor: "pointer",
      onClick: function onClick() {
        if (cancelMap.current.has(message)) {
          cancelMap.current.get(message)();
        }
      }
    }), /*#__PURE__*/React.createElement(Life, {
      style: {
        right: life
      }
    })));
  })));
};

export default HooksMessage;