import React, { useContext } from 'react';
import { HooksMessageContext } from './HooksMessageProvider';

var useMessage = function useMessage() {
  var triggerRef = useContext(HooksMessageContext);
  return {
    info: function info(content) {
      var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3000;
      return triggerRef.current({
        content: content,
        duration: duration
      }, 'info');
    },
    success: function success(content) {
      var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3000;
      return triggerRef.current({
        content: content,
        duration: duration
      }, 'success');
    },
    warning: function warning(content) {
      var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3000;
      return triggerRef.current({
        content: content,
        duration: duration
      }, 'warning');
    },
    error: function error(content) {
      var duration = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 3000;
      return triggerRef.current({
        content: content,
        duration: duration
      }, 'error');
    }
  };
};

export { useMessage };