import { FC, MutableRefObject, ReactNode } from 'react';
export interface NotificationOptions {
    key?: string;
    icon?: ReactNode;
    content: ReactNode;
    duration: number;
}
export declare type Trigger = {
    open: (options: NotificationOptions) => [Promise<boolean>, () => void];
    close: (key: string) => void;
    destroy: () => void;
};
interface HooksNotificationProps {
    triggerRef: MutableRefObject<Trigger>;
}
declare const HooksNotification: FC<HooksNotificationProps>;
export default HooksNotification;
