import _objectSpread from "@babel/runtime/helpers/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/objectWithoutProperties";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _toConsumableArray from "@babel/runtime/helpers/toConsumableArray";
import _slicedToArray from "@babel/runtime/helpers/slicedToArray";
import _pt from "prop-types";
var _excluded = ["offset"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { useCallback, useRef, useState } from 'react';
import styled from 'styled-components';
import { MdClose } from 'react-icons/md';
import { animated, to, useTransition } from '@react-spring/web';
import { useIsomorphicLayoutEffect } from '@reach/utils';
import { Box, Flex } from '../Layout';
import { Icon } from '../Icon';
import { Portal } from '../Portal';
import { StackingOrder } from '../constants';
import { tuplify } from '../utils';
import { useUID } from '../UIProvider/UIDContext';
var NotificationContainer = styled.div.withConfig({
  componentId: "sc-1j7t6pr-0"
})(["display:flex;position:fixed;top:72px;right:10px;flex-direction:column;"]);
var NotificationBox = styled.div.withConfig({
  componentId: "sc-1j7t6pr-1"
})(["position:relative;box-sizing:border-box;flex:none;width:360px;"]);
var NotificationContent = styled.div.withConfig({
  componentId: "sc-1j7t6pr-2"
})(["display:flex;position:relative;height:auto;margin-top:", ";overflow:hidden;border-radius:", ";background-color:", ";box-shadow:", ";color:", ";font-size:", ";"], function (p) {
  return p.theme.space[2];
}, function (p) {
  return p.theme.radii.lg;
}, function (p) {
  return p.theme.colors.primaryLight;
}, function (p) {
  return p.theme.shadows.xl;
}, function (p) {
  return p.theme.colors.light;
}, function (p) {
  return p.theme.fontSizes.sm;
});
var AnimatedNotificationBox = animated(NotificationBox);
var config = {
  tension: 125,
  friction: 20,
  precision: 0.1
};

var HooksNotification = function HooksNotification(_ref) {
  var triggerRef = _ref.triggerRef;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      mounted = _useState2[0],
      setMounted = _useState2[1];

  var promiseMap = useRef(new Map());
  var refMap = useRef(new Map());
  var cancelMap = useRef(new Map());

  var _useState3 = useState([]),
      _useState4 = _slicedToArray(_useState3, 2),
      notifications = _useState4[0],
      setNotifications = _useState4[1];

  var getUid = useUID();
  useIsomorphicLayoutEffect(function () {
    setMounted(true);
  }, []);
  var trigger = useCallback(function (_ref2) {
    var keyFromProps = _ref2.key,
        content = _ref2.content,
        icon = _ref2.icon,
        duration = _ref2.duration;
    var key = keyFromProps !== null && keyFromProps !== void 0 ? keyFromProps : getUid();
    var newNotification = {
      key: key,
      icon: icon,
      content: content,
      duration: duration
    };
    var promise = new Promise(function (resolve) {
      promiseMap.current.set(key, resolve);
    });
    setNotifications(function (prevNotifications) {
      return [].concat(_toConsumableArray(prevNotifications), [newNotification]);
    });

    var close = function close() {
      if (cancelMap.current.has(key)) {
        var _cancelMap$current$ge;

        (_cancelMap$current$ge = cancelMap.current.get(key)) === null || _cancelMap$current$ge === void 0 ? void 0 : _cancelMap$current$ge();
      }
    };

    return tuplify(promise, close);
  }, [getUid]);

  var close = function close(key) {
    var _cancelMap$current$ge2;

    (_cancelMap$current$ge2 = cancelMap.current.get(key)) === null || _cancelMap$current$ge2 === void 0 ? void 0 : _cancelMap$current$ge2();
    cancelMap.current.delete(key);
  };

  var destroy = function destroy() {
    cancelMap.current.forEach(function (cancelCallback) {
      return cancelCallback();
    });
  };

  useIsomorphicLayoutEffect(function () {
    // eslint-disable-next-line no-param-reassign
    triggerRef.current = {
      open: trigger,
      close: close,
      destroy: destroy
    };
  }, [trigger, triggerRef]);
  var transition = useTransition(notifications, {
    keys: function keys(notification) {
      return notification.key;
    },
    from: {
      opacity: 0,
      height: 0,
      offset: 300
    },
    enter: function enter(notification) {
      return /*#__PURE__*/function () {
        var _ref3 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(next, stop) {
          var _refMap$current$get$o, _refMap$current$get, _cancelMap$current$ge3;

          return _regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  cancelMap.current.set(notification.key, function () {
                    stop();
                    setNotifications(function (prevNotifications) {
                      return prevNotifications.filter(function (prevNotification) {
                        return prevNotification.key !== notification.key;
                      });
                    });
                  });
                  _context.next = 3;
                  return next({
                    immediate: true,
                    height: ((_refMap$current$get$o = (_refMap$current$get = refMap.current.get(notification.key)) === null || _refMap$current$get === void 0 ? void 0 : _refMap$current$get.offsetHeight) !== null && _refMap$current$get$o !== void 0 ? _refMap$current$get$o : 0) + 8
                  });

                case 3:
                  _context.next = 5;
                  return next({
                    opacity: 1,
                    offset: 0,
                    config: config
                  });

                case 5:
                  _context.next = 7;
                  return next({
                    delay: notification.duration
                  });

                case 7:
                  (_cancelMap$current$ge3 = cancelMap.current.get(notification.key)) === null || _cancelMap$current$ge3 === void 0 ? void 0 : _cancelMap$current$ge3();
                  cancelMap.current.delete(notification.key);

                case 9:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee);
        }));

        return function (_x, _x2) {
          return _ref3.apply(this, arguments);
        };
      }();
    },
    leave: function leave(notification) {
      return /*#__PURE__*/function () {
        var _ref4 = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee2(next) {
          var _promiseMap$current$g;

          return _regeneratorRuntime.wrap(function _callee2$(_context2) {
            while (1) {
              switch (_context2.prev = _context2.next) {
                case 0:
                  _context2.next = 2;
                  return next({
                    opacity: 0,
                    offset: 300,
                    config: config
                  });

                case 2:
                  (_promiseMap$current$g = promiseMap.current.get(notification.key)) === null || _promiseMap$current$g === void 0 ? void 0 : _promiseMap$current$g(true);
                  promiseMap.current.delete(notification.key);
                  _context2.next = 6;
                  return next({
                    height: 0,
                    config: config
                  });

                case 6:
                  refMap.current.delete(notification.key);

                case 7:
                case "end":
                  return _context2.stop();
              }
            }
          }, _callee2);
        }));

        return function (_x3) {
          return _ref4.apply(this, arguments);
        };
      }();
    },
    config: config
  });

  if (!mounted) {
    return null;
  }

  return /*#__PURE__*/React.createElement(Portal, {
    defaultOrder: StackingOrder.NOTIFICATION
  }, /*#__PURE__*/React.createElement(NotificationContainer, null, transition(function (_ref5, notification) {
    var offset = _ref5.offset,
        style = _objectWithoutProperties(_ref5, _excluded);

    return /*#__PURE__*/React.createElement(AnimatedNotificationBox, {
      style: _objectSpread(_objectSpread({}, style), {}, {
        transform: to(offset, function (x) {
          return "translateX(".concat(x, "px)");
        })
      })
    }, /*#__PURE__*/React.createElement(NotificationContent, {
      ref: function ref(_ref6) {
        if (_ref6) {
          refMap.current.set(notification.key, _ref6);
        }
      }
    }, notification.icon && /*#__PURE__*/React.createElement(Flex, {
      alignItems: "center",
      pl: "3",
      py: "0"
    }, notification.icon), /*#__PURE__*/React.createElement(Box, {
      flex: "auto",
      pl: "3",
      py: "3"
    }, notification.content), /*#__PURE__*/React.createElement(Flex, {
      alignItems: "center",
      p: "3",
      style: {
        cursor: 'pointer'
      },
      onClick: function onClick() {
        if (cancelMap.current.has(notification.key)) {
          var _cancelMap$current$ge4;

          (_cancelMap$current$ge4 = cancelMap.current.get(notification.key)) === null || _cancelMap$current$ge4 === void 0 ? void 0 : _cancelMap$current$ge4();
        }
      }
    }, /*#__PURE__*/React.createElement(Icon, {
      type: MdClose,
      fill: "light",
      size: "16",
      role: "button",
      cursor: "pointer"
    }))));
  })));
};

export default HooksNotification;