import React, { createContext, useRef } from 'react';
import { tuplify } from '../utils';
import HooksNotification from './HooksNotification';
var defaultTrigger = {
  open: function open() {
    return tuplify(Promise.resolve(false), function () {});
  },
  close: function close() {},
  destroy: function destroy() {}
};
var HooksNotificationContext = /*#__PURE__*/createContext({
  current: defaultTrigger
});
HooksNotificationContext.displayName = 'HooksNotificationContext';

var HooksNotificationProvider = function HooksNotificationProvider(_ref) {
  var children = _ref.children;
  var notificationTriggerRef = useRef(defaultTrigger);
  return /*#__PURE__*/React.createElement(HooksNotificationContext.Provider, {
    value: notificationTriggerRef
  }, children, /*#__PURE__*/React.createElement(HooksNotification, {
    triggerRef: notificationTriggerRef
  }));
};

export { HooksNotificationContext, HooksNotificationProvider };