import React, { useCallback, useContext } from 'react';
import { HooksNotificationContext } from './HooksNotificationProvider';

var useNotification = function useNotification() {
  var triggerRef = useContext(HooksNotificationContext);
  var open = useCallback(function (_ref) {
    var key = _ref.key,
        icon = _ref.icon,
        content = _ref.content,
        _ref$duration = _ref.duration,
        duration = _ref$duration === void 0 ? Infinity : _ref$duration;
    return triggerRef.current.open({
      key: key,
      icon: icon,
      content: content,
      duration: duration
    });
  }, [triggerRef]);
  var close = useCallback(function (key) {
    return triggerRef.current.close(key);
  }, [triggerRef]);
  var destroy = useCallback(function () {
    return triggerRef.current.destroy();
  }, [triggerRef]);
  return {
    open: open,
    close: close,
    destroy: destroy
  };
};

export { useNotification };