export interface BreakpointsType {
    /**
     * 576px
     */
    0: string;
    /**
     * 768px
     */
    1: string;
    /**
     * 992px
     */
    2: string;
    /**
     * 1200px
     */
    3: string;
}
export interface SpaceType {
    /**
     * 0px
     */
    0: string;
    /**
     * 4px
     */
    1: string;
    /**
     * 8px
     */
    2: string;
    /**
     * 16px
     */
    3: string;
    /**
     * 32px
     */
    4: string;
    /**
     * 64px
     */
    5: string;
    /**
     * 128px
     */
    6: string;
    /**
     * 256px
     */
    7: string;
}
export interface PaddingsType {
    /**
     * 8px
     */
    xs: string;
    /**
     * 12px
     */
    sm: string;
    /**
     * 16px
     */
    md: string;
    /**
     * 24px
     */
    lg: string;
}
export interface HeightsType {
    /**
     * 28px
     */
    sm: string;
    /**
     * 36px
     */
    base: string;
    /**
     * 44px
     */
    lg: string;
}
interface FontSizeType {
    /**
     * 14px
     */
    sm: string;
    /**
     * 16px
     */
    base: string;
    /**
     * 18px
     */
    lg: string;
}
export interface RadiiType {
    /**
     * 2px
     */
    sm: string;
    /**
     * 4px
     */
    base: string;
    /**
     * 8px
     */
    lg: string;
    /**
     * 16px
     */
    xl: string;
}
export interface BordersType {
    /**
     * 1px solid
     */
    base: string;
    /**
     * 2px solid
     */
    lg: string;
    /**
     * 1px dashed
     */
    dashed: string;
}
export interface ShadowsType {
    /**
     * 0 1px 3px 0 #e0e0e0
     */
    sm: string;
    /**
     * 0 2px 4px 0 #e0e0e0
     */
    base: string;
    /**
     * 0 2px 6px 0 #e0e0e0
     */
    lg: string;
    /**
     * 0 5px 10px 0 #e0e0e0
     */
    xl: string;
}
export declare const theme: {
    breakpoints: BreakpointsType;
    colors: {
        primary: string;
        primaryLight: string;
        primaryLight2: string;
        primaryDark: string;
        primaryDark2: string;
        secondary: string;
        secondaryLight: string;
        secondaryDark: string;
        surface: string;
        surface2: string;
        dark: string;
        light: string;
        gray100: string;
        gray200: string;
        gray300: string;
        gray400: string;
        gray500: string;
        gray600: string;
        gray700: string;
        gray800: string;
        success: string;
        danger: string;
        warning: string;
        info: string;
        error: string;
    };
    space: SpaceType;
    paddings: PaddingsType;
    heights: HeightsType;
    fontSizes: FontSizeType;
    radii: RadiiType;
    borders: BordersType;
    shadows: ShadowsType;
    lineHeight: number;
    transition: string;
};
export declare const darkerTheme: {
    breakpoints: BreakpointsType;
    colors: {
        primary: string;
        primaryDark: string;
        primaryDark2: string;
        primaryLight: string;
        primaryLight2: string;
        secondary: string;
        secondaryLight: string;
        secondaryDark: string;
        surface: string;
        surface2: string;
        dark: string;
        light: string;
        gray100: string;
        gray200: string;
        gray300: string;
        gray400: string;
        gray500: string;
        gray600: string;
        gray700: string;
        gray800: string;
        success: string;
        danger: string;
        warning: string;
        info: string;
        error: string;
    };
    space: SpaceType;
    paddings: PaddingsType;
    heights: HeightsType;
    fontSizes: FontSizeType;
    radii: RadiiType;
    borders: BordersType;
    shadows: ShadowsType;
    lineHeight: number;
    transition: string;
};
export declare type ThemeType = typeof theme;
export {};
