'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var _objectSpread = require('@babel/runtime/helpers/objectSpread2');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e['default'] : e; }

var _objectSpread__default = /*#__PURE__*/_interopDefaultLegacy(_objectSpread);

// https://github.com/renatorib/react-powerplug/blob/master/src/utils/composeEvents.js
var mergeEventProps = function mergeEventProps() {
  for (var _len = arguments.length, objEvents = new Array(_len), _key = 0; _key < _len; _key++) {
    objEvents[_key] = arguments[_key];
  }

  return objEvents.reduce(function (allEvents, events) {
    var append = {};
    Object.keys(events).forEach(function (key) {
      append[key] = allEvents[key] ? // Already have this event: let's merge
      function () {
        events[key].apply(events, arguments);
        allEvents[key].apply(allEvents, arguments);
      } : // Don't have this event yet: just assign the event
      events[key];
    });
    return _objectSpread__default(_objectSpread__default({}, allEvents), append);
  });
};

// Reference: https://github.com/segmentio/evergreen/blob/master/src/lib/prevent-body-scroll.js
// eslint-disable-next-line import/no-mutable-exports
exports.previousOverflow = void 0; // eslint-disable-next-line import/no-mutable-exports

exports.previousPaddingRight = void 0;
/**
 * Toggle the body scroll / overflow and additional styling
 * necessary to preserve scroll position and body width (scrollbar replacement)
 *
 * @param {boolean} preventScroll - whether or not to prevent body scrolling
 */

var preventBodyScroll = function preventBodyScroll(preventScroll) {
  var _document$body$getBou = document.body.getBoundingClientRect(),
      width = _document$body$getBou.width;
  /** Apply or remove overflow style */


  if (preventScroll) {
    exports.previousOverflow = document.body.style.overflow || '';
    document.body.style.overflow = 'hidden';
  } else {
    document.body.style.overflow = exports.previousOverflow || '';
  }
  /** Get the _new width_ of the body (this will tell us the scrollbar width) */


  var newWidth = document.body.getBoundingClientRect().width;
  var scrollBarWidth = newWidth - width;
  /** If there's a diff due to scrollbars, then account for it with padding */

  if (preventScroll) {
    exports.previousPaddingRight = document.body.style.paddingRight || '';
    document.body.style.paddingRight = "".concat(Math.max(0, scrollBarWidth || 0), "px");
  } else {
    document.body.style.paddingRight = exports.previousPaddingRight || '';
  }
};

function tuplify() {
  for (var _len = arguments.length, elements = new Array(_len), _key = 0; _key < _len; _key++) {
    elements[_key] = arguments[_key];
  }

  return elements;
}

exports.mergeEventProps = mergeEventProps;
exports.preventBodyScroll = preventBodyScroll;
exports.tuplify = tuplify;
//# sourceMappingURL=index.cjs.js.map
